local TracerName, TracerData = ...

TracerData.CurrenciesInfos = {
	--DF
	{2003, " ", "DF", false},	--Fournitures des îles aux Dragons
	{2118, " ", "DF", false},	--Débordement élémentaire
	{1191, " ", "DF", false},	--Points de vaillance
	{2122, " ", "DF", false},
	--SL
	{1754, " ", "SL", false},	--Récompense d'argent (pré-patch)
	{1828, " ", "SL", false},	--Cendre d'âme	
	{1813, " ", "SL", false},	--Anima du réservoir
	{1820, " ", "SL", false},	--Rubis infusé
	{1767, " ", "SL", false},	--Stygie
	{1885, " ", "SL", false},	--Offrande reconnaissante
	{1977, " ", "SL", false},	--Braise stygienne	
	{1906, " ", "SL", false},	--Scories d'âme	
	{1931, " ", "SL", false},	--Trouvailles cataloguées
	{1979, " ", "SL", false},	--Cryptogrammes des Fondateurs
	{2009, " ", "SL", false},	--Flux cosmique
	{1904, " ", "SL", false},	--Savoir de la tour	
	--BfA (10)
	{1560, " ", "BfA", false},	--Ressources de guerre
	{1580, " ", "BfA", false},	--Sceau du destin érodé	
	{1710, " ", "BfA", false},	--Doubon marins
	{1716, " ", "BfA", false},	--Médaille de service de la Brigade de l'Honneur	
	{1717, " ", "BfA", false},	--Médaille de service de la 7e Legion
	{1718, " ", "BfA", false},	--Résidus des Titans
	{1721, " ", "BfA", false},	--Perles de mana prismatique
	{1755, " ", "BfA", false},	--Visions coalescentes
	{1719, " ", "BfA", false},	--Corrupted Mementos
	{1803, " ", "BfA", false},	--Echoes of Ny'alotha	
	--Legion (17)
	{1149, " ", "Legion", false},	-- Oeil clos
	{1154, " ", "Legion", false}, 	-- Pièces ténébreuses	
	{1155, " ", "Legion", false},	-- Mana ancestral
	{1220, " ", "Legion", false},	-- Ressources de domaine
	{1226, " ", "Legion", false},	-- Éclat de Néant
	{1268, " ", "Legion", false},	-- Artéfact érodé	
	{1273, " ", "Legion", false},	-- Sceau du destin brisé
	{1275, " ", "Legion", false},	-- Pièce curieuse
	{1314, " ", "Legion", false},	-- Fragment d'âme rémanente
	{1342, " ", "Legion", false},	-- Fournitures de guerre du Déclin
	{1355, " ", "Legion", false},	-- Essence gangrenée	
	{1356, " ", "Legion", false},	-- Échos de bataille
	{1357, " ", "Legion", false},	-- Échos de domination	
	{1416, " ", "Legion", false},	-- Pièces d'air	
	{1501, " ", "Legion", false},	-- Essence fréissante
	{1508, " ", "Legion", false},	-- Argunite voilée
	{1533, " ", "Legion", false},	-- Essence d'éveil
	--WoD (7)
	{823, " ", "WoD", false},	-- Cristal apogide
	{994, " ", "WoD", false},	-- Sceau du destin trempé
	{824, " ", "WoD", false},	-- Ressources de fief
	{1101, " ", "WoD", false},	-- Carburant
	{944, " ", "WoD", false},	-- Fragment d'artéfact
	{980, " ", "WoD", false},	-- Pièces de fer ternies
	{1129, " ", "WoD", false},	-- Sceau du destin inévitable
	--Divers (5)
	{515, " ", "Divers", false},	--Bons de Sombrelune	
	{1166, " ", "Divers", false},	--Insignes distordu dans le temps
	{1299, " ", "Divers", false},	--Or des bastonneurs
	{1602, " ", "Divers", false},	--Point de conquête
	{1585, " ", "Divers", false},	--Honneur	
	};
local SealQuests = {
	["BfA"] = {52835, 52839, 52834, 52838, 52837, 52840}
	};

function TracerData.Function:WindowCreateCurrencies()
	--DB
	--Nom des monnaies
	for index, value in ipairs(TracerData.CurrenciesInfos) do
		value[2] = C_CurrencyInfo.GetCurrencyInfo(value[1])["name"];
	end
	
	--Ordre alphabétique
	local t1 = {};
	for index, value in ipairs(TracerData.CurrenciesInfos) do
		t1[index] = value[2]
	end
	table.sort(t1);		
	local t2 = {};
	for index, value in ipairs(t1) do
		for index1, value1 in ipairs(TracerData.CurrenciesInfos) do
			if value == value1[2] then
				t2[index] = value1;
			end
		end
	end
	TracerDB.Currencies = t2;
	
	--Informations pour la création de la catégorie
	local headername = TracerData.L.Headers[4];
	TracerDB.ListLine[4] = {};
	for index, value in ipairs(TracerDB.Currencies) do
		TracerDB.ListLine[4][index] = value[2]
	end	
	--Création de la catégorie
	TracerData.Function:WindowCreate(4, headername);

	--Copie des DisplayLine
	for index, value in ipairs(TracerDB.Currencies) do
		TracerDB.Options.DisplayLine[4][index][1] = value[4];
	end	

	--Affichage
	TracerData.Function:WindowUpdateCurrencies();

	if not TracerDB.Toons[TracerData.thisToon]["Display"] then return end
	
	--Gestion Monnaies
	TracerData.Headers[4]:RegisterEvent("PLAYER_ENTERING_WORLD");
	TracerData.Headers[4]:RegisterEvent("CURRENCY_DISPLAY_UPDATE");
	TracerData.Headers[4]:RegisterEvent("CHAT_MSG_CURRENCY");	
	TracerData.Headers[4]:SetScript("OnEvent", function(_, event) 
		TracerData.Function:UpdateCurrencies();
	end)
end

function TracerData.Function:WindowUpdateCurrencies()
	for index, value in ipairs(TracerData.ListToons) do
		for i = 1, #TracerDB.ListLine[4] , 1 do
			for key1, value1 in pairs(TracerDB.Toons) do	--On va chercher les informations pour le bon Toon				
				if value == key1 then
					TracerData.Lines[4]["Toon"..index][i]["Title"]:SetTextColor(value1.ClassColor.r, value1.ClassColor.g, value1.ClassColor.b, 1);
					if TracerDB.Currencies[i][1] ~= 1580 or (value1.Level < 50) or (value1.Quests.BfA.Seal == 2) then
						local currentAmount = value1.Currencies[TracerDB.Currencies[i][1]]
						--Affichage de la valeur en ..k 						
						if currentAmount > 10000 then
							currentAmount = tostring(math.floor(currentAmount/1000));
							currentAmount = currentAmount.." k"
						end						
						TracerData.Lines[4]["Toon"..index][i]["Title"]:SetText(currentAmount);
					else
						TracerData.Lines[4]["Toon"..index][i]["Title"]:SetText(value1.Currencies[TracerDB.Currencies[i][1]].." ("..value1.Quests.BfA.Seal.."/2)");
					end
				end
			end
		end
	end
end

function TracerData.Function:UpdateCurrencies()
	local numline = 0;	
	for index, value in ipairs(TracerDB.Currencies) do
		local currencyinfos = C_CurrencyInfo.GetCurrencyInfo(value[1]);
		TracerDB.Toons[TracerData.thisToon]["Currencies"][value[1]] = currencyinfos.quantity;		
		if value[1] == 1580 then	--Sceau BfA
			--Compter le nombre de quêtes de sceaux effectuées
			local count = 0;
			for index, value in ipairs(SealQuests["BfA"]) do
				if C_QuestLog.IsQuestFlaggedCompleted(value) then
					count = count + 1;
				end
				TracerDB.Toons[TracerData.thisToon]["Quests"]["BfA"]["Seal"] = count;
			end
			--Trouver la bonne ligne (ordre alphabétique, donc suivant la langue)
			numline = 0;
			for index, value in ipairs(TracerDB.Currencies) do
				if value[1] == 1580 then
					numline = index;
				end
			end
			--Mise à jour de la ligne
			if (count == 2) or (TracerDB.Toons[TracerData.thisToon]["Level"] < 50 )then
				TracerData.Lines[4]["Toon"..TracerData.numthisToon][numline]["Title"]:SetText(currencyinfos.quantity);
			else
				TracerData.Lines[4]["Toon"..TracerData.numthisToon][numline]["Title"]:SetText(currencyinfos.quantity.." ("..count.."/2)");
			end			
		else	
			--Affichage du texte
			if currencyinfos.quantity > 10000 then
				currencyinfos.quantity = tostring(math.floor(currencyinfos.quantity/1000));
				currencyinfos.quantity = currencyinfos.quantity.." k"
			end
			TracerData.Lines[4]["Toon"..TracerData.numthisToon][index]["Title"]:SetText(currencyinfos.quantity);
		end
	end
end
