local TracerName, TracerData = ...

local CurrentDarkmoon = 0;

function TracerData.Function:WindowCreateDarkmoonFaire1()
	TracerDB.ListLine[8] = {};
	local namecurrencie = C_CurrencyInfo.GetCurrencyInfo(515)["name"];
	
	--Détection de l'évènement
	local Date = date("*t");
	--TracerDB.listlineglobal = Date;	
	local begindarkmoon = 0;		--premier jour de la foire
	local enddarkmoon = 0;	--dernier jour de la foire
	local offset = {
		["1"] = 0,	--Sunday		
		["2"] = 1,	--Monday
		["3"] = 2,	--Tuesday
		["4"] = 3,	--Wednesday
		["5"] = 4,	--Thursday
		["6"] = 5,	--Friday
		["7"] = 6,	--Saturday
		};
	if Date.day <= 13 then
		begindarkmoon = Date.day - offset[tostring(Date.wday)];	
		if begindarkmoon >= 8 then 
			begindarkmoon = begindarkmoon - 7;
		end
		if begindarkmoon >= 1 then		
			enddarkmoon = begindarkmoon + 6;
			if (Date.day >= begindarkmoon) and (Date.day <= enddarkmoon) then
				CurrentDarkmoon = 1;
				print("Tracer : "..TracerData.L["Foire de Sombrelune disponible"]);
				TracerDB.ListLine[8] = {
					TracerData.L["Quêtes journalières"],
					TracerData.L["Quêtes de métiers"],
					TracerData.L["Quêtes Artéfacts ou Boss"],
					namecurrencie;
					};
			end
		end
	end 
	
	--Arrêt de la fonction s'il n'y a pas d'évènement
	if CurrentDarkmoon == 0 then 
		return
	else
		TracerData.Function:WindowCreateDarkmoonFaire2();	
	end
end

function TracerData.Function:WindowCreateDarkmoonFaire2()
	--DB
	TracerData.DarkmoonInfos.Daily = {		
		{questId = 29436, name = TracerData.L.Darkmoon.Daily[29436]}, --"Le boulet de canon humanoïde"
		{questId = 29463, name = TracerData.L.Darkmoon.Daily[29463]}, --"Il est temps de cogner"	
		{questId = 29438, name = TracerData.L.Darkmoon.Daily[29438]}, --"Il tire et... il marque"
		{questId = 36481, name = TracerData.L.Darkmoon.Daily[36481]}, --"Défi de l'Oiseau de feu"
		{questId = 29434, name = TracerData.L.Darkmoon.Daily[29434]}, --"Commandant de chariotte"
		{questId = 29455, name = TracerData.L.Darkmoon.Daily[29455]}, --"Cible : Tortue"
		{questId = 37910, name = TracerData.L.Darkmoon.Daily[37910]}, --"La course folle"
		{questId = 37911, name = TracerData.L.Darkmoon.Daily[37911]}, --"La grande course folle"
		{questId = 32175, name = TracerData.L.Darkmoon.Daily[32175]}, --"Combat de mascotte de Sombrelune"			
		{questId = 36471, name = TracerData.L.Darkmoon.Daily[36471]}, --"Un nouvel adversaire à Sombrelune"			
		};
	TracerData.DarkmoonInfos.Items = {
		{questId = 29433, name = TracerData.L.Darkmoon.Items[29433]}, --"Testez votre force"
		{questId = 33354, name = TracerData.L.Darkmoon.Items[33354]}, --"Croc-de-Lune (Boss)"	
		{questId = 29443, name = TracerData.L.Darkmoon.Items[29443]}, --"Un étrange cristal"
		{questId = 29444, name = TracerData.L.Darkmoon.Items[29444]}, --"Un oeuf exotique"
		{questId = 29445, name = TracerData.L.Darkmoon.Items[29445]}, --"Un grimoire fascinant"
		{questId = 29446, name = TracerData.L.Darkmoon.Items[29446]}, --"Une arme extraordinaire"
		{questId = 29464, name = TracerData.L.Darkmoon.Items[29464]}, --"Outils de divination"
		{questId = 29451, name = TracerData.L.Darkmoon.Items[29451]}, --"Le maître stratège"
		{questId = 29458, name = TracerData.L.Darkmoon.Items[29458]}, --"Journal d'aventurier défunt (JcJ)"
		{questId = 29456, name = TracerData.L.Darkmoon.Items[29456]}, --"Une bannière capturée (JcJ)"
		{questId = 29457, name = TracerData.L.Darkmoon.Items[29457]}, --"L'insigne de l'ennemi (JcJ)"
		};
		
	--Informations pour la création de la catégorie
	local headername = TracerData.L.Headers[8];
	
	--Création de la catégorie
	TracerData.Function:WindowCreate(8, headername);
	TracerDB.Options.DisplayHeader[8] = true;
	TracerDB.Options.Custom.DisplayHeader[8] = true;
	
	local count = 0;
	--Affichage
	for index, value in ipairs(TracerData.ListToons) do
		for i = 1, #TracerDB.ListLine[8] , 1 do
			for key1, value1 in pairs(TracerDB.Toons) do	--On va chercher les informations pour le bon Toon				
				if value == key1 then
					TracerData.Lines[8]["Toon"..index][i]["Title"]:SetTextColor(value1.ClassColor.r, value1.ClassColor.g, value1.ClassColor.b, 1);
					--Quêtes journalières
					if i == 1 then
						for index2, value2 in ipairs(value1.Quests.Darkmoon.Daily) do
							if value2 == 1 then
								count = count +1 ;
							end
						end
						if count == #TracerData.DarkmoonInfos.Daily then
							TracerData.Lines[8]["Toon"..index][i]["Texture2"]:SetTexture("Interface\\AddOns\\Tracer\\Fonts\\SquareGreen");
							TracerData.Lines[8]["Toon"..index][i]:SetText(nil);						
						else
							TracerData.Lines[8]["Toon"..index][i]["Title"]:SetText(count.."/"..#value1.Quests.Darkmoon.Daily);						
						end
					end
					--Quêtes métiers
					if i == 2 then
						for index2, value2 in ipairs(value1.Quests.Darkmoon.Job) do
							if value2 == 1 then
								count = count +1 ;
							end
						end
						if count == 5 then
							TracerData.Lines[8]["Toon"..index][i]["Texture2"]:SetTexture("Interface\\AddOns\\Tracer\\Fonts\\SquareGreen");
							TracerData.Lines[8]["Toon"..index][i]["Title"]:SetText(nil);						
						else
							TracerData.Lines[8]["Toon"..index][i]["Title"]:SetText(count.."/"..#value1.Quests.Darkmoon.Job);						
						end
					end
					--Quêtes artéfacts ou boss
					if i == 3 then
						for index2, value2 in ipairs(value1.Quests.Darkmoon.Items) do
							if value2 == 1 then
								count = count +1 ;
							end
						end
						if count == #TracerData.DarkmoonInfos.Items then
							TracerData.Lines[8]["Toon"..index][i]["Texture2"]:SetTexture("Interface\\AddOns\\Tracer\\Fonts\\SquareGreen");
							TracerData.Lines[8]["Toon"..index][i]["Title"]:SetText(nil);						
						else
							TracerData.Lines[8]["Toon"..index][i]["Title"]:SetText(count.."/"..#value1.Quests.Darkmoon.Items);						
						end
					end	
					--Monnaie
					if i == 4 then
						TracerData.Lines[8]["Toon"..index][i]["Title"]:SetText(TracerDB.Toons[value]["Currencies"][515]);
					end
					count = 0;					
				end
			end
		end
	end

	--Tooltip pour les quêtes de la foire
	for index1, value1 in ipairs(TracerData.ListToons) do
		for index2, value2 in ipairs(TracerDB.ListLine[8]) do	
			TracerData.Lines[8]["Toon"..index1][index2]:SetScript("OnEnter", function()
				TracerData.Function:DarkmoonTooltip(value1, index2);
			end);
			TracerData.Lines[8]["Toon"..index1][index2]:SetScript("OnLeave", function()
				GameTooltip:Hide();
			end);
		end
	end	
	
	if not TracerDB.Toons[TracerData.thisToon]["Display"] then return end	
	
	--Gestion de l'état
	TracerData.Lines[8][1]:RegisterEvent("QUEST_LOG_UPDATE");
	TracerData.Lines[8][1]:RegisterEvent("QUEST_TURNED_IN");
	TracerData.Lines[8][1]:RegisterEvent("CURRENCY_DISPLAY_UPDATE");
	TracerData.Lines[8][1]:RegisterEvent("CHAT_MSG_CURRENCY");	
	TracerData.Lines[8][1]:SetScript("OnEvent", function(_, event) 
		if (event == "QUEST_LOG_UPDATE") or (event == "QUEST_TURNED_IN") then
			C_Timer.After(5, function() TracerData.Function:DarkmoonQuestsChecking() end);
		elseif event == ("CURRENCY_DISPLAY_UPDATE") or event == ("CHAT_MSG_CURRENCY") then
			TracerData.Lines[8]["Toon"..TracerData.numthisToon][4]["Title"]:SetText(TracerDB.Toons[TracerData.thisToon]["Currencies"][515]);
		end
		end)
	
	--Premier checking
	TracerData.Function:DarkmoonQuestsChecking();	
end

function TracerData.Function:DarkmoonQuestsChecking()
	--Daily
	for index, value in ipairs(TracerData.DarkmoonInfos.Daily) do
		if C_QuestLog.IsQuestFlaggedCompleted(value.questId) then
			TracerDB.Toons[TracerData.thisToon]["Quests"]["Darkmoon"]["Daily"][index] = 1;
		else
			TracerDB.Toons[TracerData.thisToon]["Quests"]["Darkmoon"]["Daily"][index] = 0;		
		end
	end
	--Job
	local jobquestId = {
		TracerData.DarkmoonInfos.Job[TracerDB.Toons[TracerData.thisToon]["Job"][1]],
		TracerData.DarkmoonInfos.Job[TracerDB.Toons[TracerData.thisToon]["Job"][2]],
		TracerData.DarkmoonInfos.Job[TracerDB.Toons[TracerData.thisToon]["Job"][3]],		
		TracerData.DarkmoonInfos.Job[TracerDB.Toons[TracerData.thisToon]["Job"][4]],		
		TracerData.DarkmoonInfos.Job[TracerDB.Toons[TracerData.thisToon]["Job"][5]],		
		}
	for index, value in ipairs(jobquestId) do
		if value then
			if C_QuestLog.IsQuestFlaggedCompleted(value["questId"]) then
				TracerDB.Toons[TracerData.thisToon]["Quests"]["Darkmoon"]["Job"][index] = 1;
			else
				TracerDB.Toons[TracerData.thisToon]["Quests"]["Darkmoon"]["Job"][index] = 0;		
			end		
		end
	end
	--Artéfacts ou Boss
	for index, value in ipairs(TracerData.DarkmoonInfos.Items) do
		if C_QuestLog.IsQuestFlaggedCompleted(value.questId) then
			TracerDB.Toons[TracerData.thisToon]["Quests"]["Darkmoon"]["Items"][index] = 1;
		else
			TracerDB.Toons[TracerData.thisToon]["Quests"]["Darkmoon"]["Items"][index] = 0;		
		end
	end
	
	--Affichage
	local count = 0;
	--Quêtes journalières
	for index, value in ipairs(TracerDB.Toons[TracerData.thisToon]["Quests"]["Darkmoon"]["Daily"]) do
		if value == 1 then
			count = count +1 ;
		end
	end
	if count == #TracerDB.Toons[TracerData.thisToon]["Quests"]["Darkmoon"]["Daily"] then
		TracerData.Lines[8]["Toon"..TracerData.numthisToon][1]["Texture2"]:SetTexture("Interface\\AddOns\\Tracer\\Fonts\\SquareGreen");
		TracerData.Lines[8]["Toon"..TracerData.numthisToon][1]["Title"]:SetText(nil);						
	else
		TracerData.Lines[8]["Toon"..TracerData.numthisToon][1]["Texture2"]:SetTexture(nil);
		TracerData.Lines[8]["Toon"..TracerData.numthisToon][1]["Title"]:SetText(count.."/"..#TracerDB.Toons[TracerData.thisToon]["Quests"]["Darkmoon"]["Daily"]);						
	end
	count = 0;	
	--Quêtes métiers
	for index, value in ipairs(TracerDB.Toons[TracerData.thisToon]["Quests"]["Darkmoon"]["Job"]) do
		if value == 1 then
			count = count +1 ;
		end
	end
	if count == #TracerDB.Toons[TracerData.thisToon]["Quests"]["Darkmoon"]["Job"] then
		TracerData.Lines[8]["Toon"..TracerData.numthisToon][2]["Texture2"]:SetTexture("Interface\\AddOns\\Tracer\\Fonts\\SquareGreen");
		TracerData.Lines[8]["Toon"..TracerData.numthisToon][2]["Title"]:SetText(nil);						
	else
		TracerData.Lines[8]["Toon"..TracerData.numthisToon][2]["Texture2"]:SetTexture(nil);
		TracerData.Lines[8]["Toon"..TracerData.numthisToon][2]["Title"]:SetText(count.."/"..#TracerDB.Toons[TracerData.thisToon]["Quests"]["Darkmoon"]["Job"]);						
	end	
	count = 0;	
	--Quêtes artéfacts ou boss
	for index, value in ipairs(TracerDB.Toons[TracerData.thisToon]["Quests"]["Darkmoon"]["Items"]) do
		if value == 1 then
			count = count +1 ;
		end
	end
	if count == #TracerDB.Toons[TracerData.thisToon]["Quests"]["Darkmoon"]["Items"] then
		TracerData.Lines[8]["Toon"..TracerData.numthisToon][3]["Texture2"]:SetTexture("Interface\\AddOns\\Tracer\\Fonts\\SquareGreen");
		TracerData.Lines[8]["Toon"..TracerData.numthisToon][3]["Title"]:SetText(nil);						
	else
		TracerData.Lines[8]["Toon"..TracerData.numthisToon][3]["Texture2"]:SetTexture(nil);
		TracerData.Lines[8]["Toon"..TracerData.numthisToon][3]["Title"]:SetText(count.."/"..#TracerDB.Toons[TracerData.thisToon]["Quests"]["Darkmoon"]["Items"]);						
	end	
end

function TracerData.Function:DarkmoonTooltip(toon, line)
	local r, g, b = TracerDB.Toons[toon]["ClassColor"]["r"], TracerDB.Toons[toon]["ClassColor"]["g"], TracerDB.Toons[toon]["ClassColor"]["b"]
	local count = 0;
	
    GameTooltip:Hide();
	GameTooltip:SetOwner(UIParent, "ANCHOR_CURSOR");
	
	--Daily (Line 1)
	if line == 1 then
		for index, value in ipairs(TracerDB.Toons[toon]["Quests"]["Darkmoon"]["Daily"]) do
			if value == 1 then
				count = count +1 ;
			end
		end	
		GameTooltip:AddDoubleLine(TracerDB.Toons[toon]["Name"], count.."/"..#TracerDB.Toons[toon]["Quests"]["Darkmoon"]["Daily"], r, g, b, r, g, b);
		for index, value in ipairs(TracerDB.Toons[toon]["Quests"]["Darkmoon"]["Daily"])	do
			if value == 1 then
				GameTooltip:AddLine(TracerData.DarkmoonInfos.Daily[index]["name"], 0, 1, 0);
			else
				GameTooltip:AddLine(TracerData.DarkmoonInfos.Daily[index]["name"], 1, 0, 0);
			end
		end	
	end
	--Job (Line 2)
	if line == 2 then
		for index, value in ipairs(TracerDB.Toons[toon]["Quests"]["Darkmoon"]["Job"]) do
			if value == 1 then
				count = count +1 ;
			end
		end	
		GameTooltip:AddDoubleLine(TracerDB.Toons[toon]["Name"], count.."/"..#TracerDB.Toons[toon]["Quests"]["Darkmoon"]["Job"], r, g, b, r, g, b);
		for index, value in ipairs(TracerDB.Toons[toon]["Quests"]["Darkmoon"]["Job"])	do
			if value == 1 then
				GameTooltip:AddLine(TracerData.DarkmoonInfos.Job[TracerDB.Toons[toon]["Job"][index]]["name"], 0, 1, 0);
			elseif TracerDB.Toons[toon]["Job"][index] then
				GameTooltip:AddLine(TracerData.DarkmoonInfos.Job[TracerDB.Toons[toon]["Job"][index]]["name"], 1, 0, 0);
			end
		end	
	end	
	--Daily (Line 3)
	if line == 3 then
		for index, value in ipairs(TracerDB.Toons[toon]["Quests"]["Darkmoon"]["Items"]) do
			if value == 1 then
				count = count +1 ;
			end
		end	
		GameTooltip:AddDoubleLine(TracerDB.Toons[toon]["Name"], count.."/"..#TracerDB.Toons[toon]["Quests"]["Darkmoon"]["Items"], r, g, b, r, g, b);
		for index, value in ipairs(TracerDB.Toons[toon]["Quests"]["Darkmoon"]["Items"])	do
			if value == 1 then
				GameTooltip:AddLine(TracerData.DarkmoonInfos.Items[index]["name"], 0, 1, 0);
			else
				GameTooltip:AddLine(TracerData.DarkmoonInfos.Items[index]["name"], 1, 0, 0);
			end
		end	
	end
	
	GameTooltip:Show();
end



