local TracerName, TracerData = ...

TracerData.Lines = {};		--Lines
TracerData.Headers = {};	--Headers
TracerData.Function = {};	--Fonctions	
TracerData.Options = {};	--Données de configuration
TracerData.Buttons = {};	--Buttons
TracerData.CB = {};			--CheckButton
TracerData.DDM = {};		--DropDownMenu
TracerData.version = 5.15;	--Version de l'addon
TracerData.windowsorder = {	--Ordre des catégories
	1,	--Informations générales (IG)
	13, --Dragonflight (DG)
	9,	--Shadowlands (SL)		
	2,	--Battle for Azeroth (BfA)
	3,	--Legion (L)
	10, --PVP (PVP)	
	4,	--Monnaies (C)
	5,	--Réputations (RE)
	6,	--Vérouilliage de raid (R)
	11,	--Timewalking (TD)
	7,	--Evènement hebdomadaire (EH)
	8,	--Foire de sombrelune (FS)
	12, --World Event : Love Is In The Air
	};
TracerData.L = {};			--Locals
TracerData.ListToons = {}; --Liste dans l'ordre des Toons à afficher
TracerData.DarkmoonInfos = {};	--Infos pour la foire de sombrelune
TracerData.ToonPanel = {};	--Objets pour la fenêtre du Toon
TracerData.QualityColor = {
	{1, 1, 1, 1},			--Commun	
	{0.12, 1, 0, 1},		--Pas commun
	{0, 0.44, 0.87, 1},		--Rare
	{0.64, 0.21, 0.93, 1},	--Epique
	{1, 0.5, 0, 1},			--Légendaire
	{0.9, 0.8, 0.5, 1},		--Artéfact
	{0, 0.8, 1, 1},			--Héritage
	{0, 0.8, 1, 1},			--WOW Token	
	};
TracerData.TextColor = {
	{0.62, 0.17, 0.93, 1},	--Violet (nom de clé)		
	{1, 0.82, 0, 1},	--Jaune tooltip
	};
TracerData.CharactersLimit = 50;	--Limite de personnages de l'addon

--Informations sur le Toons connecté
TracerData.thisToon = UnitName("player") .. " - " .. GetRealmName(); --Récupère ex : "Grøkar - Elune"
TracerData.numthisToon = 0;

local rheader, gheader, bheader, theader = 0.63, 0.63, 0.63, 0.5;	--Couleur header
local rwindow, gwindow, bwindow, twindow = 0, 0, 0, 0.8;			--Couleur fond catégories
local ToonsFrameCount = 0;
-------------------------------------------------------------------------------------------------------------
----------------- Slash Command -----------------------------------------------------------------------------
-------------------------------------------------------------------------------------------------------------

local TracerCommandTable = {
	["toggle"] = function()
		TracerData.Function:TracerToggle();
		end,		
	["reset"] = function()
		TracerDB.Options.addonreset = 1;
		ReloadUI();
		end,
	["options"] = function()
		TracerData.Function:OptionsTracer();
		end,
	["minimap"] = function()
		if TracerDB.Options.minimap then
			TracerDB.Options.minimap = false;
			LibStub("LibDBIcon-1.0"):Hide(TracerName)
		else
			TracerDB.Options.minimap = true;	
			LibStub("LibDBIcon-1.0"):Show(TracerName)
		end
		end,		
	["sc1"] = function()
		TracerData.Function:SlashCommand1();
		end,
	["sc2"] = function()
		TracerData.Function:SlashCommand2();
		end,
	["sc3"] = function()
		TracerData.Function:SlashCommand3();
		end,		
	["sc4"] = function()
		TracerData.Function:SlashCommand4();
		end,		
	["sc5"] = function()
		TracerData.Function:SlashCommand5();
		end,		
	["sc6"] = function()
		TracerData.Function:SlashCommand6();
		end,
	["sc7"] = function()
		TracerData.Function:SlashCommand7();
		end,		
	["sc8"] = function()
		TracerData.Function:SlashCommand8();
		end,
	["sc9"] = function()
		TracerData.Function:SlashCommand9();
		end,		
	};

function TracerData.Function:DispatchCommand(message, commandTable)
	local command, parameters = string.split(" ", message, 2)
	local entry = commandTable[command:lower()]		--retire toutes les majuscules
	local which = type(entry)
	
	if which == "function" then
		entry(parameters)
	elseif which == "table" then
		DispatchCommand(parameters or "", entry)
	elseif which == "string" then
		print(entry)
	end
end

SLASH_TRACER1 = '/tracer' ;
SlashCmdList["TRACER"] = function(msg)
	TracerData.Function:DispatchCommand(msg, TracerCommandTable);
end

--Tracer Toggle
function TracerData.Function:TracerToggle()
	if TracerData.Headers[1]:IsShown() then
		TracerData.Function:CloseTracer();
	else
		if TracerDB.Toons[TracerData.thisToon]["Display"] then
			if TracerDB.Toons[TracerData.thisToon]["Order"] <= 10 then
				TracerDB.Options.Page = 1;			
			elseif (TracerDB.Toons[TracerData.thisToon]["Order"] >= 11) and (TracerDB.Toons[TracerData.thisToon]["Order"] <= 20) then
				TracerDB.Options.Page = 2;			
			elseif (TracerDB.Toons[TracerData.thisToon]["Order"] >= 21) and (TracerDB.Toons[TracerData.thisToon]["Order"] <= 30) then
				TracerDB.Options.Page = 3;
			elseif (TracerDB.Toons[TracerData.thisToon]["Order"] >= 31) and (TracerDB.Toons[TracerData.thisToon]["Order"] <= 40) then
				TracerDB.Options.Page = 4;
			else
				TracerDB.Options.Page = 5;				
			end
			TracerData.Headers[1]:Show();
			TracerData.Function:UpdateAnchors();
		else
			TracerDB.Options.Page = 1;			
			TracerData.Headers[1]:Show();
			TracerData.Function:UpdateAnchors();			
		end
		--Actualisation
		TracerData.Function:WindowUpdateDragonflight();		
		TracerData.Function:WindowUpdateShadowlands();
		TracerData.Function:WindowUpdateBfA();
		
		TracerData.Function:WindowUpdateReputations();
		TracerData.Function:WindowUpdateCurrencies();
	end
end
--InstanceInfosData
function TracerData.Function:SlashCommand1()
	TracerDB.instancedata = {};
	for k=1, 2500, 1 do
		TracerDB.instancedata[k] = {};
		local name, typeID, subtypeID, minLevel, maxLevel, recLevel, minRecLevel, maxRecLevel, expansionLevel, groupID, textureFilename, difficulty, maxPlayers, description, isHoliday, bonusRepAmount, minPlayers, isTimeWalker, name2, minGearLevel, isScalingDungeon, lfgMapID = GetLFGDungeonInfo(k)
		if name then
			TracerDB.instancedata[k]["name"] = name;
			TracerDB.instancedata[k]["typeID"] = typeID;
			TracerDB.instancedata[k]["subtypeID"] = subtypeID;
			TracerDB.instancedata[k]["minLevel"] = minLevel;
			TracerDB.instancedata[k]["maxLevel"] = maxLevel;
			TracerDB.instancedata[k]["recLevel"] = recLevel;
			TracerDB.instancedata[k]["minRecLevel"] = minRecLevel;
			TracerDB.instancedata[k]["maxRecLevel"] = maxRecLevel;	
			TracerDB.instancedata[k]["expansionLevel"] = expansionLevel;
			TracerDB.instancedata[k]["groupID"] = groupID;
			TracerDB.instancedata[k]["textureFilename"] = textureFilename;	
			TracerDB.instancedata[k]["difficulty"] = difficulty;
			TracerDB.instancedata[k]["maxPlayers"] = maxPlayers;
			TracerDB.instancedata[k]["description"] = description;
			TracerDB.instancedata[k]["isHoliday"] = isHoliday;
			TracerDB.instancedata[k]["bonusRepAmount"] = bonusRepAmount;
			TracerDB.instancedata[k]["minPlayers"] = minPlayers;
			TracerDB.instancedata[k]["isTimeWalker"] = isTimeWalker;
			TracerDB.instancedata[k]["name2"] = name2;
			TracerDB.instancedata[k]["minGearLevel"] = minGearLevel; 	
			TracerDB.instancedata[k]["lfgMapID"] = lfgMapID;
			TracerDB.instancedata[k]["isScalingDungeon"] = isScalingDungeon;
			local numEncounters, numCompleted = GetLFGDungeonNumEncounters(k)
			for i=1, numEncounters, 1 do
				local bossName, fileDataID, isKilled, unknown4 = GetLFGDungeonEncounterInfo(k, i);
					TracerDB.instancedata[k][i] = bossName;
			end
		end
	end
end
--Liste des quêtes en QuestLog
function TracerData.Function:SlashCommand2()
	local numEntries, numQuests = C_QuestLog.GetNumQuestLogEntries();
	for i=1, numEntries do
		local title = C_QuestLog.GetTitleForLogIndex(i)
		local questID = C_QuestLog.GetQuestIDForLogIndex(i)
		if not isHeader then
			print(questID.." : "..title);
		end
	end
end
--M+ checking
function TracerData.Function:SlashCommand3()
	local t = C_ChallengeMode.GetMapTable();
	for key, value in pairs(t) do
		local durationSec, level, completionDate, affixIDs, members = C_MythicPlus.GetWeeklyBestForMap(key);
		if level then
			print(value.." : "..level);
		else
			print(value.." : XD");	
		end
		print(C_MythicPlus.GetWeeklyBestForMap(key));
	end	
end
--InstancesLockInfo
function TracerData.Function:SlashCommand4()
	TracerDB.lockinstances = TracerData.Function:GetLockInstance();
end
--Liste Donjons
function TracerData.Function:SlashCommand5()
	for i = 1, GetNumRandomDungeons() do
	  local id, name = GetLFGRandomDungeonInfo(i)
	  print(id .. ": " .. name)
	end
end
--Auras
function TracerData.Function:SlashCommand6()
	TracerDB.testauras = TracerData.Function:GetAuras();
end
--Reset Daily
function TracerData.Function:SlashCommand7()
	TracerData.Function:ResetDaily();
end
--Reset Weekly
function TracerData.Function:SlashCommand8()
	TracerData.Function:ResetWeekly();
end
--
function TracerData.Function:SlashCommand9()
	--Détection de la bonne zone
	-- local inInstance, instanceType = IsInInstance();
	-- local LfgDungeonID = 0;
	-- if inInstance and (instanceType == "scenario") then
		-- local name, _, _, _, _, _, _, _, _, LfgDungeonID  = GetInstanceInfo();
		-- local name2 = GetLFGDungeonInfo(LfgDungeonID);
		-- print("LfgDungeonID "..LfgDungeonID.." - "..name);
		-- print("MapID  "..C_Map.GetBestMapForUnit("player"));				
	-- end
	
	--Test Bag
	local bagId = {0, 1, 2, 3, 4, -1, 5, 6, 7, 8, 9, 10, 11, -3};	--0 à 4 perso, -1 banque, 5 à 11 sac de banque, -3 compo
	local numberOfSlots = 0;
	local numObject = 0;
	local containerInfo = {};
	for index, value in ipairs(bagId) do
		TracerDB.test[index] = {};
		numberOfSlots = C_Container.GetContainerNumSlots(value);
		for i=1, numberOfSlots do
			containerInfo = C_Container.GetContainerItemInfo(value, i);
			TracerDB.test[index][i] = containerInfo;
		end
	end

end


-- ----------------------------------------------------------------------------------------------------------
-- ----------------- Bouton minimap -------------------------------------------------------------------------
-- ----------------------------------------------------------------------------------------------------------

local addon = LibStub("AceAddon-3.0"):NewAddon("Tracer", "AceConsole-3.0")
local TracerLDB = LibStub("LibDataBroker-1.1"):NewDataObject("Tracer", {
	type = "data source",
	text = "Tracer",
	icon = "Interface\\AddOns\\Tracer\\Fonts\\TracerMinimap",
	OnClick = function() 
		TracerData.Function:TracerToggle();
		end,		
})
local icon = LibStub("LibDBIcon-1.0")

function addon:OnInitialize()
	self.db = LibStub("AceDB-3.0"):New("TracerDB", {
		profile = {
			minimap = {
				hide = false,
				["minimapPos"] = 201,
			},
		},
	})
	icon:Register("Tracer", TracerLDB, self.db.profile.minimap)
end
 
function addon:TracerMinimapCommand()
	self.db.profile.minimap.hide = not self.db.profile.minimap.hide
	if self.db.profile.minimap.hide then
		icon:Hide("Tracer")
	else
		icon:Show("Tracer")
	end
end

-- ----------------------------------------------------------------------------------------------------------
-- ----------------- IconID ---------------------------------------------------------------------------------
-- ----------------------------------------------------------------------------------------------------------

TracerData.ClassIcon = {
	626008,	--1 - Warrior
	626003,	--2 - Paladin
	626000,	--3 - Hunter
	626005,	--4	- Rogue
	626004,	--5 - Priest
	135771,	--6 - DK
	626006,	--7 - Shaman
	626001,	--8 - Mage
	626007,	--9 - Warlock
	626002,	--10 - Monk
	625999,	--11 - Druid
	236415,	--12 - DH
	4574311, --13 - Evoker
}

-- ----------------------------------------------------------------------------------------------------------
-- ----------------- Fonctions générales --------------------------------------------------------------------
-- ----------------------------------------------------------------------------------------------------------

--Montrer ou Cacher une catégorie
function TracerData.Function:ShowOrHide(t)
	if TracerDB.Options.DisplayHeader[t] then
		Tracer.Headers[t]:Show();
	else
		Tracer.Headers[t]:Hide();
	end
end

--Création d'une frame complète
function TracerData.Function:CreateFrameOne(name, ParentFrame, ParentAnchor, xSize, ySize, SetPointOne, SetPointParent, xOffset1, yOffset1, r, g, b, a, SetPointTextOne, SetPointTextParent, xOffset2, yOffset2, text)
	local t = CreateFrame("Frame" , name, ParentFrame);
	t:SetSize(xSize, ySize); --Définir la taille de la frame(largueur/hauteur)
	t:SetPoint(SetPointOne, ParentAnchor, SetPointParent, xOffset1, yOffset1); --Position de la frame 
	t:SetFrameStrata("HIGH"); --Couche sur laquelle la frame est placée
	-- Texture de la frame (pour le fond)
	t.Texture1 = t:CreateTexture(nil, "BACKGROUND");
	t.Texture1:SetAllPoints(t);
	t.Texture1:SetColorTexture(r, g, b, a);
	-- Texture2 de la frame	(pour l'icône)
	t.Texture2 = t:CreateTexture(nil, "BORDER");
	t.Texture2:SetSize(12, 12);
	t.Texture2:SetPoint("CENTER");
	-- Titre de la frame
	t.Title = t:CreateFontString(nil, "OVERLAY");
	t.Title:SetFont("Fonts\\FRIZQT__.TTF", TracerDB.Options.police);	
	t.Title:SetPoint(SetPointTextOne, t, SetPointTextParent, xOffset2, yOffset2);
	t.Title:SetText(text);
	return t;
end 

--Création d'un bouton pour les noms des Toons
function TracerData.Function:CreateFrameOne2(name, ParentFrame, ParentAnchor, xSize, ySize, SetPointOne, SetPointParent, xOffset1, yOffset1, r, g, b, a, SetPointTextOne, SetPointTextParent, xOffset2, yOffset2, text, toonnumber)
	local t = CreateFrame("Button" , name, ParentFrame);
	t:SetSize(xSize, ySize); --Définir la taille de la frame(largueur/hauteur)
	t:SetPoint(SetPointOne, ParentAnchor, SetPointParent, xOffset1, yOffset1); --Position de la frame 
	t:SetFrameStrata("HIGH"); --Couche sur laquelle la frame est placée
	t:SetHighlightTexture("Interface\\AddOns\\Tracer\\Fonts\\TalentSelected");
	-- Texture de la frame (pour le fond)
	t.Texture1 = t:CreateTexture(nil, "BACKGROUND");
	t.Texture1:SetAllPoints(t);
	t.Texture1:SetColorTexture(r, g, b, a);
	-- Texture2 de la frame	(pour l'icône)
	t.Texture2 = t:CreateTexture(nil, "BORDER");
	t.Texture2:SetSize(12, 12);
	t.Texture2:SetPoint("CENTER");
	-- Titre de la frame
	t.Title = t:CreateFontString(nil, "OVERLAY");
	t.Title:SetFont("Fonts\\FRIZQT__.TTF", TracerDB.Options.police);	
	t.Title:SetPoint(SetPointTextOne, t, SetPointTextParent, xOffset2, yOffset2);
	t.Title:SetText(text);
	--Liste des bouttons d'interaction
	t:SetScript("OnClick", function(self, button, down)
		if button == "LeftButton" then
			if not TracerData.ToonPanel["Header"]:IsShown() then
				TracerData.Function:ToonPanelDisplay(toonnumber);		
			elseif TracerData.ToonPanel["Header"]:IsShown() and (TracerDB.Options.toonpanelnumber ~= toonnumber) then
				TracerData.Function:ToonPanelDisplay(toonnumber);
			else
				TracerData.ToonPanel["Header"]:Hide();		
			end
			TracerDB.Options.toonpanelnumber = toonnumber;
		end
		end);		
	return t;
end 

--Création d'une ligne complète
--num : Numéro de la catégorie
function TracerData.Function:CreateLine(num, id)
	local widthrow0 = TracerDB.Options.widthrow0;
	local widthtoon = TracerDB.Options.widthtoon;	
	local heightline = TracerDB.Options.heightline;		
	local i = #TracerDB.ListLine[num]+1;
	
	--Création des lignes
	local xOffset = 0;	
	--Affichage de la première colonne						
	TracerData.Lines[num][i]=TracerData.Function:CreateFrameOne("Lines_"..num.."_"..i, TracerData.Headers[1], UIParent, widthrow0, heightline, "CENTER", "CENTER", 0, 0, rwindow, gwindow, bwindow, twindow, "LEFT", "LEFT", 5, 0, " ")
	TracerData.Lines[num][i]["Title"]:SetAllPoints(TracerData.Lines[num][i]);
	TracerData.Lines[num][i]["Title"]:SetJustifyH("LEFT");
	--Création des frames des Toons pour un futur affichage
	for index = 1, ToonsFrameCount, 1 do	--On parcours les Toons à afficher
		if TracerData.Lines[num]["Toon"..index] == nil then
			TracerData.Lines[num]["Toon"..index] = {};	--Création de la table pour les informations du Toon à afficher	
		end
		--Création des frames
		if index == 1 then
			ParentAnchor = TracerData.Lines[num][i];	--Anchor de la frame			
		else
			ParentAnchor = TracerData.Lines[num]["Toon"..index-1][i] --Update de l'Anchor pour le Toon suivant			
		end			
		TracerData.Lines[num]["Toon"..index][i] = TracerData.Function:CreateFrameOne("Lines"..num.."Toon"..index.."_"..i, TracerData.Headers[1], ParentAnchor, widthtoon, heightline, "LEFT", "RIGHT", 0, 0, rwindow, gwindow, bwindow, twindow, "CENTER", "CENTER", 0, 0, num.." - "..index.." - "..i);
	end
	TracerData.Lines[num]["Toon"..TracerData.numthisToon][i]["Title"]:SetTextColor(TracerDB.Toons[TracerData.thisToon]["ClassColor"]["r"], TracerDB.Toons[TracerData.thisToon]["ClassColor"]["g"], TracerDB.Toons[TracerData.thisToon]["ClassColor"]["b"], 1);
		
	table.insert(TracerDB.ListLine[num], id);	
	table.insert(TracerDB.Options.DisplayLine[num], {TracerData.Buttons["6minus"]:IsShown(), true});		
end

--Création d'une catégorie complète
function TracerData.Function:WindowCreate(num, headername)
	local widthrow0 = TracerDB.Options.widthrow0;
	local widthtoon = TracerDB.Options.widthtoon;	
	local heightline = TracerDB.Options.heightline;	
	

	--Création des DisplayLine par ligne
	for index, value in ipairs(TracerDB.ListLine[num]) do
		if not TracerDB.Options.DisplayLine[num][index] then
			TracerDB.Options.DisplayLine[num][index] = {true, true};
			--Paramétrage pour l'affichage custom de base
			if (num == 4) or (num == 5) or (num == 10) then			--Pour ne pas afficher les monnaies / réputations / pvp
				TracerDB.Options.Custom.DisplayLine[num][index] = {false, false};	
			else
				TracerDB.Options.Custom.DisplayLine[num][index] = {true, true};
			end
		end
	end
	
	--Création de l'en-tête
	local ParentFrame = UIParent;	
	if num ~= 1 then
		ParentFrame = TracerData.Headers[1];
	end
	--Calcul de la longueur du header
	local lengthheader = 0;
	if #TracerData.ListToons >= 10 then
		lengthheader = widthrow0 + 10 * widthtoon
	else
		lengthheader = widthrow0 + #TracerData.ListToons * widthtoon
	end
	TracerData.Headers[num] = TracerData.Function:CreateFrameOne("TracerHeader"..num, ParentFrame, UIParent, lengthheader, heightline, "CENTER", "CENTER", 0, 0, rheader, gheader, bheader, theader, "CENTER", "CENTER", 0, 0, headername)
	
	--Création du bouton pour faire apparaître/disparaître les lignes	
	TracerData.Buttons[num.."minus"] = CreateFrame("Button", "Button"..num.."Minus", TracerData.Headers[num]);
	TracerData.Buttons[num.."minus"]:SetSize(15, 15);
	TracerData.Buttons[num.."minus"]:SetPoint("LEFT", TracerData.Headers[num], "LEFT", 5, 0);
	TracerData.Buttons[num.."minus"]:SetNormalTexture("Interface\\AddOns\\Tracer\\Fonts\\UI-MinusButton-Up");
	TracerData.Buttons[num.."minus"]:SetPushedTexture("Interface\\AddOns\\Tracer\\Fonts\\UI-MinusButton-Down");		
	TracerData.Buttons[num.."minus"]:SetScript("OnClick", function()		
		for index, value in ipairs(TracerDB.Options.DisplayLine[num]) do
			value[2] = value[1];	--mémorise si la ligne était affichée
			value[1] = false;		--cache de la ligne
		end
		TracerDB.Options.Reduction[num] = true;
		--Update des Ancrages
		TracerData.Function:UpdateAnchors();
		end)
	TracerData.Buttons[num.."plus"] = CreateFrame("Button", "Button"..num.."Plus", TracerData.Headers[num]);
	TracerData.Buttons[num.."plus"]:SetSize(15, 15);
	TracerData.Buttons[num.."plus"]:SetPoint("LEFT", TracerData.Headers[num], "LEFT", 5, 0);
	TracerData.Buttons[num.."plus"]:SetNormalTexture("Interface\\AddOns\\Tracer\\Fonts\\UI-PlusButton-Up");
	TracerData.Buttons[num.."plus"]:SetPushedTexture("Interface\\AddOns\\Tracer\\Fonts\\UI-PlusButton-Down");		
	TracerData.Buttons[num.."plus"]:SetScript("OnClick", function()	
		for index, value in ipairs(TracerDB.Options.DisplayLine[num]) do
			if value[2] then		--si la ligné été affichée
				value[1] = true;	--on l'affiche
			end
		end
		TracerDB.Options.Reduction[num] = false;
		--Update des Ancrages
		TracerData.Function:UpdateAnchors();
		end)
		
	--Création des lignes
	TracerData.Lines[num] = {};
	local yOffset = 0;
	local xOffset = 0;	
	--Affichage de la première colonne
	local ParentAnchor = TracerData.Headers[num];	--Anchor de la frame
	for i = 1, #TracerDB.ListLine[num], 1 do
		TracerData.Lines[num][i]=TracerData.Function:CreateFrameOne("Lines_"..num.."_"..i, TracerData.Headers[1], ParentAnchor, widthrow0, heightline, "TOPLEFT", "BOTTOMLEFT", 0, 0, rwindow, gwindow, bwindow, twindow, "LEFT", "LEFT", 5, 0, TracerDB.ListLine[num][i])
		TracerData.Lines[num][i]["Title"]:SetAllPoints(TracerData.Lines[num][i]);
		TracerData.Lines[num][i]["Title"]:SetJustifyH("LEFT");
		ParentAnchor = TracerData.Lines[num][i];	
	end
	--Création des frames des Toons pour un futur affichage
	if #TracerData.ListToons <= 10 then
		ToonsFrameCount = #TracerData.ListToons
	elseif #TracerData.ListToons <= 20 then
		ToonsFrameCount = 20;
	elseif #TracerData.ListToons <= 30 then
		ToonsFrameCount = 30;		
	elseif #TracerData.ListToons <= 40 then
		ToonsFrameCount = 40;		
	else
		ToonsFrameCount = 50;		
	end
	for index=1, ToonsFrameCount, 1 do	--On parcours les Toons à afficher
		TracerData.Lines[num]["Toon"..index] = {};	--Création de la table pour les informations du Toon à afficher	
		for i = 1, #TracerDB.ListLine[num] , 1 do
			--Création des frames
			if (index == 1) or (index == 11) or (index == 21) or (index == 31) or (index == 41) then
				ParentAnchor = TracerData.Lines[num][i];	--Anchor de la frame			
			else
				ParentAnchor = TracerData.Lines[num]["Toon"..index-1][i] --Update de l'Anchor pour le Toon suivant			
			end
			--Création spécifique des boutons pour le nom du Toons
			if (num == 1) and (i == 1) then
				TracerData.Lines[num]["Toon"..index][i] = TracerData.Function:CreateFrameOne2("Lines"..num.."Toon"..index.."_"..i, TracerData.Headers[1], ParentAnchor, widthtoon, heightline, "LEFT", "RIGHT", 0, 0, rwindow, gwindow, bwindow, twindow, "CENTER", "CENTER", 0, 0, nil, index);
			else
				TracerData.Lines[num]["Toon"..index][i] = TracerData.Function:CreateFrameOne("Lines"..num.."Toon"..index.."_"..i, TracerData.Headers[1], ParentAnchor, widthtoon, heightline, "LEFT", "RIGHT", 0, 0, rwindow, gwindow, bwindow, twindow, "CENTER", "CENTER", 0, 0, nil);
			end
			if index >= 11 then
				TracerData.Lines[num]["Toon"..index][i]:Hide();
			end
			TracerData.Lines[num]["Toon"..index][i]["Title"]:SetSize(widthtoon, heightline);
		end
	end
	
	TracerData.Function:UpdateAnchors();
end

--Création d'un slider
function TracerData.Function:CreateSlider(name, ParentFrame, xSize, ySize, SetPointOne, Parent, SetPointParent, xOffset1, yOffset1, SetPointTextOne, SetPointTextParent, xOffset2, yOffset2, text, mini, maxi, step)
	local t = CreateFrame("Slider", nil, ParentFrame, "OptionsSliderTemplate");
	t:SetOrientation('HORIZONTAL');
	t:SetPoint(SetPointOne,Parent,SetPointParent,xOffset1,yOffset1);
	t:SetWidth(ySize);
	t:SetHeight(xSize);
	t:SetMinMaxValues(mini, maxi);
	t:SetValueStep(step);
	t["Title"] = t:CreateFontString(nil, "OVERLAY");
	t["Title"]:SetFont("Fonts\\FRIZQT__.TTF", TracerDB.Options.police);
	t["Title"]:SetPoint(SetPointTextOne, t, SetPointTextParent, xOffset2, yOffset2);
	t["Title"]:SetText(text);
	return t;
end

--Compter la quantité d'un item dans les sacs (perso + banque + banque de compo)
function TracerData.Function:GetContainerNumItem(item)
	local bagId = {0, 1, 2, 3, 4, -1, 5, 6, 7, 8, 9, 10, 11, -3};	--0 à 4 perso, -1 banque, 5 à 11 sac de banque, -3 compo
	local numberOfSlots = 0;
	local numObject = 0;
	local containerInfo = {};
	for index, value in ipairs(bagId) do
		numberOfSlots = C_Container.GetContainerNumSlots(value);
		for i=1, numberOfSlots do
			containerInfo = C_Container.GetContainerItemInfo(value, i);
			if containerInfo and (containerInfo.itemID == item) then				
				numObject = numObject + containerInfo.stackCount;
			end
		end
	end
	return numObject;
end

--Obtenir les vérouillage d'instances
function TracerData.Function:GetLockInstance()
	--Récupération des vérouillage de raid
	local num  = GetNumSavedInstances();
	local InstanceLockInfo = {};
	if num == 0 then return end
	for i=1, num do
		InstanceLockInfo[i] = {};
		local name, id, reset, difficulty, locked, extended, instanceIDMostSig, isRaid, maxPlayers, difficultyName, numEncounters, encounterProgress = GetSavedInstanceInfo(i);
		InstanceLockInfo[i]["name"] = name;
		InstanceLockInfo[i]["id"] = id;
		InstanceLockInfo[i]["reset"] = reset;
		InstanceLockInfo[i]["difficulty"] = difficulty;
		InstanceLockInfo[i]["locked"] = locked;
		InstanceLockInfo[i]["extended"] = extended;
		InstanceLockInfo[i]["instanceIDMostSig"] = instanceIDMostSig;
		InstanceLockInfo[i]["isRaid"] = isRaid;
		InstanceLockInfo[i]["maxPlayers"] = maxPlayers;
		InstanceLockInfo[i]["difficultyName"] = difficultyName;
		InstanceLockInfo[i]["numEncounters"] = numEncounters;
		InstanceLockInfo[i]["encounterProgress"] = encounterProgress;
	end
	return InstanceLockInfo
end

--Obtenir les auras
function TracerData.Function:GetAuras()
	local t = {};
	for i=1,40 do
		local name, icon, count, debuffType, duration, expirationTime, unitCaster, isStealable, 
			nameplateShowPersonal, spellId, canApplyAura, isBossDebuff, nameplateShowAll, timeMod, value1, value2, value3
			= UnitBuff("player", i)
		t[i] = {
			["name"] = name,
			["icon"] = icon,
			["count"] = count,
			["debuffType"] = debuffType,
			["duration"] = duration,
			["expirationTime"] = expirationTime,
			["unitCaster"] = unitCaster,
			["isStealable"] = isStealable,			
			["nameplateShowPersonal"] = nameplateShowPersonal,
			["spellId"] = spellId,
			["canApplyAura"] = canApplyAura,
			["isBossDebuff"] = isBossDebuff,
			["nameplateShowAll"] = nameplateShowAll,
			["timeMod"] = timeMod,
			["value1"] = value1,
			["value2"] = value2,
			["value3"] = value3,
			};			
	end
	return t;
end

--Update des métiers du Toon
function TracerData.Function:UpdateJobsToon()
	TracerData.DarkmoonInfos.Job = {	--TradeSkillId
			[182] = {questId = 29514, name = C_TradeSkillUI.GetTradeSkillDisplayName(182)},	--Herboristerie
			[186] = {questId = 29518, name = C_TradeSkillUI.GetTradeSkillDisplayName(186)},	--Minage
			[393] = {questId = 29519, name = C_TradeSkillUI.GetTradeSkillDisplayName(393)},	--Dépeçage
			[171] = {questId = 29506, name = C_TradeSkillUI.GetTradeSkillDisplayName(171)},	--Alchimie
			[164] = {questId = 29508, name = C_TradeSkillUI.GetTradeSkillDisplayName(164)},	--Forge
			[333] = {questId = 29510, name = C_TradeSkillUI.GetTradeSkillDisplayName(333)},	--Enchantement
			[202] = {questId = 29511, name = C_TradeSkillUI.GetTradeSkillDisplayName(202)},	--Ingénierie
			[773] = {questId = 29515, name = C_TradeSkillUI.GetTradeSkillDisplayName(773)},	--Calligraphie
			[755] = {questId = 29516, name = C_TradeSkillUI.GetTradeSkillDisplayName(755)},	--Joaillerie
			[165] = {questId = 29517, name = C_TradeSkillUI.GetTradeSkillDisplayName(165)},	--Travail du cuir
			[197] = {questId = 29520, name = C_TradeSkillUI.GetTradeSkillDisplayName(197)},	--Couture
			[794] = {questId = 29507, name = C_TradeSkillUI.GetTradeSkillDisplayName(794)},	--Archéologie
			[185] = {questId = 29509, name = C_TradeSkillUI.GetTradeSkillDisplayName(185)},	--Cuisine
			[356] = {questId = 29513, name = C_TradeSkillUI.GetTradeSkillDisplayName(356)},	--Pêche
			};
	
	local prof1, prof2, archaeology, fishing, cooking = GetProfessions();
	
	local job1, job2, job3, job4, job5;
	if prof1 then
		job1 = GetSpellTabInfo(prof1);
		for key, value in pairs(TracerData.DarkmoonInfos.Job) do
			if job1 == value.name then
				job1 = key
			end
		end		
	else
		job1 = false;
	end
	if prof2 then
		job2 = GetSpellTabInfo(prof2);
		for key, value in pairs(TracerData.DarkmoonInfos.Job) do
			if job2 == value.name then
				job2 = key
			end
		end			
	else
		job2 = false;
	end
	if archaeology then
		job3 = 794;
	else
		job3 = false;
	end	
	if fishing then
		job4 = 356;
	else
		job4 = false;
	end	
	if cooking then
		job5 = 185;
	else
		job5 = false;
	end		
	TracerDB["Toons"][TracerData.thisToon]["Job"][1] = job1;
	TracerDB["Toons"][TracerData.thisToon]["Job"][2] = job2;
	TracerDB["Toons"][TracerData.thisToon]["Job"][3] = job3;
	TracerDB["Toons"][TracerData.thisToon]["Job"][4] = job4;
	TracerDB["Toons"][TracerData.thisToon]["Job"][5] = job5;
end

--Close Tracer
function TracerData.Function:CloseTracer()
	--Remise sur la page 1
	TracerDB.Options.Page = 1;
	TracerData.Function:UpdateAnchors();
	--Fermeture
	TracerData.Headers[1]:Hide();
	if TracerData.Options["OptionsH"] ~= nil then
		TracerData.Options["OptionsH"]:Hide();
		for i=1, #TracerData.ListOptions, 1 do
			TracerData.Options["W"..i]:Hide();
		end
	end
	TracerData.ToonPanel.Header:Hide();
end

--Options Menu
function TracerData.Function:OptionsTracer()
	--Création du menu des Options		
	if TracerData.Options["OptionsH"] == nil then
		TracerData.Function:Options();
	end
	
	if TracerData.Options["OptionsH"]:IsShown() then
		TracerData.Options["OptionsH"]:Hide();
		for i=1, #TracerData.ListOptions, 1 do
			TracerData.Options["W"..i]:Hide();
		end
	else
		TracerData.Options["OptionsH"]:Show();
		TracerData.Options["OptionsH"]:ClearAllPoints();
		TracerData.Options["OptionsH"]:SetPoint("CENTER", UIParent, "CENTER", 0, 200);
		TracerData.Options["W1"]:Show();
		TracerData.Options["OptionsH"]["Title"]:SetText(TracerData.ListOptions[1]);		
	end
end

--Formatage pour affichage d'un temps en d/h/min/sec
function TracerData.Function:RemainingTime(remaining)
	local days, hours, minutes, seconds, answer = 0, 0, 0, 0, " ";
	days = (remaining - (remaining % 86400)) / 86400;
	remaining = remaining - days * 86400;
	hours = (remaining - (remaining % 3600)) / 3600;
	remaining = remaining - hours * 3600;
	minutes = (remaining - (remaining % 60)) / 60;
	seconds = remaining - minutes * 60;	
	
	if days ~= 0 then
		if seconds < 10 then
			answer = days.." "..TracerData.L["j"].." "..hours.." h "..minutes..":0"..seconds ;		
		else
			answer = days.." "..TracerData.L["j"].." "..hours.." h "..minutes..":"..seconds ;			
		end
	elseif hours ~= 0 then
		if seconds < 10 then
			answer = hours.." h "..minutes..":0"..seconds ;		
		else
			answer = hours.." h "..minutes..":"..seconds ;		
		end
	else
		if seconds < 10 then
			answer = minutes.." min 0"..seconds.." s" ;
		else
			answer = minutes.." min "..seconds.." s" ;		
		end
	end
	return answer;	
end

--Ecrire un nombre entier avec séparateur de millier
function TracerData.Function:format_thousand(v)
    local pos = string.len(v) % 3 --détermine combien de digits contient la première partie
    if pos == 0 then pos = 3 end
    return string.sub(v, 1, pos) .. string.gsub(string.sub(v, pos+1), "(...)", " %1")
end

--String Split
function TracerData.Function:StringSplit(inputstr, sep)
	if sep == nil then
			sep = "%s"
	end
	local t={}
	for str in string.gmatch(inputstr, "([^"..sep.."]+)") do
			table.insert(t, str)
	end
	return t
end

-- ----------------------------------------------------------------------------------------------------------
-- ----------------- Ajout/Update du personnage + Liste Toons pour affichage --------------------------------
-- ---------------------------------------------------------------------------------------------------------

--Tester si le joueur est déjà dans la liste
--Renvoi 1 si oui, 0 sinon
function TracerData.Function:CheckToon(name)
	local a = 0;	
	for key, value in pairs(TracerDB.Toons) do
		if key == name then 
			a = 1;
		end
	end	
	return a;
end

--Ajoute/Update le joueur
function TracerData.Function:InitToon()
	local class, classFileName, classID = UnitClass("player")
	local raceName, raceFile, raceID = UnitRace("player");
	local color = RAID_CLASS_COLORS[classFileName]
	
	--Ajoute le joueur
	if TracerData.Function:CheckToon(TracerData.thisToon) == 0 then	--Ajoute le joueur s'il est absent '0'
		--Détermine l'ordre du Toon, il doit être après ceux display et avant les non display
		local order = 1;
		for key, value in pairs(TracerDB.Toons) do
			if value.Display then 
				order = order + 1;
			end
		end
		--Il faut ajouter 1 à tous les non display	
		for key, value in pairs(TracerDB.Toons) do
			if not (value.Display) then 
				value.Order = value.Order + 1;
			end
		end		
		
		--Initialisation du Toon		
		TracerDB.Toons[TracerData.thisToon] = {
			["Order"] = order,	--Ordre d'affichage
			["Display"] = true,	--Affiché ou non
			["Class"] = class,
			["ClassId"] = classID,
			["Name"] = UnitName("player"),
			["Level"] = UnitLevel("player"),
			["Race"] = raceName,
			["RaceId"] = raceID,	
			["Gender"] = UnitSex("player"),
			["Realm"] = GetRealmName(),
			["Faction"] = UnitFactionGroup("player"),
			["Specialization"] = {},
			["ConfigsInfos"] = {},
			["TalentPVP"] = {},			
			["Job"] = {false, false},
			["Ilvl"] = -1,
			["PO"] = 0,
			["ClassColor"] = {
				r = color.r,
				g = color.g,
				b = color.b,
				},
			["Quests"] = {
				["HD"] = -1,	--Flag donjon héroïque du jour
				["MD"] = -2,	--Plus haut niveau du donjon mythique de la semaine (-2 NA, -1 rien, 0 ou +)
				["MC"] = -1,	--Flag coffre m+ à récupérer (-1 non dispo)
				["MK"] = {0, -1, 0, 0, 0, 0},	--MythicMapId, Level, Affix1, Affix2, Affix3, Affix4
				["MKLegion"] = {0, -1, 0, 0, 0, 0},	--MythicMapId, Level, Affix1, Affix2, Affix3, Affix4
				["MKSL"] = {0, -1, 0, 0, 0, 0},	--MythicMapId, Level, Affix1, Affix2, Affix3, Affix4				
				["BfA"] = {
					["IE"] = {-1, -1},	--quête expédition d'îles : flag quête complétée, quantité d'azérite					
					["Quests"] = {0, 0, 0, 0, 0, 0, 0, 0, 0},		--Suivi quête BfA
					["Warfronts"] = {
						-2,	--Stromgarde
						-2,	--Sombrivage
						},
					["Seal"] = 0,	--quête pour les sceaux
					["Nazjatar"] = {
						["Daily"] = -1,	--quêtes journa pour le gardien aillié de nazjatar
						["Weekly"] = {-1,-1,-1},	--Mardivas, ??, ??
						},
					["Mechagon"] = {-1, -1, -1},	--daily 850, recyclage, WM quest
					["Assaults"] = {0, 0},	--nombre d'assaults effectué (0, 1 ou 2) Val, Uldum
					["Ashjra'kamas"] = {0, 0},	--rang de la cape légendaire / nombre visions
					},
				["SL"] = {
					["Callings"] = {
						{0, false},
						{0, false},						
						{0, false},						
						},
					["CallingsUnlocked"] = false,
					["CovenantID"] = C_Covenants.GetActiveCovenantID(),
					["CovenantRenownLevel"] = C_CovenantSanctumUI.GetRenownLevel(),
					["WeeklyDungeonQuests"] = {-1, -1},
					["WeeklyDungeonQuestsUnlocked"] = false;
					["WBSL"] = -1;
					["Quests"] = {0, 0, 0, 0},
					["AssaultMaw"] = 0,
					["KorthiaWeekly"] = -1,
					["KorthiaDaily"] = 0,
					["KorthiaWB"] = -1,	
					["KorthiaWQ"] = -1,	
					["ZMWB"] = -1,
					["ZMWeekly"] = -1,
					},
				["DF"] = {
					["Currencies"] = {
						[199211] = 0,	--essence primitive (monnaie pré patch)
						},			
					["Quests"] = {
						[70049] = -1,	--quete journa pour les essences
						["AylaagCamp"] = -1,
						["CourseDraconique"] = 0,
						["WeeklyChests"] = 0,
						["WeeklyValdrakken"] = {},
						["KnowledgePoints"] = {0, 0};
						[71995] = 0,
						[70906] = 0,
						[70893] = 0,
						[71033] = 0,
						[70866] = 0,
						[66133] = -1,
						[66805] = -1,						
						},
					["WBDF"] = -1,	--Flag World Boss Nazjatar tué ( 0 ='non' et 1 = 'oui')
					},
				["WBNaz"] = -1,	--Flag World Boss Nazjatar tué ( 0 ='non' et 1 = 'oui')				
				["Weeklyquest"] = {-1, -1, -1},	--quête d'évènement hebdo : flag quête complétée, questdone, questneed	
				["WBBfA"] = -1,	--Flag World Boss BfA tué ( 0 ='non' et 1 = 'oui')
				["WBNzoth"] = -1,	--Flag World Boss Nzoth tué ( 0 ='non' et 1 = 'oui')				
				["EQBfA"] = {
					-1,	--Nombre de quêtes d'émissaires disponibles
					["EQ1"] = { 0 , 0, false, " ", 0, 0},	--1ere EQ avec id, temps restant en min, faite ou non, récompense, quêtes faites, total
					["EQ2"] = { 0 , 0, false, " ", 0, 0},	--2ere EQ avec id, temps restant en min, faite ou non, récompense, quêtes faites, total 
					["EQ3"] = { 0 , 0, false, " ", 0, 0},	--3ere EQ avec id, temps restant en min, faite ou non, récompense, quêtes faites, total	
					},
				["Argus"] = {-1, -1, -1, -1, -1, -1},	--Flag Argus quêtes				
				["WBLegion"] = 0,	--Flag World Boss Legion tué ( 0 ='non' et 1 = 'oui')
				["WBArgus"] = -1,	--Flag Argus Invasion Prioritaire faite ( 0 ='non' et 1 = 'oui')								
				["EQLegion"] = {
					-1,	--Nombre de quêtes d'émissaires disponibles
					["EQ1"] = { 0 , 0, false, " ", 0, 0},	--1ere EQ avec id, temps restant en min, faite ou non, récompense, quêtes faites, total 
					["EQ2"] = { 0 , 0, false, " ", 0, 0},	--2ere EQ avec id, temps restant en min, faite ou non, récompense, quêtes faites, total 
					["EQ3"] = { 0 , 0, false, " ", 0, 0},	--3ere EQ avec id, temps restant en min, faite ou non, récompense, quêtes faites, total 	
					},
				["TD"] = {
					-1, --Compteur Timewalking de la semaine (-1 quête non prise)
					false,	--Rendu ou non
					-1,	--Quête du premier de la semaine
					-1, --Quête du raid
					},
				["Darkmoon"] = {
					["Job"] = {0, 0, 0, 0, 0},
					["Daily"] = {0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
					["Items"] = {0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
					},						
				},
			["PVP"] = {
				["CC"] = {0, 0},				--Points précédent, points gagnés cette semaine
				["CTAQuests"] = {},				--Weekly Appels aux armes (3 quêtes)		
				["BattleNazjatar"] = {0, 0},	--Progression (pourcent), flag quête pour la Weekly Bataille de Nazjatar
				["Daily"] = {0, 0, 0},			--Daily : Champ de bataille, épique et escarmouche
				["DailyRated"] = {0, 0, 0},		--Daily : 2v2, 3v3, champ de bataille
				["25kill"] = -2,				--Weekly 25 kill
				},				
			["Azerite"] = {
				active = false,	--active item
				lvl = 0,		--niveau
				xp = 0,			--xp niveau
				xptotal = 0,	--xp total du niveau			
				},
			["Instances"] = {},	--Lock des boss de raid
			["Mythic"] = {},
			["MythicList"] = {},
			["MythicReward"] = {},	
			["MythicScore"] = 0,
			["MythicBestSeason"] = {};
			["Currencies"] = {},
			["Factions"] = {},		
			["Inventory"] = {},
			["AzeriteTraits"] = {},
			["AzeriteEssences"] = {},
			["Torghast"] = {},
			["LoveIsInTheAir"] = {0, 0},	--World Event : L'amour est dans l'air
			};
	--Update du joueur
	else
		TracerDB["Toons"][TracerData.thisToon]["Level"] = UnitLevel("player");		
		TracerDB["Toons"][TracerData.thisToon]["Name"] = UnitName("player");
		TracerDB["Toons"][TracerData.thisToon]["Realm"] = GetRealmName();
		TracerDB["Toons"][TracerData.thisToon]["Class"] = class;
		TracerDB["Toons"][TracerData.thisToon]["ClassId"] = classID;
		TracerDB["Toons"][TracerData.thisToon]["Race"] = raceName;
		TracerDB["Toons"][TracerData.thisToon]["RaceId"] = raceID;	
		TracerDB["Toons"][TracerData.thisToon]["Gender"] = UnitSex("player");
		TracerDB["Toons"][TracerData.thisToon]["Faction"] = UnitFactionGroup("player");		
		TracerDB["Toons"][TracerData.thisToon]["ClassColor"] = {
				r = color.r,
				g = color.g,
				b = color.b,
				};
		TracerData.Function:UpdateJobsToon();	--pour les métiers
		TracerDB["Toons"][TracerData.thisToon]["Quests"]["SL"]["CovenantID"] = C_Covenants.GetActiveCovenantID();	--id covenant
		TracerDB["Toons"][TracerData.thisToon]["Quests"]["SL"]["CovenantRenownLevel"] = C_CovenantSanctumUI.GetRenownLevel();	--Renown level		
	end

	--Compte le nombre de Toons enregistré
	local a = 0; 
	for key in pairs(TracerDB.Toons) do
		a = a + 1;
	end		
	TracerDB.ToonsCount = a;
	if a > TracerData.CharactersLimit then
		TracerDB["Toons"][TracerData.thisToon]["Display"] = false;
		print(TracerData.L["TracerLimit"]);
	end
	
	TracerData.numthisToon = TracerDB.Toons[TracerData.thisToon]["Order"];
end

--Création de la liste des Toons à afficher
function TracerData.Function:ListToons()
	local i = 0;
	
	--Création de la liste des Toons à afficher dans l'ordre
	for key, value in pairs(TracerDB.Toons) do
		if value.Display then			
			TracerData.ListToons[value.Order] = key;
		end
		i = i+1;
	end
end

function TracerData.Function:InitCRT()
	for key, value in ipairs(TracerData.ListToons) do
		--Initialisation des monnaies
		for index1, value1 in ipairs(TracerData.CurrenciesInfos) do
			if not TracerDB.Toons[value]["Currencies"][value1[1]] then
				TracerDB.Toons[value]["Currencies"][value1[1]] = 0;		
			end
		end
		--Initialisation des réputations		
		for index1, value1 in ipairs(TracerData.FactionsInfos) do
			if not TracerDB.Toons[value]["Factions"][value1[1]] then
				TracerDB.Toons[value]["Factions"][value1[1]] = {1, 0, 0, false, " "};
			end
		end		
		--Initialisation de Torghast
		for index1, value1 in ipairs(TracerData.TorghastDungeonIds) do
			if not TracerDB.Toons[value]["Torghast"][value1] then
				TracerDB.Toons[value]["Torghast"][value1] = false;
			end
		end
	end		
end

-- ----------------------------------------------------------------------------------------------------------
-- ----------------- Gestion des Quêtes d'Emissaires (Legion & BfA) -----------------------------------------
-- ----------------------------------------------------------------------------------------------------------
	
function TracerData.Function:EmissaryQuestsChecking(extension)
	local list;
	local numheader;
	local quest_available = 0;
	local mapId = 0;
	
	--Arrêt si le personnage n'a pas de faction
	if UnitFactionGroup("player") == "Neutral" then
		return;
	end
	
	--Paramétrage suivant l'extension
	if extension == "BfA" then
		numheader = 2;
		line = 1;
		quest_available = TracerData.EQBfAInfo.Available[TracerDB.Toons[TracerData.thisToon]["Faction"]];
		mapId = 1161;	--Boralus, C_Map.GetBestMapForUnit("player") pour avoir UiMapID
	elseif extension == "Legion" then
		numheader = 3;
		line = 1;	
		quest_available = TracerData.EQLegionInfo.Available[TracerDB.Toons[TracerData.thisToon]["Faction"]];
		mapId = 627;	--Dalaran, Iles Brisées, C_Map.GetBestMapForUnit("player") pour avoir UiMapID
	end

	--Détection de la possibilité des quêtes d'emmisaires
	if not C_QuestLog.IsQuestFlaggedCompleted(quest_available) then
		return;
	end
	TracerData.Lines[numheader]["Toon"..TracerData.numthisToon][line]["Title"]:SetText(nil);	
	
	local EQavailable = {
		0,	--Nombre de quêtes d'émissaires disponibles
		["EQ1"] = { 0 , 0, true, " ", 0, 0},	--1ere EQ avec id, temps restant en min, faite ou non, récompense, quêtes faites, total
		["EQ2"] = { 0 , 0, true, " ", 0, 0},	--2ere EQ avec id, temps restant en min, faite ou non, récompense, quêtes faites, total
		["EQ3"] = { 0 , 0, true, " ", 0, 0},	--3ere EQ avec id, temps restant en min, faite ou non, récompense, quêtes faites, total
		};	
	
	--Récupérer les quêtes et les ordonner
	--WorldMapFrame:GetMapID() --Pour voir l'id de la zone affiché avec la carte
	local BountyQuest = C_QuestLog.GetBountiesForMapID(mapId);	
	for BountyIndex, BountyInfo in ipairs(BountyQuest) do
		--Détermine le type de récompense
		local reward = " ";
		--Ressources de guerre / Azérite
		local numCurrencies = GetNumQuestLogRewardCurrencies(BountyInfo.questID);
		for i = 1, numCurrencies do
			local name, texture, count = GetQuestLogRewardCurrencyInfo(i, BountyInfo.questID);
			if name == C_CurrencyInfo.GetCurrencyInfo(1721)["name"] then		--1721 pour les perles de mana prismatiques
				reward = TracerData.L["Perles"];
				break;			
			elseif name == C_CurrencyInfo.GetCurrencyInfo(1560)["name"] then	--1560 pour les ressource de guerre
				reward = TracerData.L["RG"];
				break;			
			elseif name == C_CurrencyInfo.GetCurrencyInfo(1553)["name"] then	--1553 pour l'azérite
				reward = "AZ";
			end		
		end
		--Equipement
		local itemName, itemTexture, numItems1, quality, isUsable, itemID = GetQuestLogRewardInfo(1,BountyInfo.questID)
		if itemName then
			reward = "Loot";
		end		
		--PO
		local money = GetQuestLogRewardMoney(BountyInfo.questID)
		if money ~= 0 then
			reward = TracerData.L["PO"];
		end		
		
		--Détermine le temps restant
		local timeleft = C_TaskQuest.GetQuestTimeLeftMinutes(BountyInfo.questID)		
		
		--Détermine le nombres de quêtes faites et le nombre total demandées
		local _, _, isFinish, questDone, questNeed = GetQuestObjectiveInfo(BountyInfo.questID, 1, false);
		
		--Sauvegarde
		if timeleft then
			if timeleft > 2880 then
				EQavailable.EQ3[1] = BountyInfo.questID ;
				EQavailable.EQ3[2] = timeleft ;
				EQavailable.EQ3[3] = C_QuestLog.IsQuestFlaggedCompleted(BountyInfo.questID);
				EQavailable.EQ3[4] = reward;
				EQavailable.EQ3[5] = questDone;
				EQavailable.EQ3[6] = questNeed;
			elseif timeleft > 1440 then
				EQavailable.EQ2[1] = BountyInfo.questID ;
				EQavailable.EQ2[2] = timeleft ;
				EQavailable.EQ2[3] = C_QuestLog.IsQuestFlaggedCompleted(BountyInfo.questID);
				EQavailable.EQ2[4] = reward;
				EQavailable.EQ2[5] = questDone;
				EQavailable.EQ2[6] = questNeed;				
			else
				EQavailable.EQ1[1] = BountyInfo.questID ;
				EQavailable.EQ1[2] = timeleft ;
				EQavailable.EQ1[3] = C_QuestLog.IsQuestFlaggedCompleted(BountyInfo.questID);
				EQavailable.EQ1[4] = reward;
				EQavailable.EQ1[5] = questDone;
				EQavailable.EQ1[6] = questNeed;				
			end
		end
    end
	--Compter le nombre de quêtes emissaires dispo
	for key, value in pairs(EQavailable) do
		if key ~= 1 then
			if not value[3] then
				EQavailable[1] = EQavailable[1] + 1 ; 
			end
		end
	end

	if EQavailable[1] == 3 then
		TracerData.Lines[numheader]["Toon"..TracerData.numthisToon][line]["Texture2"]:SetTexture("Interface\\AddOns\\Tracer\\Fonts\\SquareRed");
	elseif EQavailable[1] == 2 then
		TracerData.Lines[numheader]["Toon"..TracerData.numthisToon][line]["Texture2"]:SetTexture("Interface\\AddOns\\Tracer\\Fonts\\SquareOrange");
	elseif EQavailable[1] == 1 then
		TracerData.Lines[numheader]["Toon"..TracerData.numthisToon][line]["Texture2"]:SetTexture("Interface\\AddOns\\Tracer\\Fonts\\SquareYellow");
	elseif EQavailable[1] == 0 then
		TracerData.Lines[numheader]["Toon"..TracerData.numthisToon][line]["Texture2"]:SetTexture("Interface\\AddOns\\Tracer\\Fonts\\SquareGreen");
	end

	TracerDB.Toons[TracerData.thisToon]["Quests"]["EQ"..extension] = EQavailable;
end

function TracerData.Function:EQTooltip(extension, value)
	local r, g, b = TracerDB.Toons[value]["ClassColor"]["r"], TracerDB.Toons[value]["ClassColor"]["g"], TracerDB.Toons[value]["ClassColor"]["b"]
	local quest =  {0, 0, 0};
	local lefttext = {" ", " ", " "};
	
	--Infos spécifique à l'extension (pour raccourcir le nom)
	local EQtoon = TracerDB.Toons[value]["Quests"]["EQ"..extension];
	--Trouver le nom de la réputation
	local Name = {}
	if extension == "BfA" then
		Name = TracerData.EQBfAInfo.Name;
	else
		Name = TracerData.EQLegionInfo.Name;
	end
	local questName = " ";
	
	for i=1, 3, 1 do
		--Nom de la réput
		for index, value in ipairs(TracerDB.Factions) do
			if Name[EQtoon["EQ"..i][1]] == value[1] then
				questName = value[2];
			end
		end
		
		if (EQtoon["EQ"..i][1] ~= 0) and (i == 1) then
			quest[i] = questName.." ("..EQtoon["EQ"..i][5].."/"..EQtoon["EQ"..i][6]..")";			
			lefttext[i] = i.." "..TracerData.L["jour"].." ("..EQtoon["EQ"..i][4]..")";
		elseif (EQtoon["EQ"..i][1] ~= 0) and (i > 1) then
			quest[i] = questName.." ("..EQtoon["EQ"..i][5].."/"..EQtoon["EQ"..i][6]..")";			
			lefttext[i] = i.." "..TracerData.L["jours"].." ("..EQtoon["EQ"..i][4]..")";			
		else
			if i== 1 then
				lefttext[i] = i.." "..TracerData.L["jour"];
			else
				lefttext[i] = i.." "..TracerData.L["jours"];	
			end
			if EQtoon["EQ"..i][2] == 0 then			
				quest[i] = TracerData.L["Terminé"];
			else
				quest[i] = TracerData.L["Inconnu"];			
			end
		end
	end
	
    GameTooltip:Hide();
	GameTooltip:SetOwner(UIParent, "ANCHOR_CURSOR");
    GameTooltip:AddLine(TracerDB.Toons[value]["Name"], r, g, b);
	GameTooltip:AddDoubleLine(lefttext[1], quest[1], 1, 1, 1, 1 ,1, 1);
	GameTooltip:AddDoubleLine(lefttext[2], quest[2], 1, 1, 1, 1 ,1, 1);
	GameTooltip:AddDoubleLine(lefttext[3], quest[3], 1, 1, 1, 1 ,1, 1);
	if TracerDB.Toons[value]["Level"] >= 50 then
		GameTooltip:Show();
	end
end

function TracerData.Function:UpdateEQTooltip(extension)
	local level = 0;
	local available = false;
	
	--Paramétrage suivant l'extension (level)
	if extension == "BfA" then
		level = 50;		
	elseif extension == "Legion" then
		level = 50;		
	end	
	--Paramétrage suivant l'extension (quêtes d'expéditions débloquées)
	if TracerDB.Toons[TracerData.thisToon]["Quests"]["EQ"..extension][1] ~= -1 then
		available = true;				
	end

	--Détecte si le perso connecté peut transmettre les infos
	if TracerDB.Toons[TracerData.thisToon]["Level"] < level then return end	--Le perso doit être 50
	if not available then return end	--Le perso doit avoir débloqué les quêtes d'emmisaires
	if TracerDB.Toons[TracerData.thisToon]["Quests"]["EQ"..extension]["EQ3"][4] == " " then return end	--Les infos du jour à jour
	
	--Update pour les tooltip lors d'un reset
	if extension == "Legion" then
		local addonresetflag = TracerDB.Reset["EQresetLegion"];
		if addonresetflag ~= 0 then
			while(addonresetflag ~= 0) do
				for key, value in pairs(TracerDB.Toons) do 
					if key ~= TracerData.thisToon then
						value.Quests["EQLegion"]["EQ"..(4-addonresetflag)] = TracerDB.Toons[TracerData.thisToon]["Quests"]["EQLegion"]["EQ"..(4-addonresetflag)];
					end
				end
				addonresetflag = addonresetflag-1;				
			end			
		end
		TracerDB.Reset["EQresetLegion"] = 0;	
	else
		local addonresetflag = TracerDB.Reset["EQresetBfA"..UnitFactionGroup("player")];
		if addonresetflag ~= 0 then
			while(addonresetflag ~= 0) do
				for key, value in pairs(TracerDB.Toons) do 
					if (key ~= TracerData.thisToon) and value["Faction"] == UnitFactionGroup("player") then
						value.Quests["EQBfA"]["EQ"..(4-addonresetflag)] = TracerDB.Toons[TracerData.thisToon]["Quests"]["EQBfA"]["EQ"..(4-addonresetflag)];
					end
				end
				addonresetflag = addonresetflag-1;
			end
		end
		TracerDB.Reset["EQresetBfA"..UnitFactionGroup("player")] = 0;	
	end
end

-- ----------------------------------------------------------------------------------------------------------
-- ----------------- Display/Anchors  -----------------------------------------------------------------------
-- ----------------------------------------------------------------------------------------------------------

function TracerData.Function:UpdateAnchors()
	local heightline = TracerDB.Options.heightline;
	local k = 1;		
	local yOffset = 0;
	local AnchorLine = TracerData.Headers[1];
	local flag = false;
	
	--Cacher la ligne du daily donjon héro
	TracerDB.Options.DisplayLine[1][3][1] = false;
	-- for index, value in ipairs(TracerData.ListToons) do
		-- if TracerDB.Toons[value]["Quests"]["HD"] == 1 then
			-- flag = true;
		-- end
	-- end
	-- if not flag then
		-- TracerDB.Options.DisplayLine[1][3][1] = false;
	-- end
	
	flag = false;	
	--Pour le MC
	for index, value in ipairs(TracerData.ListToons) do
		if TracerDB.Toons[value]["Quests"]["MC"] == 0 then
			flag = true;
		end
	end
	if not flag then
		TracerDB.Options.DisplayLine[1][5][1] = false;
	end
	
	flag = false;	
	--Vérouillages de raid : cacher les lignes si la catégories n'est pas affichée
	-- if not TracerDB.Options.DisplayHeader[6] then
		-- for index, value in ipairs(TracerDB.ListLine[6]) do
			-- TracerDB.Options.DisplayLine[6][index][1] = false;
		-- end
	-- end
	
	flag = false;
	-- Réputations
	-- for index, value in ipairs(TracerDB.ListLine[5]) do
		-- if value == " " then
			-- TracerDB.Options.DisplayLine[5][index][1] = false;
		-- end
	-- end
	
	--Ancrage de l'header 1
	TracerData.Headers[1]:ClearAllPoints()
	TracerData.Headers[1]:SetPoint("TOPLEFT", UIParent, "BOTTOMLEFT", TracerDB.Options.anchorleft, TracerDB.Options.anchortop);	
	
	--Ancrage des headers (sauf le 1) et lignes
	local i = 0;	--numéro de la catégorie à ancrer
	local count = 0;	--nombre de lignes affichées
	for index, value in ipairs(TracerData.windowsorder) do
		i = value;
		if TracerData.Headers[i] ~= nil then
			count = 0;
			if (not TracerDB.Options.DisplayHeader[i]) and (i ~= 1) then
				TracerData.Headers[i]:Hide();								--Cache de l'header
				for j=1, #TracerDB.ListLine[i], 1 do 
					TracerData.Lines[i][j]:Hide();							--Cache de l'en-tête des lignes
					for index=1, ToonsFrameCount, 1 do
						if TracerData.Lines[i]["Toon"..index] then
							TracerData.Lines[i]["Toon"..index][j]:Hide();	--Cache des cadres des Toons
						end
					end	
				end
			else
				--Pour le header (sauf le premier)
				if i ~= 1 then
					k = k + 1;	--Ligne supplémentaire
					TracerData.Headers[i]:Show();							--Affichage de l'header
					TracerData.Headers[i]:ClearAllPoints();
					TracerData.Headers[i]:SetPoint("TOPLEFT", TracerData.Headers[1], "TOPLEFT", 0, yOffset);
					AnchorLine = TracerData.Headers[i];
				end
				--Pour les lignes
				for j=1, #TracerDB.ListLine[i], 1 do
					if TracerDB.Options.DisplayLine[i][j][1] and (not TracerDB.Options.Reduction[i]) then						
						count = count + 1;
						k = k + 1;										--Ligne supplémentaire
						TracerData.Lines[i][j]:ClearAllPoints()
						TracerData.Lines[i][j]:SetPoint("TOPLEFT", AnchorLine, "BOTTOMLEFT", 0, 0);
						TracerData.Lines[i][j]:Show();						--Affichage de l'en-tête
						for index=1, ToonsFrameCount, 1 do
							if (index >= TracerDB.Options.Page*10-9) and (index <= TracerDB.Options.Page*10) then
								--Affichage des cadres des Toons de la page en cours
								if TracerData.Lines[i]["Toon"..index] then
									TracerData.Lines[i]["Toon"..index][j]:Show();	
								end							
							else
							--Cache des cadres des Toons des autres page
								--Affichage des cadres des Toons de la page en cours
								if TracerData.Lines[i]["Toon"..index] then
									TracerData.Lines[i]["Toon"..index][j]:Hide();	
								end														
							end
						end
						AnchorLine = TracerData.Lines[i][j];						
					else
						TracerData.Lines[i][j]:Hide();						--Cache de l'en-tête
						for index=1, ToonsFrameCount, 1 do
							if TracerData.Lines[i]["Toon"..index] then
								TracerData.Lines[i]["Toon"..index][j]:Hide();	--Cache des cadres des Toons
							end
						end						
					end			
				end
				--Bouton de réduction
				if (not TracerDB.Options.DisplayHeader[i]) then
					TracerData.Buttons[i.."minus"]:Hide();
					TracerData.Buttons[i.."plus"]:Hide();								
				elseif count ~= 0 then
					TracerData.Buttons[i.."minus"]:Show();
					TracerData.Buttons[i.."plus"]:Hide();								
				else
					TracerData.Buttons[i.."minus"]:Hide();
					TracerData.Buttons[i.."plus"]:Show();
				end
			end
			AnchorLine = TracerData.Headers[1];
			yOffset = yOffset-k*heightline;
			k = 0;
		end
	end	
end

function TracerData.Function:DisplayDF()
	TracerDB.Options.displayWindow = 6;	
		
	TracerDB.Options.DisplayHeader[2] = false;	--Catégorie BfA à cacher
	TracerDB.Options.DisplayHeader[3] = false;	--Catégorie Legion à cacher	
	TracerDB.Options.DisplayHeader[4] = true;	--Catégorie Monnaie à afficher	
	TracerDB.Options.DisplayHeader[5] = true;	--Catégorie Réputation à afficher
	TracerDB.Options.DisplayHeader[6] = true;	--Catégorie Vérouillages de raids à afficher
	TracerDB.Options.DisplayHeader[9] = false;	--Catégorie Shadowlands à cacher
	TracerDB.Options.DisplayHeader[10] = false;	--Catégorie PVP à cacher	
	TracerDB.Options.DisplayHeader[13] = true;	--Catégorie DF à afficher
	
	--Catégorie de DF, afficher toutes les lignes
	for index, value in ipairs(TracerDB.Options.DisplayLine[13]) do
		value[1] = true;
		value[2] = true;
	end		
	--Afficher les monnaies de DF
	for index, value in ipairs(TracerDB.Currencies) do
		if value[3] == "DF" then
			TracerDB.Options.DisplayLine[4][index][1] = true;
			TracerDB.Options.DisplayLine[4][index][2] = true;
		else
			TracerDB.Options.DisplayLine[4][index][1] = false;		
			TracerDB.Options.DisplayLine[4][index][2] = false;
		end
	end
	--Afficher les réputations de DF
	for index, value in ipairs(TracerDB.Factions) do
		if value[3] == "DF" then
			TracerDB.Options.DisplayLine[5][index][1] = true;
			TracerDB.Options.DisplayLine[5][index][2] = true;
		else
			TracerDB.Options.DisplayLine[5][index][1] = false;		
			TracerDB.Options.DisplayLine[5][index][2] = false;
		end
	end
	
	--Ancrage
	TracerData.Function:UpdateAnchors();
	--Mise à jour des réputations
	TracerData.Function:WindowUpdateReputations();
end

function TracerData.Function:DisplayCustom()
	TracerDB.Options.displayWindow = 1;	
	for index, value in ipairs(TracerDB.Options.Custom.DisplayHeader) do	
		TracerDB.Options.DisplayHeader[index] = value;	
	end
	for index, value in ipairs(TracerDB.Options.Custom.DisplayLine) do
		for index1, value1 in ipairs(value) do
			TracerDB.Options.DisplayLine[index][index1][1] = value1[1];
			TracerDB.Options.DisplayLine[index][index1][2] = value1[2];			
		end	
	end	
	
	--Ancrage	
	TracerData.Function:UpdateAnchors();
	--Mise à jour des réputations
	TracerData.Function:WindowUpdateReputations();	
end

function TracerData.Function:DisplaySL()
	TracerDB.Options.displayWindow = 5;	
		
	TracerDB.Options.DisplayHeader[2] = false;	--Catégorie BfA à cacher
	TracerDB.Options.DisplayHeader[3] = false;	--Catégorie Legion à cacher	
	TracerDB.Options.DisplayHeader[4] = true;	--Catégorie Monnaie à afficher	
	TracerDB.Options.DisplayHeader[5] = true;	--Catégorie Réputation à afficher
	TracerDB.Options.DisplayHeader[6] = true;	--Catégorie Vérouillages de raids à afficher
	TracerDB.Options.DisplayHeader[9] = true;	--Catégorie Shadowlands à cacher
	TracerDB.Options.DisplayHeader[10] = true;	--Catégorie PVP à afficher	
	TracerDB.Options.DisplayHeader[13] = false;	--Catégorie DF à cacher
	
	--Catégorie de SL, afficher toutes les lignes
	for index, value in ipairs(TracerDB.Options.DisplayLine[9]) do
		value[1] = true;
		value[2] = true;
	end		
	--Afficher les monnaies de SL
	for index, value in ipairs(TracerDB.Currencies) do
		if value[3] == "SL" then
			TracerDB.Options.DisplayLine[4][index][1] = true;
			TracerDB.Options.DisplayLine[4][index][2] = true;
		else
			TracerDB.Options.DisplayLine[4][index][1] = false;		
			TracerDB.Options.DisplayLine[4][index][2] = false;
		end
	end
	--Afficher les réputations de SL
	for index, value in ipairs(TracerDB.Factions) do
		if value[3] == "SL" then
			TracerDB.Options.DisplayLine[5][index][1] = true;
			TracerDB.Options.DisplayLine[5][index][2] = true;
		else
			TracerDB.Options.DisplayLine[5][index][1] = false;		
			TracerDB.Options.DisplayLine[5][index][2] = false;
		end
	end
	--Afficher le PVP
	TracerDB.Options.DisplayLine[10][1][1] = true;		
	TracerDB.Options.DisplayLine[10][1][2] = true;
	
	--Ancrage	
	TracerData.Function:UpdateAnchors();
	--Mise à jour des réputations
	TracerData.Function:WindowUpdateReputations();
end

function TracerData.Function:DisplayBfA()
	TracerDB.Options.displayWindow = 2;	
		
	TracerDB.Options.DisplayHeader[2] = true;	--Catégorie BfA à afficher
	TracerDB.Options.DisplayHeader[3] = false;	--Catégorie Legion à cacher	
	TracerDB.Options.DisplayHeader[4] = true;	--Catégorie Monnaie à afficher	
	TracerDB.Options.DisplayHeader[5] = true;	--Catégorie Réputation à afficher
	TracerDB.Options.DisplayHeader[6] = true;	--Catégorie Vérouillages de raids à afficher
	TracerDB.Options.DisplayHeader[9] = false;	--Catégorie Shadowlands à cacher
	TracerDB.Options.DisplayHeader[10] = false;	--Catégorie PVP à cacher
	TracerDB.Options.DisplayHeader[13] = false;	--Catégorie DF à cacher	
	
	--Catégorie de BfA, afficher toutes les lignes
	for index, value in ipairs(TracerDB.Options.DisplayLine[2]) do
		value[1] = true;
		value[2] = true;
	end		
	--Afficher les monnaies de BfA
	for index, value in ipairs(TracerDB.Currencies) do
		if value[3] == "BfA" then
			TracerDB.Options.DisplayLine[4][index][1] = true;
			TracerDB.Options.DisplayLine[4][index][2] = true;
		else
			TracerDB.Options.DisplayLine[4][index][1] = false;		
			TracerDB.Options.DisplayLine[4][index][2] = false;
		end
	end
	--Afficher les réputations de BfA
	for index, value in ipairs(TracerDB.Factions) do
		if value[3] == "BfA" then
			TracerDB.Options.DisplayLine[5][index][1] = true;
			TracerDB.Options.DisplayLine[5][index][2] = true;
		else
			TracerDB.Options.DisplayLine[5][index][1] = false;		
			TracerDB.Options.DisplayLine[5][index][2] = false;
		end
	end
	
	--Ancrage	
	TracerData.Function:UpdateAnchors();
	--Mise à jour des réputations
	TracerData.Function:WindowUpdateReputations();	
end

function TracerData.Function:DisplayLegion()
	TracerDB.Options.displayWindow = 3;	
	
	TracerDB.Options.DisplayHeader[2] = false;	--Catégorie BfA à cacher
	TracerDB.Options.DisplayHeader[3] = true;	--Catégorie Legion à afficher	
	TracerDB.Options.DisplayHeader[4] = true;	--Catégorie Monnaie à afficher	
	TracerDB.Options.DisplayHeader[5] = true;	--Catégorie Réputation à afficher
	TracerDB.Options.DisplayHeader[6] = true;	--Catégorie Vérouillages de raids à afficher	
	TracerDB.Options.DisplayHeader[9] = false;	--Catégorie Shadowlands à cacher
	TracerDB.Options.DisplayHeader[10] = false;	--Catégorie PVP à cacher	
	TracerDB.Options.DisplayHeader[13] = false;	--Catégorie DF à cacher
	
	--Catégorie de Legion, afficher toutes les lignes
	for index, value in ipairs(TracerDB.Options.DisplayLine[3]) do
		value[1] = true;
		value[2] = true;
	end		
	--Afficher les monnaies de Legion
	for index, value in ipairs(TracerDB.Currencies) do
		if value[3] == "Legion" then
			TracerDB.Options.DisplayLine[4][index][1] = true;
			TracerDB.Options.DisplayLine[4][index][2] = true;
		else
			TracerDB.Options.DisplayLine[4][index][1] = false;		
			TracerDB.Options.DisplayLine[4][index][2] = false;
		end
	end
	--Afficher les réputations de Legion
	for index, value in ipairs(TracerDB.Factions) do
		if value[3] == "Legion" then
			TracerDB.Options.DisplayLine[5][index][1] = true;
			TracerDB.Options.DisplayLine[5][index][2] = true;
		else
			TracerDB.Options.DisplayLine[5][index][1] = false;		
			TracerDB.Options.DisplayLine[5][index][2] = false;
		end
	end
	
	--Ancrage	
	TracerData.Function:UpdateAnchors();
	--Mise à jour des réputations
	TracerData.Function:WindowUpdateReputations();	
end

function TracerData.Function:DisplayWoD()
	TracerDB.Options.displayWindow = 4;
	
	TracerDB.Options.DisplayHeader[2] = false;	--Catégorie BfA à cacher
	TracerDB.Options.DisplayHeader[3] = false;	--Catégorie Legion à cacher	
	TracerDB.Options.DisplayHeader[4] = true;	--Catégorie Monnaie à afficher	
	TracerDB.Options.DisplayHeader[5] = true;	--Catégorie Réputation à afficher
	TracerDB.Options.DisplayHeader[6] = true;	--Catégorie Vérouillages de raids à afficher	
	TracerDB.Options.DisplayHeader[9] = false;	--Catégorie Shadowlands à cacher
	TracerDB.Options.DisplayHeader[10] = false;	--Catégorie PVP à cacher
	TracerDB.Options.DisplayHeader[13] = false;	--Catégorie DF à cacher
	
	--Catégorie de WoD, afficher toutes les lignes
		
	--Afficher les monnaies de WoD
	for index, value in ipairs(TracerDB.Currencies) do
		if value[3] == "WoD" then
			TracerDB.Options.DisplayLine[4][index][1] = true;
			TracerDB.Options.DisplayLine[4][index][2] = true;
		else
			TracerDB.Options.DisplayLine[4][index][1] = false;		
			TracerDB.Options.DisplayLine[4][index][2] = false;
		end
	end
	--Afficher les réputations de WoD
	for index, value in ipairs(TracerDB.Factions) do
		if value[3] == "WoD" then
			TracerDB.Options.DisplayLine[5][index][1] = true;
			TracerDB.Options.DisplayLine[5][index][2] = true;
		else
			TracerDB.Options.DisplayLine[5][index][1] = false;		
			TracerDB.Options.DisplayLine[5][index][2] = false;
		end
	end
	
	--Ancrage	
	TracerData.Function:UpdateAnchors();
	--Mise à jour des réputations
	TracerData.Function:WindowUpdateReputations();
end






