local TracerName, TracerData = ...

local ListToonsNew = {};
local rheader, gheader, bheader, theader = 0.63, 0.63, 0.63, 0.5;	--Couleur header
local rwindow, gwindow, bwindow, twindow = 0, 0, 0, 0.7;			--Couleur fond catégories
local info = {};

function TracerData.Function:Options()
	TracerData.ListOptions = {					--Fenêtres du menu options
		TracerData.L.Options["Affichage"],
		TracerData.L.Options["Persos"],
		TracerData.L.Options["Catégories"],		
		TracerData.L.Options["Infos"]
		};
		
	--Header
	TracerData.Options["OptionsH"] = TracerData.Function:CreateFrameOne("OptionsHeader", UIParent, UIParent, 600, TracerDB.Options.heightline, "CENTER", "CENTER", 0, 800, rheader, gheader, bheader, theader, "CENTER", "CENTER", 50, 0, TracerData.ListOptions[1]);
	TracerData.Options["OptionsH"]:SetFrameStrata("FULLSCREEN");
	TracerData.Options["OptionsH"]:Hide();
	--Déplacement de la fenêtre
	TracerData.Options["OptionsH"]:SetScript("OnMouseDown", function() 
		TracerData.Options["OptionsH"]:SetMovable(true); --Autorisation de déplacer la fenêtre
		TracerData.Options["OptionsH"]:StartMoving();
		end) --Autorisation
	TracerData.Options["OptionsH"]:SetScript("OnMouseUp", function() 
		TracerData.Options["OptionsH"]:StopMovingOrSizing();		
		end) --Blocage
	--Bouton Fermer
	TracerData.Buttons.CloseOptions = CreateFrame("Button", "TracerCloseOptionsButton", TracerData.Options["OptionsH"], "GameMenuButtonTemplate");
	TracerData.Buttons.CloseOptions:SetPoint("BOTTOMRIGHT", TracerData.Options["OptionsH"], "TOPRIGHT", 0, 5);
	TracerData.Buttons.CloseOptions:SetSize(15, 15);
	TracerData.Buttons.CloseOptions:SetNormalTexture("Interface\\AddOns\\Tracer\\Fonts\\close_normal");	
	TracerData.Buttons.CloseOptions:SetScript("OnClick", function()
		TracerData.Function:OptionsTracer();
		end);	
	
	--Fenêtre de sélection
	TracerData.Options["OptionsS"] = TracerData.Function:CreateFrameOne("OptionsSelection", TracerData.Options.OptionsH, TracerData.Options.OptionsH, 100, 640, "TOPLEFT", "BOTTOMLEFT", 0, 0, rheader, gheader, bheader, theader, "CENTER", "CENTER", 0, 0, nil);
	TracerData.Options["OptionsS"]:SetFrameStrata("FULLSCREEN");
	local yOffset = 0;
	for index, value in ipairs(TracerData.ListOptions) do
		--Fenêtres
		TracerData.Options["W"..index] = TracerData.Function:CreateFrameOne("OptionsW"..index, TracerData.Options["OptionsH"], TracerData.Options["OptionsS"], 500, 640, "TOPLEFT", "TOPRIGHT", 0, 0, 0, 0, 0, 0.8, "CENTER", "CENTER", 0, 0, nil);
		TracerData.Options["W"..index]:SetFrameStrata("FULLSCREEN");
		TracerData.Options["W"..index]:Hide();
		--Boutons
		TracerData.Options["B"..index] = CreateFrame("Button", "OptionsB"..index, TracerData.Options["OptionsS"], "GameMenuButtonTemplate");
		TracerData.Options["B"..index]:SetPoint("TOP", TracerData.Options["OptionsS"], "TOP", 0, yOffset);
		TracerData.Options["B"..index]:SetSize(75, 20);
		TracerData.Options["B"..index]:SetText(value);
		TracerData.Options["B"..index]:SetScript("OnClick", function(self, button, down)
			TracerData.Function:OptionsButtons(self, button, down, index);
			end);
		yOffset = yOffset - 25;
	end
	
	TracerData.Function:OptionsAffichage();
	TracerData.Function:OptionsCategories();
	TracerData.Function:OptionsPersos();
	TracerData.Function:OptionsInfos();
	TracerData.Function:DDMCreationList(); --(pour crée les DDM des monnaies et réputations)	
end

function TracerData.Function:OptionsButtons(self, button, down, index)
	--Pour faire apparaître la bonne fenêtre
	local id = self:GetName();
	id = string.sub(id,9)
	for i=1, #TracerData.ListOptions, 1 do
		if i == tonumber(id) then
			TracerData.Options["W"..i]:Show();
			TracerData.Options.OptionsH.Title:SetText(TracerData.ListOptions[tonumber(id)]);
		else
			TracerData.Options["W"..i]:Hide();
		end
	end
	--Spécificité suivant la fenêtre
	if index == 2 then
		TracerData.Function:ListToonsNewCreation();
		TracerData.Function:DisplayToonsOptions();
	end
	if index == 3 then
		TracerData.Function:DisplayCustom();				
	end 
end


--1er Onglet - Affichage
function TracerData.Function:OptionsAffichage()	
	--CheckButton "Afficher à la connexion" (DisplayStart)
	TracerData.CB["DisplayStart"] = CreateFrame("CheckButton", "CBDisplayStart", TracerData.Options["W1"], "ChatConfigCheckButtonTemplate");
	TracerData.CB["DisplayStart"]:SetPoint("TOPLEFT", TracerData.Options["W1"], "TOPLEFT", 10, -8);
	TracerData.CB["DisplayStart"]["Title"] = TracerData.CB["DisplayStart"]:CreateFontString(nil, "OVERLAY");
	TracerData.CB["DisplayStart"]["Title"]:SetPoint("LEFT", TracerData.CB["DisplayStart"], "RIGHT", 5, 0);
	TracerData.CB["DisplayStart"]["Title"]:SetFont("Fonts\\FRIZQT__.TTF", TracerDB.Options.police);
	TracerData.CB["DisplayStart"]["Title"]:SetText(TracerData.L.Options["Afficher à la connexion"]);
	TracerData.CB["DisplayStart"]:SetChecked(TracerDB.Options.displayStart);
	TracerData.CB["DisplayStart"]:SetScript("OnClick", function()
		if TracerData.CB["DisplayStart"]:GetChecked() then
			TracerDB.Options.displayStart = true;
		else
			TracerDB.Options.displayStart = false;		
		end
		end);
	--CheckButton "Bouton sur la minimap" (MinimapButton)
	TracerData.CB["MinimapButton"] = CreateFrame("CheckButton", "CBMinimapButton", TracerData.CB["DisplayStart"], "ChatConfigCheckButtonTemplate");
	TracerData.CB["MinimapButton"]:SetPoint("TOPLEFT", TracerData.CB["DisplayStart"], "BOTTOMLEFT", 0, -10);
	TracerData.CB["MinimapButton"]["Title"] = TracerData.CB["MinimapButton"]:CreateFontString(nil, "OVERLAY");
	TracerData.CB["MinimapButton"]["Title"]:SetPoint("LEFT", TracerData.CB["MinimapButton"], "RIGHT", 5, 0);
	TracerData.CB["MinimapButton"]["Title"]:SetFont("Fonts\\FRIZQT__.TTF", TracerDB.Options.police);
	TracerData.CB["MinimapButton"]["Title"]:SetText(TracerData.L.Options["Icône sur la minimap"]);
	TracerData.CB["MinimapButton"]:SetChecked(TracerDB.Options.minimap);
	TracerData.CB["MinimapButton"]:SetScript("OnClick", function()
		if TracerData.CB["MinimapButton"]:GetChecked() then
			TracerDB.Options.minimap = true;
			LibStub("LibDBIcon-1.0"):Show(TracerName)
		else
			TracerDB.Options.minimap = false;	
			LibStub("LibDBIcon-1.0"):Hide(TracerName)
		end
		end);		
		
		
	--Bouton reset de la position de la fenêtre
	TracerData.Buttons["Resetsize"] = CreateFrame("Button", "ResetSizeButton", TracerData.Options["W1"], "GameMenuButtonTemplate");
	TracerData.Buttons["Resetsize"]:SetPoint("TOPLEFT", TracerData.CB["MinimapButton"], "BOTTOMLEFT", 0, -10);
	TracerData.Buttons["Resetsize"]:SetSize(80, 20);
	TracerData.Buttons["Resetsize"]:SetText("Reset");
	TracerData.Buttons["Resetsize"]["Title"] = TracerData.Buttons["Resetsize"]:CreateFontString(nil, "OVERLAY");
	TracerData.Buttons["Resetsize"]["Title"]:SetFont("Fonts\\FRIZQT__.TTF", TracerDB.Options.police);
	TracerData.Buttons["Resetsize"]["Title"]:SetPoint("LEFT", TracerData.Buttons["Resetsize"], "RIGHT", 10, 0);
	TracerData.Buttons["Resetsize"]["Title"]:SetText(TracerData.L.Options["Reset de la position de la fenêtre"]);	
	TracerData.Buttons["Resetsize"]:SetScript("OnClick", function()
		--Fenêtre principale
		TracerData.Headers[1]:ClearAllPoints();
		TracerData.Headers[1]:SetPoint("CENTER", UIParent, "CENTER", 0, 200);		
		TracerDB.Options.anchorleft = TracerData.Headers[1]:GetLeft();
		TracerDB.Options.anchortop = TracerData.Headers[1]:GetTop();		
		TracerData.Headers[1]:Show();
		--ToonPanel
		TracerData.ToonPanel["Header"]:ClearAllPoints();
		TracerData.ToonPanel["Header"]:SetPoint("CENTER", UIParent, "CENTER", 0, 200);	
		TracerDB.Options.anchorlefttoonpanel = TracerData.Headers[1]:GetLeft();
		TracerDB.Options.anchortoptoonpanel = TracerData.Headers[1]:GetTop();		
		end);
		
	--Bouton reset database
	TracerData.Buttons["ResetDB"] = CreateFrame("Button", "CBResetDB", TracerData.Options["W1"], "GameMenuButtonTemplate");
	TracerData.Buttons["ResetDB"]:SetPoint("TOPLEFT", TracerData.Buttons["Resetsize"], "BOTTOMLEFT", 0, -50);
	TracerData.Buttons["ResetDB"]:SetSize(80, 20);
	TracerData.Buttons["ResetDB"]:SetText("Reset");
	TracerData.Buttons["ResetDB"]["Title"] = TracerData.Buttons["ResetDB"]:CreateFontString(nil, "OVERLAY");
	TracerData.Buttons["ResetDB"]["Title"]:SetFont("Fonts\\FRIZQT__.TTF", TracerDB.Options.police);
	TracerData.Buttons["ResetDB"]["Title"]:SetPoint("LEFT", TracerData.Buttons["ResetDB"], "RIGHT", 10, 0);
	TracerData.Buttons["ResetDB"]["Title"]:SetText(TracerData.L.Options["Reset de la base de données"]);	
	TracerData.Buttons["ResetDB"]:SetScript("OnClick", function()
		TracerDB.Version = 1;
		ReloadUI();
		end);
end


--2e onglet - Perso
function TracerData.Function:OptionsPersos() --2e onglet
	TracerData.Options["W2"]["Title2"] = TracerData.Options["W2"]:CreateFontString(nil, "OVERLAY");
	TracerData.Options["W2"]["Title2"]:SetFont("Fonts\\FRIZQT__.TTF", TracerDB.Options.police);
	TracerData.Options["W2"]["Title2"]:SetPoint("TOPLEFT", TracerData.Options["W2"], "TOPLEFT", 10, -12);
	TracerData.Options["W2"]["Title2"]:SetText(TracerData.L.Options["Sélection des personnages"]);

	--Création du bouton pour afficher le DDM de l'affichage ou non d'un perso
	TracerData.Buttons["DDMToonSelection"] = CreateFrame("Button", "DDMRealmSelectionButton", TracerData.Options["W2"], "GameMenuButtonTemplate");
	TracerData.Buttons["DDMToonSelection"]:SetPoint("LEFT", TracerData.Options["W2"]["Title2"], "RIGHT", 20, 0);
	TracerData.Buttons["DDMToonSelection"]:SetSize(100, 20);
	TracerData.Buttons["DDMToonSelection"]:SetText(TracerData.L.Options["Sélection"]);
	TracerData.Buttons["DDMToonSelection"]:SetScript("OnClick", function(self, button, down)
		TracerData.Function:DDMToonSelection_OnClick(self, button, down);
		end);
	if TracerDB.ToonsCount > TracerData.CharactersLimit then
		TracerData.Buttons["DDMToonSelection"]:Disable();
	else
		TracerData.Buttons["DDMToonSelection"]:Enable();
	end
	--Création de la frame du DDM
	TracerData.DDM.DDMToonSelection = CreateFrame("Frame" , "DDMToonSelection", nil, "UIDropDownMenuTemplate");
	TracerData.DDM.DDMToonSelection:SetFrameStrata("FULLSCREEN_DIALOG");
	TracerData.DDM.DDMToonSelection.displayMode = "MENU";
	UIDropDownMenu_Initialize(TracerData.DDM.DDMToonSelection, function(self, level, menuList) TracerData.Function:DDMToonSelection_Initialize(self, level) end);

	TracerData.Options["W2"]["Title3"] = TracerData.Options["W2"]:CreateFontString(nil, "OVERLAY");
	TracerData.Options["W2"]["Title3"]:SetFont("Fonts\\FRIZQT__.TTF", TracerDB.Options.police);
	TracerData.Options["W2"]["Title3"]:SetPoint("TOPLEFT", TracerData.Options["W2"]["Title2"], "BOTTOMLEFT", 0, -12);
	TracerData.Options["W2"]["Title3"]:SetText(TracerData.L.Options["Supprimer un personnage"]);
	
	--Création du bouton pour afficher le DDM de la suppression d'un perso
	TracerData.Buttons["DDMToonDelete"] = CreateFrame("Button", "DDMToonDelete", TracerData.Options["W2"], "GameMenuButtonTemplate");
	TracerData.Buttons["DDMToonDelete"]:SetPoint("LEFT", TracerData.Options["W2"]["Title3"], "RIGHT", 20, 0);
	TracerData.Buttons["DDMToonDelete"]:SetSize(100, 20);
	TracerData.Buttons["DDMToonDelete"]:SetText(TracerData.L.Options["Sélection"]);
	TracerData.Buttons["DDMToonDelete"]:SetScript("OnClick", function(self, button, down)
		TracerData.Function:DDMToonDelete_OnClick(self, button, down);
		end);
	--Création de la frame du DDM
	TracerData.DDM.DDMToonDelete = CreateFrame("Frame" , "DDMToonDelete", nil, "UIDropDownMenuTemplate");
	TracerData.DDM.DDMToonDelete:SetFrameStrata("FULLSCREEN_DIALOG");
	TracerData.DDM.DDMToonDelete.displayMode = "MENU";
	UIDropDownMenu_Initialize(TracerData.DDM.DDMToonDelete, function(self, level, menuList) TracerData.Function:DDMToonDelete_Initialize(self, level) end);
	
	--Gestion de l'ordre des Toons
	TracerData.Options["W2"]["Title4"] = TracerData.Options["W2"]:CreateFontString(nil, "OVERLAY");
	TracerData.Options["W2"]["Title4"]:SetFont("Fonts\\FRIZQT__.TTF", TracerDB.Options.police);
	TracerData.Options["W2"]["Title4"]:SetPoint("TOPLEFT", TracerData.Options["W2"]["Title3"], "BOTTOMLEFT", 0, -15);
	TracerData.Options["W2"]["Title4"]:SetText(TracerData.L.Options["Ordre de l'affichage"]);
	
	--Création de l'affichage des frames pour l'ordre des ToonsCount
	local yOffset = -12;
	local name ;	
	--Bouton + Zone de texte colonne de gauche
	for i=1, 25 do
		--Bouton pour monter le toon
		name = "ToonUp"..i;
		TracerData.Buttons[name] = CreateFrame("Button", name.."Button", TracerData.Options["W2"]);
		TracerData.Buttons[name]:SetSize(25, 25);
		TracerData.Buttons[name]:SetPoint("TOPLEFT", TracerData.Options["W2"]["Title4"], "BOTTOMLEFT", 5, yOffset);
		TracerData.Buttons[name]:SetNormalTexture("Interface\\AddOns\\Tracer\\Fonts\\UI-ScrollBar-ScrollUpButton-Up");
		TracerData.Buttons[name]:SetPushedTexture("Interface\\AddOns\\Tracer\\Fonts\\UI-ScrollBar-ScrollUpButton-Down");
		TracerData.Buttons[name]:SetHighlightTexture("Interface\\AddOns\\Tracer\\Fonts\\UI-ScrollBar-Button-Overlay");	
		TracerData.Buttons[name]:SetScript("OnClick", function(self)
			TracerData.Function:MoveToon("up", i);
			end)
		--Bouton pour descendre le toon
		name = "ToonDown"..i;
		TracerData.Buttons[name] = CreateFrame("Button", name.."Button", TracerData.Options["W2"]);
		TracerData.Buttons[name]:SetSize(25, 25);
		TracerData.Buttons[name]:SetPoint("LEFT", TracerData.Buttons["ToonUp"..i], "RIGHT", -2, 0);
		TracerData.Buttons[name]:SetNormalTexture("Interface\\AddOns\\Tracer\\Fonts\\UI-ScrollBar-ScrollDownButton-Up");
		TracerData.Buttons[name]:SetPushedTexture("Interface\\AddOns\\Tracer\\Fonts\\UI-ScrollBar-ScrollDownButton-Down");
		TracerData.Buttons[name]:SetHighlightTexture("Interface\\AddOns\\Tracer\\Fonts\\UI-ScrollBar-Button-Overlay");				
		TracerData.Buttons[name]:SetScript("OnClick", function(self)
			TracerData.Function:MoveToon("down", i);
			end)			
		--Titre
		TracerData.Options["W2"]["TitleToon"..i] = TracerData.Options["W2"]:CreateFontString(nil, "OVERLAY");
		TracerData.Options["W2"]["TitleToon"..i]:SetFont("Fonts\\FRIZQT__.TTF", TracerDB.Options.police);
		if i == 1 then
			TracerData.Options["W2"]["TitleToon"..i]:SetPoint("LEFT", TracerData.Buttons["ToonDown"..i], "RIGHT", 3, 0);
		else
			TracerData.Options["W2"]["TitleToon"..i]:SetPoint("LEFT", TracerData.Buttons["ToonUp"..i], "RIGHT", 25, 0);
		end
		
		yOffset = yOffset - 20;		
	end
	yOffset = -12;
	--Bouton + Zone de texte colonne de droite
	for i=26, 50 do
		--Bouton pour monter le toon
		name = "ToonUp"..i;
		TracerData.Buttons[name] = CreateFrame("Button", name.."Button", TracerData.Options["W2"]);
		TracerData.Buttons[name]:SetSize(25, 25);
		TracerData.Buttons[name]:SetPoint("TOPLEFT", TracerData.Options["W2"]["Title4"], "BOTTOMLEFT", 240, yOffset);
		TracerData.Buttons[name]:SetNormalTexture("Interface\\AddOns\\Tracer\\Fonts\\UI-ScrollBar-ScrollUpButton-Up");
		TracerData.Buttons[name]:SetPushedTexture("Interface\\AddOns\\Tracer\\Fonts\\UI-ScrollBar-ScrollUpButton-Down");
		TracerData.Buttons[name]:SetHighlightTexture("Interface\\AddOns\\Tracer\\Fonts\\UI-ScrollBar-Button-Overlay");	
		TracerData.Buttons[name]:SetScript("OnClick", function(self)
			TracerData.Function:MoveToon("up", i);
			end)
		--Bouton pour descendre le toon
		name = "ToonDown"..i;
		TracerData.Buttons[name] = CreateFrame("Button", name.."Button", TracerData.Options["W2"]);
		TracerData.Buttons[name]:SetSize(25, 25);
		TracerData.Buttons[name]:SetPoint("LEFT", TracerData.Buttons["ToonUp"..i], "RIGHT", -2, 0);
		TracerData.Buttons[name]:SetNormalTexture("Interface\\AddOns\\Tracer\\Fonts\\UI-ScrollBar-ScrollDownButton-Up");
		TracerData.Buttons[name]:SetPushedTexture("Interface\\AddOns\\Tracer\\Fonts\\UI-ScrollBar-ScrollDownButton-Down");
		TracerData.Buttons[name]:SetHighlightTexture("Interface\\AddOns\\Tracer\\Fonts\\UI-ScrollBar-Button-Overlay");			
		TracerData.Buttons[name]:SetScript("OnClick", function(self)
			TracerData.Function:MoveToon("down", i);
			end)			
		--Titre
		TracerData.Options["W2"]["TitleToon"..i] = TracerData.Options["W2"]:CreateFontString(nil, "OVERLAY");
		TracerData.Options["W2"]["TitleToon"..i]:SetFont("Fonts\\FRIZQT__.TTF", TracerDB.Options.police);			
		TracerData.Options["W2"]["TitleToon"..i]:SetPoint("LEFT", TracerData.Buttons["ToonUp"..i], "RIGHT", 25, 0);

		yOffset = yOffset - 20;		
	end	
		
	--Bouton Annuler
	TracerData.Buttons["SelectionToonsReset"] = CreateFrame("Button", "SelectionToonsResetButton", TracerData.Options["W2"], "GameMenuButtonTemplate");
	TracerData.Buttons["SelectionToonsReset"]:SetPoint("BOTTOMRIGHT", TracerData.Options["W2"], "BOTTOM", -10, 5);
	TracerData.Buttons["SelectionToonsReset"]:SetSize(100, 20);
	TracerData.Buttons["SelectionToonsReset"]:SetText(TracerData.L.Options["Annuler"]);
	TracerData.Buttons["SelectionToonsReset"]:SetScript("OnClick", function(self, button, down)
		TracerData.Function:ListToonsNewCreation();
		TracerData.Function:DisplayToonsOptions();
		end);	
	--Bouton reload
	TracerData.Buttons["SelectionToonsReload"] = CreateFrame("Button", "SelectionToonsReloadButton", TracerData.Options["W2"], "GameMenuButtonTemplate");
	TracerData.Buttons["SelectionToonsReload"]:SetPoint("BOTTOMLEFT", TracerData.Options["W2"], "BOTTOM", 10, 5);
	TracerData.Buttons["SelectionToonsReload"]:SetSize(100, 20);
	TracerData.Buttons["SelectionToonsReload"]:SetText(TracerData.L.Options["Actualiser"]);
	TracerData.Buttons["SelectionToonsReload"]:SetScript("OnClick", function(self, button, down)
		TracerData.Function:SaveDisplayToons();
		end);
end

function TracerData.Function:DDMToonSelection_Initialize(self, level)
	-- Liste des serveurs et des Toons	
	local ListRealm, ListRealmToons = TracerData.Function:ListRealmAndToons();

	wipe(info);
	if level == 1 then		
		--Titre de la DDM
		info.text = TracerData.L.Options["Serveurs"];
		info.isTitle = true;
		info.notCheckable = true;
		UIDropDownMenu_AddButton(info, level);
		info.isTitle = nil;
		info.disabled = nil; --car si is.Title détecté, il met automatiquement ca à true
		--Menu des serveurs
		for index, value in ipairs(ListRealm) do
			--On détermine s'il y a un perso à afficher
			local findcharacter = false;
			for index2, value2 in ipairs(ListToonsNew) do
				if (value2.realm == value) and not (value2.delete) then
					findcharacter = true;
				end
			end					
			if findcharacter then
				info.text = value;
				info.hasArrow = true;
				UIDropDownMenu_AddButton(info, level);
			end
		end	
		info.hasArrow = true;
		info.notCheckable = nil;
		-- Add a blank separator
        wipe(info);
        info.disabled = true;
        UIDropDownMenu_AddButton(info, level);
        info.disabled = nil;
		--Menu Fermer
		info.text = TracerData.L.Options["Fermer"]
		info.notCheckable = true;
		info.func = function() CloseDropDownMenus() end
		UIDropDownMenu_AddButton(info, level);
		info.func = nil;
		info.notCheckable = nil;
		
	elseif level == 2 then
		--Liste des persos par serveurs
		for key, value in ipairs(ListRealm) do	
			if (UIDROPDOWNMENU_MENU_VALUE == value) then
				for index1, value1 in ipairs(ListRealmToons[value]) do
					--Afficher un perso seulement s'il n'est pas delete
					local isdelete = false;
					for index2, value2 in ipairs(ListToonsNew) do
						if value2.name.." - "..value2.realm == value1.." - "..UIDROPDOWNMENU_MENU_VALUE then
							isdelete = value2.delete;
						end
					end										
					if not isdelete then					
						--Pour aller chercher la valeur du Display
						local todisplay = false;
						for index2, value2 in ipairs(ListToonsNew) do
							if value2.name.." - "..value2.realm == value1.." - "..UIDROPDOWNMENU_MENU_VALUE then
								todisplay = value2.display;
							end
						end				
										
						info.text = value1;
						info.isNotRadio = true;
						info.checked = todisplay;
						info.arg1 = value1;
						info.arg2 = UIDROPDOWNMENU_MENU_VALUE;
						info.func = function(name, arg1, arg2, checked) 
							TracerData.Function:SelectToon(name, arg1, arg2, checked); 
							end
						info.keepShownOnClick = true;
						UIDropDownMenu_AddButton(info, level);
					end
				end
			end
		end
		info.isNotRadio = nil;
		info.checked = nil;
		info.keepShownOnClick = nil;
	end
end

function TracerData.Function:DDMToonSelection_OnClick(self, button, down)
	local name = self:GetName();
	ToggleDropDownMenu(1, nil, TracerData.DDM.DDMToonSelection, name, 0, 0);
end

function TracerData.Function:DDMToonDelete_Initialize(self, level)
	-- Liste des serveurs et des Toons	
	local ListRealm, ListRealmToons = TracerData.Function:ListRealmAndToons();

	wipe(info);
	if level == 1 then		
		--Titre de la DDM
		info.text = TracerData.L.Options["Serveurs"];
		info.isTitle = true;
		info.notCheckable = true;
		UIDropDownMenu_AddButton(info, level);
		info.isTitle = nil;
		info.disabled = nil; --car si is.Title détecté, il met automatiquement ca à true
		--Menu des serveurs
		for index, value in ipairs(ListRealm) do
			--On détermine s'il y a un perso à afficher
			local findcharacter = false;
			for index2, value2 in ipairs(ListToonsNew) do
				if (value2.realm == value) and not (value2.delete) then
					findcharacter = true;
				end
			end					
			if findcharacter then
				info.text = value;
				info.hasArrow = true;
				UIDropDownMenu_AddButton(info, level);	
			end
		end	
		info.hasArrow = true;
		info.notCheckable = nil;
		-- Add a blank separator
        wipe(info);
        info.disabled = true;
        UIDropDownMenu_AddButton(info, level);
        info.disabled = nil;
		--Menu Fermer
		info.text = TracerData.L.Options["Fermer"]
		info.notCheckable = true;
		info.func = function() CloseDropDownMenus() end
		UIDropDownMenu_AddButton(info, level);
		info.func = nil;
		info.notCheckable = nil;
		
	elseif level == 2 then
		--Liste des persos par serveurs
		for key, value in ipairs(ListRealm) do	
			if (UIDROPDOWNMENU_MENU_VALUE == value) then
				for index1, value1 in ipairs(ListRealmToons[value]) do
					--Afficher un perso seulement s'il n'est pas delete
					local isdelete = false;
					for index2, value2 in ipairs(ListToonsNew) do
						if value2.name.." - "..value2.realm == value1.." - "..UIDROPDOWNMENU_MENU_VALUE then
							isdelete = value2.delete;
						end
					end										
					if not isdelete then										
						info.text = value1;
						info.arg1 = value1;
						info.arg2 = UIDROPDOWNMENU_MENU_VALUE;
						info.notCheckable = true;
						info.func = function(name, arg1, arg2, checked) 
							TracerData.Function:DeleteToon(name, arg1, arg2, checked); 
							end
						UIDropDownMenu_AddButton(info, level);	
					end
				end
				info.notCheckable = nil;
			end
		end
	end
end

function TracerData.Function:DDMToonDelete_OnClick(self, button, down)
	local name = self:GetName();
	ToggleDropDownMenu(1, nil, TracerData.DDM.DDMToonDelete, name, 0, 0);
end

--Création de la table pour gérer l'affichage des Toons
function TracerData.Function:ListToonsNewCreation()
	ListToonsNew = {};
	local ListToonsNewDisplay = {};
	local ListToonsNewNoDisplay = {};
	
	local kdisplay = 1;
	local knodisplay = 1;	
	for key, value in pairs(TracerDB.Toons) do
		if value.Display then
			ListToonsNewDisplay[kdisplay] = {
				order = value.Order, --rang du Toon
				name = value.Name, --Nom
				realm = value.Realm,	--Serveur
				display = value.Display,	--flag display
				delete = false,	--flag supprimer le toon
				};
			kdisplay = kdisplay+1;
		else
			ListToonsNewNoDisplay[knodisplay] = {
				order = value.Order, --rang du Toon
				name = value.Name, --Nom
				realm = value.Realm,	--Serveur
				display = value.Display,	--flag display
				delete = false,	--flag supprimer le toon
				};
			knodisplay = knodisplay+1;	
		end
	end
	
	if ListToonsNewDisplay[1] ~= nil then
		for index, value in ipairs(ListToonsNewDisplay) do
			table.insert(ListToonsNew, value);
		end
	end
	if ListToonsNewNoDisplay[1] ~= nil then	
		for index, value in ipairs(ListToonsNewNoDisplay) do
			table.insert(ListToonsNew, value);
		end	
	end
end

--Liste des Serveur et des Toons dans l'ordre alphabétique
function TracerData.Function:ListRealmAndToons()
-- ListToonsNew[k] = {
	-- order = value.Order --rang du Toon
	-- name = value.Name, --Nom
	-- realm = value.Realm,	--Serveur
	-- display = value.Display,	--flag display
	-- delete = false,	--flag supprimer le toon
	-- };
	if ListToonsNew[1] == nil then return end
	
	local ListRealm = {} ;			--Liste des serveurs dans l'ordre alphabétique
	local ListRealmToons = {} ;		--Liste des Toons par odre alphabétique par serveur
	local j = 1;
	
	--Liste des serveurs
	for index, value in ipairs(ListToonsNew) do
		ListRealm[j] = value["realm"];
		j = j+1;
	end
	--On enlève les doublons pour les serveurs
	table.sort(ListRealm);
	local ListRealm2 = {}
	for index, value in ipairs(ListRealm) do
		if value ~=	ListRealm[index+1] then
			table.insert(ListRealm2, value);
		end
	end
	ListRealm = ListRealm2 ;
	--Triage dans l'ordre Alphabétique
	table.sort(ListRealm);	
	--On complète la ListRealmToons avec les serveurs
	for index, value in ipairs(ListRealm) do
		ListRealmToons[value] = {};
	end
	--On complète les Toons dans chaques serveurs
	for key, value in pairs(TracerDB.Toons) do
		table.insert(ListRealmToons[value.Realm], value.Name);
	end
	--On tri dans l'ordre alphabétique les listes des Toons
	for key, value in pairs(ListRealmToons) do
		table.sort(value);
	end
	
	return ListRealm, ListRealmToons ;
end

--Fonction pour afficher la liste de Toons dans l'onglet perso
function TracerData.Function:DisplayToonsOptions()
	local numtoons = 0;
	for index, value in ipairs(ListToonsNew) do
		if (not value.delete) and (value.display) then
			numtoons = numtoons + 1;
		end
	end	
	TracerData.Options["W2"]["TitleToon"..1]:SetText(" ");
	
	if numtoons == 0 then return end
	
	--Texte
	for i=1, 50, 1 do
		if ListToonsNew[i] and (ListToonsNew[i]["display"]) then
			local value = TracerDB.Toons[ListToonsNew[i]["name"].." - "..ListToonsNew[i]["realm"]]
			local order = ListToonsNew[i]["order"];
			TracerData.Options["W2"]["TitleToon"..order]:SetTextColor(value["ClassColor"]["r"], value["ClassColor"]["g"], value["ClassColor"]["b"], 1);
			TracerData.Options["W2"]["TitleToon"..order]:SetText(ListToonsNew[i]["name"].." - "..ListToonsNew[i]["realm"]);
		elseif ListToonsNew[i] and not (ListToonsNew[i]["display"]) then
			local value = TracerDB.Toons[ListToonsNew[i]["name"].." - "..ListToonsNew[i]["realm"]]
			local order = ListToonsNew[i]["order"];
			TracerData.Options["W2"]["TitleToon"..order]:SetTextColor(1, 1, 1, 1);
			TracerData.Options["W2"]["TitleToon"..order]:SetText(" ");		
		else
			TracerData.Options["W2"]["TitleToon"..i]:SetTextColor(1, 1, 1, 1);
			TracerData.Options["W2"]["TitleToon"..i]:SetText(" ");
		end
	end

	--Boutons	
	--On affiche tous les boutons Down
	for i=1, 50, 1 do
		TracerData.Buttons["ToonDown"..i]:Show();	
		TracerData.Buttons["ToonUp"..i]:Show();		
	end	
	--On cache le Up du 1er toon
	TracerData.Buttons["ToonUp1"]:Hide();
	--On cache le Down du durnier toon
	TracerData.Buttons["ToonDown"..numtoons]:Hide();
	--Cache tous les autres boutons
	for i=numtoons+1, 50, 1 do
		TracerData.Buttons["ToonUp"..i]:Hide();
		TracerData.Buttons["ToonDown"..i]:Hide();	
	end
end

function TracerData.Function:SelectToon(name, toon, realm, checked)
	local orderdelete = 0; --Numéro de l'ordre du Toons changé
	local orderadd = 0; --Numéro de l'ordre du Toons ajouté	
	local orderold = 0; --Ancien numéro de l'ordre du Toons ajouté	
	--Flag display
	for index, value in ipairs(ListToonsNew) do	
		if value.name.." - "..value.realm == toon.." - "..realm then		
			if checked then
				--print("ajouter");
				value.display = true;
			else
				--print("enlever");
				value.display = false;
				orderdelete = value.order;				
			end
		end
	end
	
	if checked then
		--On déterminer l'ordre du nouveau Toon
		for i=1, 50, 1 do
			if TracerData.Options["W2"]["TitleToon"..i]:GetText() == " " then
				orderadd = i;
				break
			end
		end
		--On détermine l'ancien ordre du Toon
			for index, value in ipairs(ListToonsNew) do	
				if value.name.." - "..value.realm == toon.." - "..realm then		
					orderold = value.order;
				end
			end			
		--Décalage des ordres
		for i=1, 50, 1 do
			if ListToonsNew[i] and (ListToonsNew[i]["order"] >= orderadd) and (ListToonsNew[i]["order"] < orderold) then
				ListToonsNew[i]["order"] = ListToonsNew[i]["order"] + 1;
			end
		end		
		--On met l'ordre du toon ajouter
		for index, value in ipairs(ListToonsNew) do	
			if value.name.." - "..value.realm == toon.." - "..realm then		
				value.order = orderadd;
			end
		end
	else
		--Décalage des ordres
		for i=1, 50, 1 do
			if ListToonsNew[i] and ListToonsNew[i]["order"] >= orderdelete then
				ListToonsNew[i]["order"] = ListToonsNew[i]["order"] - 1;
			end
		end
		--On met l'ordre du toon enlever en dernier
		for index, value in ipairs(ListToonsNew) do	
			if value.name.." - "..value.realm == toon.." - "..realm then		
				value.order = #ListToonsNew;
			end
		end			
	end
	
	TracerData.Function:DisplayToonsOptions();
end

function TracerData.Function:DeleteToon(name, toon, realm, checked)	
	local orderdelete = 0;
	
	if not checked then
		--On détermine l'ordre du Toon supprimé
		for index, value in ipairs(ListToonsNew) do	
			if value.name.." - "..value.realm == toon.." - "..realm then		
				orderdelete = value.order;
			end
		end	
		--Décalage des ordres
		for i=1, 50, 1 do
			if ListToonsNew[i] and (ListToonsNew[i]["order"] > orderdelete) then
				ListToonsNew[i]["order"] = ListToonsNew[i]["order"] - 1;
			end
		end
		--On place le Toon a supprimé en dernier
		for index, value in ipairs(ListToonsNew) do	
			if value.name.." - "..value.realm == toon.." - "..realm then		
				value.order = #ListToonsNew;
			end
		end			
		--On supprime le Toon
		for index, value in ipairs(ListToonsNew) do	
			if value.name.." - "..value.realm == toon.." - "..realm then		
				value.delete = true;
				value.display = false;				
			end
		end

		TracerData.Function:DisplayToonsOptions();
	end
end

function TracerData.Function:MoveToon(sens, num)
	local ordermaster = num;
	local rankmaster = 0;	
	local orderslave = 0;	
	if sens == "up" then
		orderslave = ordermaster - 1;						
	else
		orderslave = ordermaster + 1;	
	end
 
	--Ordre du master Toon
	for index, value in ipairs(ListToonsNew) do	
		if value.order == ordermaster then		
			value.order = orderslave;
			rankmaster = index;					--a ce moment là, deux toons ont le même ordre
		end
	end
	--Ordre du slave Toon
	for index, value in ipairs(ListToonsNew) do	
		if (value.order == orderslave) and (rankmaster ~= index) then		
			value.order = ordermaster;
		end
	end
	TracerData.Function:DisplayToonsOptions();
end

function TracerData.Function:SaveDisplayToons()
	for index, value in ipairs(ListToonsNew) do
		-- Ordre
		TracerDB.Toons[value.name.." - "..value.realm]["Order"] = value.order
		-- Display
		TracerDB.Toons[value.name.." - "..value.realm]["Display"] = value.display
		-- Delete
		if value.delete then
			TracerDB.Toons[value.name.." - "..value.realm] = nil;
			TracerDB.ToonsCount = TracerDB.ToonsCount-1;
		end
	end	
	
	ReloadUI();
end


--3e onglet (Catégories)
function TracerData.Function:OptionsCategories()
	--CheckButton Affichage des fenêtres
	local yOffset = -8;
	for index, value in ipairs(TracerData.windowsorder) do
		TracerData.CB["Header"..value] = CreateFrame("CheckButton", "CBHeader"..value, TracerData.Options["W3"], "ChatConfigCheckButtonTemplate");
		TracerData.CB["Header"..value]:SetPoint("TOPLEFT", TracerData.Options["W3"], "TOPLEFT", 10, yOffset);
		TracerData.CB["Header"..value]["Title"] = TracerData.CB["Header"..value]:CreateFontString(nil, "OVERLAY");
		TracerData.CB["Header"..value]:SetChecked(TracerDB.Options.Custom.DisplayHeader[value]);
		TracerData.CB["Header"..value]["Title"]:SetFont("Fonts\\FRIZQT__.TTF", TracerDB.Options.police);
		TracerData.CB["Header"..value]["Title"]:SetPoint("LEFT", TracerData.CB["Header"..value], "RIGHT", 5, 0);
		TracerData.CB["Header"..value]["Title"]:SetText(TracerData.L.Headers[value]);
		TracerData.CB["Header"..value]:SetScript("OnClick", function()
			if TracerData.CB["Header"..value]:GetChecked() then
				TracerDB.Options.Custom.DisplayHeader[value] = true;
				TracerDB.Options.DisplayHeader[value] = true;
			else
				TracerDB.Options.Custom.DisplayHeader[value] = false;
				TracerDB.Options.DisplayHeader[value] = false;		
			end			
			TracerData.Function:UpdateAnchors();
			end)
		yOffset = yOffset - 35;
	end
	
	--CheckButton cas particulier
	TracerData.CB["Header1"]["Title"]:SetTextColor(0.5, 0.5, 0.5, 1);
	TracerData.CB["Header1"]:Disable();

	-- Création du bouton pour afficher le DDM de la sélection des lignes	
	for index, value in ipairs(TracerData.windowsorder) do
		TracerData.Buttons["DDMLineSelection"..value] = CreateFrame("Button", "DDMLineSelectionButton"..value, TracerData.Options["W3"], "GameMenuButtonTemplate");
		TracerData.Buttons["DDMLineSelection"..value]:SetPoint("LEFT", TracerData.CB["Header"..value], "LEFT", 300, 0);
		TracerData.Buttons["DDMLineSelection"..value]:SetSize(100, 20);
		TracerData.Buttons["DDMLineSelection"..value]:SetText(TracerData.L.Options["Sélection"]);
		TracerData.Buttons["DDMLineSelection"..value]:SetScript("OnClick", function(self, button, down)
			TracerData.Function:DDMLineSelection_OnClick(self, button, down, value);
			end);
	end	
	--Création des frame de DDM
	for index, value in ipairs(TracerData.windowsorder) do 
		TracerData.DDM["DDMLineSelection"..value] = CreateFrame("Frame" , "DDMLineSelection"..value, nil, "UIDropDownMenuTemplate");
		TracerData.DDM["DDMLineSelection"..value]:SetFrameStrata("FULLSCREEN_DIALOG");
		TracerData.DDM["DDMLineSelection"..value]["displayMode"] = "MENU";
		if (value == 4) or (value == 5) then
			UIDropDownMenu_Initialize(TracerData.DDM["DDMLineSelection"..value], function(self, level, menuList) TracerData.Function:DDMLineSelection_Initialize2(self, level, value) end);		
		else
			UIDropDownMenu_Initialize(TracerData.DDM["DDMLineSelection"..value], function(self, level, menuList) TracerData.Function:DDMLineSelection_Initialize(self, level, value) end);
		end
	end
end

function TracerData.Function:DDMLineSelection_Initialize(self, level, i)
	if TracerDB.Options.Custom.DisplayLine[i] then
		wipe(info);		
		--Titre de la DDM
			info.text = TracerData.L.Headers[i];
			info.isTitle = true;
			info.notCheckable = true;
			UIDropDownMenu_AddButton(info, level);
			info.isTitle = nil;
			info.disabled = nil; --car si is.Title détecté, il met automatiquement ca à true
		--Menu des catégories
			for index, value in ipairs(TracerDB.Options.Custom.DisplayLine[i]) do				
				info.notCheckable = false;
				--Gestion pour l'affichage des noms des raids
				if i == 6 then
					info.text = TracerData.RaidNameDDM[index];
				else
					info.text = TracerDB.ListLine[i][index];				
				end

				info.isNotRadio = true;
				info.checked = TracerDB.Options.Custom.DisplayLine[i][index][1];
				info.arg1 = i
				info.arg2 = index					
				info.func = function(name, arg1, arg2, checked)
					if checked then
						TracerDB.Options.Custom.DisplayLine[arg1][arg2][1] = true;
						TracerDB.Options.Custom.DisplayLine[arg1][arg2][2] = true;
						TracerDB.Options.DisplayLine[arg1][arg2][1] = true;
						TracerDB.Options.DisplayLine[arg1][arg2][2] = true;												
					else
						TracerDB.Options.Custom.DisplayLine[arg1][arg2][1] = false;
						TracerDB.Options.Custom.DisplayLine[arg1][arg2][2] = false;
						TracerDB.Options.DisplayLine[arg1][arg2][1] = false;
						TracerDB.Options.DisplayLine[arg1][arg2][2] = false;						
					end
					TracerData.Function:UpdateAnchors();
					end;
				info.keepShownOnClick = true;
				UIDropDownMenu_AddButton(info, level);
			end
			info.isNotRadio = nil;
			info.checked = nil;
			info.keepShownOnClick = nil;
		-- Add a blank separator
			wipe(info);
			info.disabled = true;
			UIDropDownMenu_AddButton(info, level);
			info.disabled = nil;
		--Menu Fermer
			info.text = TracerData.L.Options["Fermer"]
			info.notCheckable = true;
			info.func = function() CloseDropDownMenus() end
			UIDropDownMenu_AddButton(info, level);
			info.func = nil;
			info.notCheckable = nil;
	end	
end

local ExtensionNameCurrencies = {"DF", "SL", "BfA", "Legion", "WoD", "Divers"};
local ListExtensionCurrencies = {};
local ExtensionNameReputations = {"DF", "SL", "BfA", "Legion", "WoD"};
local ListExtensionReputations = {};
function TracerData.Function:DDMCreationList()
	local extensionname = "";
	--Currencies
	for index, value in ipairs(ExtensionNameCurrencies) do
		ListExtensionCurrencies[value] = {};
	end
	for index, value in ipairs(TracerDB.Currencies) do
		extensionname = value[3];
		table.insert(ListExtensionCurrencies[extensionname],value[2])
	end
	--Reputations
	for index, value in ipairs(ExtensionNameReputations) do
		ListExtensionReputations[value] = {};
	end
	for index, value in ipairs(TracerDB.Factions) do
		extensionname = value[3];
		table.insert(ListExtensionReputations[extensionname],value[2])
	end	
end

function TracerData.Function:DDMLineSelection_Initialize2(self, level, i)
	local DataName1 = {};
	local DataName2 = {};
	if i == 4 then
		DataName1 = ExtensionNameCurrencies;
		DataName2 = ListExtensionCurrencies;
	elseif i == 5 then
		DataName1 = ExtensionNameReputations;
		DataName2 = ListExtensionReputations;	
	end
	if TracerDB.Options.Custom.DisplayLine[i] then
		wipe(info);	
			if level == 1 then		
			--Titre de la DDM
				info.text = TracerData.L.Headers[i];
				info.isTitle = true;
				info.notCheckable = true;
				UIDropDownMenu_AddButton(info, level);
				info.isTitle = nil;
				info.disabled = nil; --car si is.Title détecté, il met automatiquement ca à true
			--Menu des catégories
				for index, value in ipairs(DataName1) do				
					info.notCheckable = true;
					info.isNotRadio = true;
					info.hasArrow = true;
					info.text = value;					
					info.keepShownOnClick = true;
					UIDropDownMenu_AddButton(info, level);
				end
				info.isNotRadio = nil;
				info.checked = nil;
				info.keepShownOnClick = nil;
			end
			if level == 2 then
				for index, value in ipairs(DataName1) do
					if UIDROPDOWNMENU_MENU_VALUE == value then 
					--Titre de la DDM
						info.text = value;
						info.isTitle = true;
						info.notCheckable = true;
						UIDropDownMenu_AddButton(info, level);
						info.isTitle = nil;
						info.disabled = nil; --car si is.Title détecté, il met automatiquement ca à true
					--Menu des catégories						
						for index2, value2 in ipairs(DataName2[value]) do				
							info.notCheckable = false;
							info.isNotRadio = true;
							info.text = value2;
							info.keepShownOnClick = true;
							--Trouver la ligne
							if i == 4 then
								for index3, value3 in ipairs(TracerDB.Currencies) do
									if value2 == value3[2] then
										info.arg2 = index3;
									end
								end
							elseif i == 5 then
								for index3, value3 in ipairs(TracerDB.Factions) do
									if value2 == value3[2] then
										info.arg2 = index3;
									end
								end								
							end								
							info.arg1 = i
							info.checked = TracerDB.Options.Custom.DisplayLine[i][info.arg2][1];					
							info.func = function(name, arg1, arg2, checked)												
								if checked then
									TracerDB.Options.Custom.DisplayLine[arg1][arg2][1] = true;
									TracerDB.Options.Custom.DisplayLine[arg1][arg2][2] = true;
									TracerDB.Options.DisplayLine[arg1][arg2][1] = true;
									TracerDB.Options.DisplayLine[arg1][arg2][2] = true;	
									if i == 4 then
										TracerDB.Currencies[arg2][4] = true;
									end									
									if i == 5 then
										TracerDB.Factions[arg2][4] = true;
									end
								else
									TracerDB.Options.Custom.DisplayLine[arg1][arg2][1] = false;
									TracerDB.Options.Custom.DisplayLine[arg1][arg2][2] = false;
									TracerDB.Options.DisplayLine[arg1][arg2][1] = false;
									TracerDB.Options.DisplayLine[arg1][arg2][2] = false;
									if i == 4 then
										TracerDB.Currencies[arg2][4] = false;
									end										
									if i == 5 then
										TracerDB.Factions[arg2][4] = false;
									end									
								end
								TracerData.Function:UpdateAnchors();
								end;							
							UIDropDownMenu_AddButton(info, level);
						end
						info.isNotRadio = nil;
						info.checked = nil;
						info.keepShownOnClick = nil;
					end
				end				
			end
		-- Add a blank separator
			wipe(info);
			info.disabled = true;
			UIDropDownMenu_AddButton(info, level);
			info.disabled = nil;
		--Menu Fermer
			info.text = TracerData.L.Options["Fermer"]
			info.notCheckable = true;
			info.func = function() CloseDropDownMenus() end
			UIDropDownMenu_AddButton(info, level);
			info.func = nil;
			info.notCheckable = nil;
	end	
end

function TracerData.Function:DDMLineSelection_OnClick(self, button, down, i)
	local name = self:GetName();
	ToggleDropDownMenu(1, nil, TracerData.DDM["DDMLineSelection"..tostring(i)], name, 0, 0);
end


--4e onglet (Infos)
function TracerData.Function:OptionsInfos()
	--Version 
	TracerData.Options["W4"]["Title"]:SetText("Tracer - Version "..TracerData.version);
	--Auteur
	TracerData.Options["W4"]["Title1"] = TracerData.Options["W4"]:CreateFontString(nil, "OVERLAY");
	TracerData.Options["W4"]["Title1"]:SetFont("Fonts\\FRIZQT__.TTF", TracerDB.Options.police);
	TracerData.Options["W4"]["Title1"]:SetPoint("TOP", TracerData.Options["W4"]["Title"], "BOTTOM", 0, -5);
	TracerData.Options["W4"]["Title1"]:SetText("Author : Grøkar - Elune (EU)");	
end
