local TracerName, TracerData = ...

local TimewalkingInfos = {
	[744] = {
		name="Timewalking BC", 
		questIdItem=40168,			--
		questIdDungeon=72727,		--ok
		level = 10, 				--
		questIdRaid = {1, 47523},	--
		},
	[995] = {
		name="Timewalking Wotlk",
		questIdItem=40173,			--
		questIdDungeon=62633,		--	
		level = 10, 				--
		questIdRaid ={1, 50316},	--
		},
	[1146] = {
		name="Timewalking Cata", 
		questIdItem=40787,			--
		questIdDungeon=62634,		--
		level = 10, 				--
		questIdRaid = {1, 57637},	--
		},
	[1453] = {
		name="Timewalking MoP", 			
		questIdItem=45563,			--
		questIdDungeon=62635,		--
		level = 10, 				--
		questIdRaid = {1, 0},		--
		},
	[1971] = {
		name="Timewalking WoD", 			
		questIdItem=55498,			--ok
		questIdDungeon=72724,		--ok
		level = 10, 				--
		questIdRaid = {1, 0},		--
		},
	[2274] = {
		name="Timewalking Legion", 			
		questIdItem=64710,			--ok
		questIdDungeon=72719,		--ok
		level = 10, 				--
		questIdRaid = {1, 0},		--
		},		
	};
local CurrentTimewalking = 0;	--ID des donjons timewalking (BC, Wotlk, Cata ou MoP) en cours
local CurrentTimewalkingName = " ";

local MythicLegionIds = {
	[197] = "EoA", --"L'oeil d'Azshara"	
	[198] = "DT", --"Fourré Sombrecoeur"	
	[199] = "BRH", --"Bastion du Freux"	
	[206] = "NL", --"Repaire de Neltharion"
	[207] = "VoW", --"Caveau des Gardiennes"	
	[210] = "CoS", --"Cours des Etoiles"
	};
TracerData.MythicLegionMapId = {
	[1456] = 197, --"L'oeil d'Azshara"
	[1466] = 198, --"Fourré Sombrecoeur"
	[1501] = 199, --"Bastion du Freux"
	[1458] = 206, --"Repaire de Neltharion"
	[1493] = 207, --"Caveau des Gardiennes"
	[1571] = 210, --"Cours des Etoiles"
	};
	
function TracerData.Function:WindowCreateTimewalking1()
	TracerDB.ListLine[11] = {};
	local namecurrencie = C_CurrencyInfo.GetCurrencyInfo(1166)["name"];

	--Détection de l'évènement Timewalking
	for i=1, GetNumRandomDungeons() do
		local id, name2 = GetLFGRandomDungeonInfo(i) 
		for key, value in pairs(TimewalkingInfos) do
			if key == id then
				print(TracerData.L["Tracer : Evènement Timewalking en cours"]);
				CurrentTimewalking = key;			--Id du timewalking
				CurrentTimewalkingName = name2;		--Nom du timewalking
				TracerDB.ListLine[11] = {
					TracerData.L["Passage dans les limbes"],
					TracerData.L["Quête du 1er donjon"],
					namecurrencie,
					}
				if 	value.questIdRaid[2] ~= 0 then
					TracerDB.ListLine[11][4] = TracerData.L["Quête Raid"];
				end
				if id == 2274 then
					TracerDB.ListLine[11][4] = TracerData.L["Clé disponible"];
				end
				break end;
		end
	end
	
	--Arrêt de la fonction s'il n'y a pas d'évènement
	if CurrentTimewalking == 0 then
		return
	else
		TracerData.Function:WindowCreateTimewalking2();
	end
end

function TracerData.Function:WindowCreateTimewalking2()
	--DB
	
	--Informations pour la création de la catégorie
	
	--Création de la catégorie
	TracerData.Function:WindowCreate(11, CurrentTimewalkingName);
	TracerDB.Options.DisplayHeader[11] = true;
	TracerDB.Options.Custom.DisplayHeader[11] = true;	

	--Affichage
	TracerData.Function:WindowsUpdateTimawalking();
	
	--Tooltip pour les clé Mythic+ dispo
	if (CurrentTimewalking == 2274) then
		for index, value in ipairs(TracerData.ListToons) do
			TracerData.Lines[11]["Toon"..index][4]:SetScript("OnEnter", function()
				TracerData.Function:MythicPlusKeyLegionTooltip(value);
			end);
			TracerData.Lines[11]["Toon"..index][4]:SetScript("OnLeave", function()
				TracerData["MythicKeyFrame"]:Hide();
			end);	
		end	
	end
	
	if not TracerDB.Toons[TracerData.thisToon]["Display"] then return end
	
	--Gestion de l'état
	TracerData.Lines[11][1]:RegisterEvent("LFG_COMPLETION_REWARD");
	TracerData.Lines[11][1]:RegisterEvent("QUEST_LOG_UPDATE");		
	TracerData.Lines[11][1]:RegisterEvent("BAG_UPDATE");	
	TracerData.Lines[11][1]:SetScript("OnEvent", function(_, event)
			C_Timer.After(3, function() TracerData.Function:TimewalkingQuest() end);		
		end)
	
	
	--Premier checking
	TracerData.Function:TimewalkingQuest();
end

function TracerData.Function:WindowsUpdateTimawalking()
	for index, value in ipairs(TracerData.ListToons) do
		for i = 1, #TracerDB.ListLine[11] , 1 do
			for key1, value1 in pairs(TracerDB.Toons) do	--On va chercher les informations pour le bon Toon				
				if value == key1 then
					TracerData.Lines[11]["Toon"..index][i]["Title"]:SetTextColor(value1.ClassColor.r, value1.ClassColor.g, value1.ClassColor.b, 1);
					--"Passage dans les limbes"
					if i == 1 then
						if value1.Quests.TD[1] ~= -1 then
							TracerData.Lines[11]["Toon"..index][i]["Texture2"]:SetTexture(nil);
							TracerData.Lines[11]["Toon"..index][i]["Title"]:SetText(value1.Quests.TD[1].."/5");
							if value1.Quests.TD[2] then	--ID du timewalking en cours
								TracerData.Lines[11]["Toon"..index][i]["Texture2"]:SetTexture("Interface\\AddOns\\Tracer\\Fonts\\SquareGreen");
								TracerData.Lines[11]["Toon"..index][i]["Title"]:SetText(nil);								
							end
						elseif value1.Level >= 10 then							
							TracerData.Lines[11]["Toon"..index][i]["Texture2"]:SetTexture("Interface\\AddOns\\Tracer\\Fonts\\SquareRed");
							TracerData.Lines[11]["Toon"..index][i]["Title"]:SetText(nil);
						else
							TracerData.Lines[11]["Toon"..index][i]["Texture2"]:SetTexture(nil);
							TracerData.Lines[11]["Toon"..index][i]["Title"]:SetText("NA");	--pas prise							
						end
					end
					--"Quête 1er donjon"
					if i == 2 then
						if value1.Level >= TimewalkingInfos[CurrentTimewalking]["level"] then
							if value1.Quests.TD[3] == 1 then
								TracerData.Lines[11]["Toon"..index][i]["Texture2"]:SetTexture("Interface\\AddOns\\Tracer\\Fonts\\SquareGreen");
								TracerData.Lines[11]["Toon"..index][i]["Title"]:SetText(nil);
							elseif value1.Quests.TD[3] == 0 then
								TracerData.Lines[11]["Toon"..index][i]["Texture2"]:SetTexture("Interface\\AddOns\\Tracer\\Fonts\\SquareOrange");
								TracerData.Lines[11]["Toon"..index][i]["Title"]:SetText(nil);
							else
								TracerData.Lines[11]["Toon"..index][i]["Texture2"]:SetTexture("Interface\\AddOns\\Tracer\\Fonts\\SquareRed");
								TracerData.Lines[11]["Toon"..index][i]["Title"]:SetText(nil);
							end
						else
							TracerData.Lines[11]["Toon"..index][i]["Texture2"]:SetTexture(nil);
							TracerData.Lines[11]["Toon"..index][i]["Title"]:SetText("NA");
						end
					end
					--Monnaie
					if i == 3 then					
						TracerData.Lines[11]["Toon"..index][i]["Title"]:SetText(TracerDB.Toons[value]["Currencies"][1166]);
					end												
					--Quête du raid
					if (i == 4) and (CurrentTimewalking ~= 2274) then
						if value1.Level >= TimewalkingInfos[CurrentTimewalking]["level"] then
							if value1.Quests.TD[4] == 1 then
								TracerData.Lines[11]["Toon"..index][i]["Texture2"]:SetTexture("Interface\\AddOns\\Tracer\\Fonts\\SquareGreen");
								TracerData.Lines[11]["Toon"..index][i]["Title"]:SetText(nil);
							elseif value1.Quests.TD[4] == 0 then
								TracerData.Lines[11]["Toon"..index][i]["Texture2"]:SetTexture("Interface\\AddOns\\Tracer\\Fonts\\SquareOrange");
								TracerData.Lines[11]["Toon"..index][i]["Title"]:SetText(nil);
							else
								TracerData.Lines[11]["Toon"..index][i]["Texture2"]:SetTexture("Interface\\AddOns\\Tracer\\Fonts\\SquareRed");
								TracerData.Lines[11]["Toon"..index][i]["Title"]:SetText(nil);
							end
						else					
							TracerData.Lines[11]["Toon"..index][i]["Texture2"]:SetTexture(nil);
							TracerData.Lines[11]["Toon"..index][i]["Title"]:SetText("NA");
						end
					end	
					--Clé disponible (Legion)
					if (i == 4) and (CurrentTimewalking == 2274)then
						--Changement de police pour les clés
						TracerData.Lines[11]["Toon"..index][i]["Title"]:SetFont("Fonts\\FRIZQT__.TTF", 10);					
						if value1.Level == 60 then
							if value1["Quests"]["MKLegion"][2] == -1 then	
								TracerData.Lines[11]["Toon"..index][i]["Texture2"]:SetTexture(nil);
								TracerData.Lines[11]["Toon"..index][i]["Title"]:SetText("NA");
							elseif value1["Quests"]["MKLegion"][2] == 0 then
								TracerData.Lines[11]["Toon"..index][i]["Texture2"]:SetTexture("Interface\\AddOns\\Tracer\\Fonts\\SquareRed");
								TracerData.Lines[11]["Toon"..index][i]["Title"]:SetText(nil);
							else
								TracerData.Lines[11]["Toon"..index][i]["Texture2"]:SetTexture(nil);
								TracerData.Lines[11]["Toon"..index][i]["Title"]:SetText(MythicLegionIds[value1["Quests"]["MKLegion"][1]].." "..value1["Quests"]["MKLegion"][2]);
							end
						else
							TracerData.Lines[11]["Toon"..index][i]["Texture2"]:SetTexture(nil);
							TracerData.Lines[11]["Toon"..index][i]["Title"]:SetText("NA");						
						end
					end						
				end
			end
		end
	end
end

function TracerData.Function:TimewalkingQuest()	
	local TimewalkingID = TimewalkingInfos[CurrentTimewalking]["questIdDungeon"];	--ID de la quête des donjons
	local TimewalkingFirstDungeon = TimewalkingInfos[CurrentTimewalking]["questIdItem"];	--ID de la quête pour la récompense du 1er donjon
	local TimewalkingFirstRaid = TimewalkingInfos[CurrentTimewalking]["questIdRaid"][2];	--ID de la quête pour la récompense du raid
	
	--Donjons effectués
	local questLogIndex = C_QuestLog.GetLogIndexForQuestID(TimewalkingID);
	if C_QuestLog.IsQuestFlaggedCompleted(TimewalkingID) then
		TracerDB.Toons[TracerData.thisToon]["Quests"]["TD"][1] = 5;	
		TracerDB.Toons[TracerData.thisToon]["Quests"]["TD"][2] = true;
	else
		if questLogIndex ~= 0 then
			local _, _, isFinish, questDone, questNeed = GetQuestObjectiveInfo(TimewalkingID, 1, false);
			if questDone then
				TracerDB.Toons[TracerData.thisToon]["Quests"]["TD"][1] = questDone;				
			end
		elseif TracerDB.Toons[TracerData.thisToon]["Level"] >= 10 then
			TracerDB.Toons[TracerData.thisToon]["Quests"]["TD"][1] = -1;
		end
	end
	
	--Quête du 1er donjon
	questLogIndex = C_QuestLog.GetLogIndexForQuestID(TimewalkingFirstDungeon);
	if C_QuestLog.IsQuestFlaggedCompleted(TimewalkingFirstDungeon) then
		TracerDB.Toons[TracerData.thisToon]["Quests"]["TD"][3] = 1;
	else
		if questLogIndex then
			TracerDB.Toons[TracerData.thisToon]["Quests"]["TD"][3] = 0;
		else
			TracerDB.Toons[TracerData.thisToon]["Quests"]["TD"][3] = -1;	
		end
	end
	
	--Quête du raid
	if TimewalkingFirstRaid ~= 0 then
		questLogIndex = C_QuestLog.GetLogIndexForQuestID(TimewalkingFirstRaid);
		if C_QuestLog.IsQuestFlaggedCompleted(TimewalkingFirstRaid) then
			TracerDB.Toons[TracerData.thisToon]["Quests"]["TD"][4] = 1;
		else
			if questLogIndex then
				TracerDB.Toons[TracerData.thisToon]["Quests"]["TD"][4] = 0;	
			else
				TracerDB.Toons[TracerData.thisToon]["Quests"]["TD"][4] = -1;							
			end
		end
	end
	
	--Affichage
	TracerData.Function:WindowsUpdateTimawalking();
end


--Fonctions pour les Tooltip
function TracerData.Function:MythicPlusKeyLegionTooltip(toon)
	if (TracerDB.Toons[toon]["Quests"]["MKLegion"][1] ~= 0) and (TracerDB.Toons[toon]["Level"] >=60) then	
		TracerData["MythicKeyFrame"]:SetWidth(tonumber(string.len(TracerData.MythicNames[TracerDB.Toons[toon]["Quests"]["MKLegion"][1]]))*8+20);

		TracerData["MythicKeyFrame"]["Title"]:SetText(TracerData.MythicNames[TracerDB.Toons[toon]["Quests"]["MKLegion"][1]]);
		TracerData["MythicKeyFrame"]["TitleKeyLevel"]:SetText(TracerDB.Toons[toon]["Quests"]["MKLegion"][2]);
		local height = 20;
		for i=1, 4, 1 do	
			if TracerDB.Toons[toon]["Quests"]["MKLegion"][i+2] ~= 0 then
				local nameaffix, _, _ = C_ChallengeMode.GetAffixInfo(TracerDB.Toons[toon]["Quests"]["MKLegion"][i+2]);
				TracerData["MythicKeyFrame"]["Affix"..i]:SetText(nameaffix);
				height = height + 16;
				TracerData["MythicKeyFrame"]:SetHeight(height);	
			else
				TracerData["MythicKeyFrame"]["Affix"..i]:SetText(nil);
			end
		end	
		
		TracerData["MythicKeyFrame"]:ClearAllPoints();
		TracerData["MythicKeyFrame"]:SetPoint("BOTTOM", TracerData.Lines[11]["Toon"..TracerDB.Toons[toon]["Order"]][4], "TOP");
		TracerData["MythicKeyFrame"]:Show();
	end
end