local TracerName, TracerData = ...

local rheader, gheader, bheader, theader = 0.63, 0.63, 0.63, 0.5;	--Couleur header
local rwindow, gwindow, bwindow, twindow = 0, 0, 0, 0.8;			--Couleur fond catégories
local length = 250;	--largeur fenêtre

local RaceIcon = {
	1,	--1 - Warrior
	1,	--2 - Paladin
	1,	--3 - Hunter
	1,	--4	- Rogue
	1,	--5 - Priest
	1,	--6 - DK
	1,	--7 - Shaman
	1,	--8 - Mage
	1,	--9 - Warlock
	1,	--10 - Monk
	1,	--11 - Druid
	1,	--12 - DH	
}
local SlotNum = {
	1,		--Tête
	2,		--Cou
	3,		--Epaule
	15,		--Cape
	5,		--Torse
	4,		--Tabard
	19,		--Chemise
	9,		--Brassard
	16,		--Arme gauche
	10,		--Gants
	6,		--Ceinture
	7,		--Jambes
	8,		--Pieds
	11,		--Anneau 1
	12,		--Anneau 2
	13,		--Bijou 1
	14,		--Bijou 2
	17,		--Arme droite
};
local SlotTexture = {
	"Interface\\AddOns\\Tracer\\Fonts\\SlotInventory\\UI-PaperDoll-Slot-Head",				--Tête
	"Interface\\AddOns\\Tracer\\Fonts\\SlotInventory\\UI-PaperDoll-Slot-Neck",				--Cou
	"Interface\\AddOns\\Tracer\\Fonts\\SlotInventory\\UI-PaperDoll-Slot-Shoulder",			--Epaule
	"Interface\\AddOns\\Tracer\\Fonts\\SlotInventory\\UI-PaperDoll-Slot-Chest",				--Cape
	"Interface\\AddOns\\Tracer\\Fonts\\SlotInventory\\UI-PaperDoll-Slot-Chest",				--Torse
	"Interface\\AddOns\\Tracer\\Fonts\\SlotInventory\\UI-PaperDoll-Slot-Tabard",			--Tabard
	"Interface\\AddOns\\Tracer\\Fonts\\SlotInventory\\UI-PaperDoll-Slot-Shirt",				--Chemise
	"Interface\\AddOns\\Tracer\\Fonts\\SlotInventory\\UI-PaperDoll-Slot-Wrists",			--Brassard
	"Interface\\AddOns\\Tracer\\Fonts\\SlotInventory\\UI-PaperDoll-Slot-SecondaryHand",		--Arme gauche
	"Interface\\AddOns\\Tracer\\Fonts\\SlotInventory\\UI-PaperDoll-Slot-Hands",				--Gants
	"Interface\\AddOns\\Tracer\\Fonts\\SlotInventory\\UI-PaperDoll-Slot-Waist",				--Ceinture
	"Interface\\AddOns\\Tracer\\Fonts\\SlotInventory\\UI-PaperDoll-Slot-Legs",				--Jambes
	"Interface\\AddOns\\Tracer\\Fonts\\SlotInventory\\UI-PaperDoll-Slot-Feet",				--Pieds
	"Interface\\AddOns\\Tracer\\Fonts\\SlotInventory\\UI-PaperDoll-Slot-Finger",			--Anneau 1
	"Interface\\AddOns\\Tracer\\Fonts\\SlotInventory\\UI-PaperDoll-Slot-Finger",			--Anneau 2
	"Interface\\AddOns\\Tracer\\Fonts\\SlotInventory\\UI-PaperDoll-Slot-Trinket",			--Bijou 1
	"Interface\\AddOns\\Tracer\\Fonts\\SlotInventory\\UI-PaperDoll-Slot-Trinket",			--Bijou 2
	"Interface\\AddOns\\Tracer\\Fonts\\SlotInventory\\UI-PaperDoll-Slot-MainHand",			--Arme droite	
};
local IlvlRankBack = {
	[125] = 1;	--
	[127] = 2;	--
	[129] = 3;
	[131] = 4;
	[133] = 5;
	[135] = 6;
	[137] = 7;
	[139] = 8;
	[141] = 9;	--
	[143] = 10; --
	[145] = 11;
	[147] = 12;	
	[149] = 13;
	[151] = 14;
	[155] = 15;	--	
	};
local Speid = {
	{71, 72, 73},			--1 - Warrior
	{65, 66, 70},			--2 - Paladin
	{253, 254, 255},		--3 - Hunter
	{259, 260, 261},		--4	- Rogue
	{256, 257, 258},		--5 - Priest
	{250, 251, 252},		--6 - DK
	{262, 263, 264},		--7 - Shaman
	{62, 63, 64},			--8 - Mage
	{265, 266, 267},		--9 - Warlock
	{268, 270, 269},		--10 - Monk
	{102, 103, 104, 105},	--11 - Druid
	{577, 581},				--12 - DH
	{1467, 1468},			--13 - Evoker
}

function TracerData.Function:ToonPanelCreate()
	rheader, gheader, bheader, theader = 0.63, 0.63, 0.63, 0.5;	--Couleur header
	rwindow, gwindow, bwindow, twindow = 0, 0, 0, 0.8;			--Couleur fond catégories
	length = 250;	--largeur fenêtre
	
	local classId = TracerDB.Toons[TracerData.thisToon]["ClassId"];
	
	--Frame pour détecter les modifications
	TracerData.ToonPanel["Scan"] = CreateFrame("Frame", "TracerToonPanelScan", UIParent);
	
	--Création de la fenêtre
	--Header
	TracerData.ToonPanel["Header"] = TracerData.Function:CreateFrameOne("ToonPanelHeader", UIParent, UIParent, length, TracerDB.Options.heightline, "TOPLEFT", "BOTTOMLEFT", TracerDB.Options.anchorlefttoonpanel, TracerDB.Options.anchortoptoonpanel, rheader, gheader, bheader, theader, "CENTER", "CENTER", 0, 0, "Infos");
	TracerData.ToonPanel["Header"]:SetFrameStrata("FULLSCREEN");
	TracerData.ToonPanel["Header"]:Hide();	
	--Déplacement de la fenêtre
	TracerData.ToonPanel["Header"]:SetScript("OnMouseDown", function() 
		TracerData.ToonPanel["Header"]:SetMovable(true); --Autorisation de déplacer la fenêtre
		TracerData.ToonPanel["Header"]:StartMoving();
		end) --Autorisation
	TracerData.ToonPanel["Header"]:SetScript("OnMouseUp", function() 
		TracerDB.Options.anchorlefttoonpanel = TracerData.ToonPanel["Header"]:GetLeft();
		TracerDB.Options.anchortoptoonpanel = TracerData.ToonPanel["Header"]:GetTop();
		TracerData.ToonPanel["Header"]:StopMovingOrSizing();
		TracerData.ToonPanel["Header"]:ClearAllPoints();
		TracerData.ToonPanel["Header"]:SetPoint("TOPLEFT", UIParent, "BOTTOMLEFT", TracerDB.Options.anchorlefttoonpanel, TracerDB.Options.anchortoptoonpanel);
		end) --Blocage
	--Bouton Fermer
	TracerData.Buttons.CloseToonPanel = CreateFrame("Button", "TracerCloseToonPanelButton", TracerData.ToonPanel["Header"], "GameMenuButtonTemplate");
	TracerData.Buttons.CloseToonPanel:SetPoint("BOTTOMRIGHT", TracerData.ToonPanel["Header"], "TOPRIGHT", 0, 5);
	TracerData.Buttons.CloseToonPanel:SetSize(15, 15);
	TracerData.Buttons.CloseToonPanel:SetNormalTexture("Interface\\AddOns\\Tracer\\Fonts\\close_normal");	
	TracerData.Buttons.CloseToonPanel:SetScript("OnClick", function()
		TracerData.ToonPanel["Header"]:Hide()
		end);		
	--Fenêtre
	TracerData.ToonPanel["Window"] = TracerData.Function:CreateFrameOne("ToonPanelWindow", TracerData.ToonPanel["Header"], TracerData.ToonPanel["Header"], length, 500, "TOPLEFT", "BOTTOMLEFT", 0, 0, rwindow, gwindow, bwindow, twindow, "CENTER", "CENTER", 0, 0, nil);	
	TracerData.ToonPanel["Window"]:SetFrameStrata("FULLSCREEN");
	
	
	--Informations générales
	--Nom-Serveur
	TracerData.ToonPanel["Window"]["ToonName"] = TracerData.ToonPanel["Window"]:CreateFontString(nil, "OVERLAY");
	TracerData.ToonPanel["Window"]["ToonName"]:SetFont("Fonts\\FRIZQT__.TTF", 15);			
	TracerData.ToonPanel["Window"]["ToonName"]:SetPoint("LEFT", TracerData.ToonPanel["Window"], "TOPLEFT", 10, -12);	
	TracerData.ToonPanel["Window"]["ToonName"]:SetText("Grøkar - Elune");	
	--Race
	TracerData.ToonPanel["Window"]["ToonRace"] = TracerData.Function:CreateFrameOne("ToonPanelToonRace", TracerData.ToonPanel["Window"], TracerData.ToonPanel["Window"]["ToonName"], 20, 20, "TOPLEFT", "BOTTOMLEFT", 0, -10, 0, 1, 0, 0.5, "LEFT", "RIGHT", 5, 0, nil);
	TracerData.ToonPanel["Window"]["ToonRace"]:SetFrameStrata("FULLSCREEN");
	--Classe
	TracerData.ToonPanel["Window"]["ToonClass"] = TracerData.Function:CreateFrameOne("ToonPanelToonClass", TracerData.ToonPanel["Window"], TracerData.ToonPanel["Window"]["ToonRace"], 20, 20, "LEFT", "RIGHT", 5, 0, 0, 0, 0, 0, "LEFT", "RIGHT", 5, 0, nil);	
	TracerData.ToonPanel["Window"]["ToonClass"]:SetFrameStrata("FULLSCREEN");	
	
	--Spé (icône)
	local ParentAnchor = TracerData.ToonPanel["Window"]["ToonRace"];
	local xOffset, yOffset = 0, -15;
	local AnchorFrame, AnchorParent = "TOP", "BOTTOM";
	for i=1, 4, 1 do
		TracerData.ToonPanel["Window"]["ToonSpe"..i] = CreateFrame("Button", "ToonPanelToonSpe1"..i, TracerData.ToonPanel["Window"]);
		TracerData.ToonPanel["Window"]["ToonSpe"..i]:SetPoint(AnchorFrame, ParentAnchor, AnchorParent, xOffset, yOffset);
		TracerData.ToonPanel["Window"]["ToonSpe"..i]:SetSize(20, 20);
		TracerData.ToonPanel["Window"]["ToonSpe"..i]:Hide();	
		TracerData.ToonPanel["Window"]["ToonSpe"..i]:SetHighlightTexture("Interface\\AddOns\\Tracer\\Fonts\\TalentSelected");		
		TracerData.ToonPanel["Window"]["ToonSpe"..i]:SetScript("OnClick", function(self, button, down)
			local name = TracerData.ToonPanel["Window"]["ToonName"]:GetText();
			for key, value in pairs(TracerDB.Toons) do
				if name == key then
					--TracerData.Function:ToonTalentDisplay(value.Order, i);
					TracerData.Function:ToonInventoryDisplay(value.Order, i)
				end
			end
			end);
		ParentAnchor = TracerData.ToonPanel["Window"]["ToonSpe"..i];
		xOffset = 5;
		yOffset = 0;
		AnchorFrame = "LEFT";
		AnchorParent = "RIGHT";		
	end
	
	--Nom de la spécialisation
	TracerData.ToonPanel["Window"]["ToonSpeDisplay"] = TracerData.Function:CreateFrameOne("ToonSpeDisplay", TracerData.ToonPanel["Window"], TracerData.ToonPanel["Window"]["ToonSpe1"], 50, 20, "LEFT", "BOTTOMLEFT", 5, -25, 0, 0, 0, 0, "LEFT", "LEFT", 0, 0, "Name spé");
	TracerData.ToonPanel["Window"]["ToonSpeDisplay"]:SetFrameStrata("FULLSCREEN");	
	
	--Inventory
	--Texture
	ParentAnchor = TracerData.ToonPanel["Window"]["ToonSpeDisplay"];
	xOffset, yOffset = 50, -40;
	AnchorFrame = "TOPLEFT";
	AnchorParent = "TOPLEFT";
	for i=1, 9, 1 do
		TracerData.ToonPanel["Window"]["Inventory"..i] = TracerData.Function:CreateFrameOne("ToonPanelInventory"..i, TracerData.ToonPanel["Window"], ParentAnchor, 29, 29, AnchorFrame, AnchorParent, xOffset, yOffset, 0, 0, 0, 0, "CENTER", "CENTER", 0, 0, nil);
		TracerData.ToonPanel["Window"]["Inventory"..i]:SetFrameStrata("FULLSCREEN");
		TracerData.ToonPanel["Window"]["Inventory"..i]["Texture1"]:ClearAllPoints();
		TracerData.ToonPanel["Window"]["Inventory"..i]["Texture1"]:SetAllPoints(TracerData.ToonPanel["Window"]["Inventory"..i]);				
		ParentAnchor = TracerData.ToonPanel["Window"]["Inventory"..i];
		xOffset = 0;
		yOffset = -10;
		AnchorFrame = "TOP";
		AnchorParent = "BOTTOM";							
	end		
	ParentAnchor = TracerData.ToonPanel["Window"]["Inventory1"];
	xOffset, yOffset = 50, 0;
	AnchorFrame = "LEFT";
	AnchorParent = "RIGHT";
	for i=10, 18, 1 do
		TracerData.ToonPanel["Window"]["Inventory"..i] = TracerData.Function:CreateFrameOne("ToonPanelInventory"..i, TracerData.ToonPanel["Window"], ParentAnchor, 29, 29, AnchorFrame, AnchorParent, xOffset, yOffset, 0, 0, 0, 0, "CENTER", "CENTER", 0, 0, nil);
		TracerData.ToonPanel["Window"]["Inventory"..i]:SetFrameStrata("FULLSCREEN");
		TracerData.ToonPanel["Window"]["Inventory"..i]["Texture1"]:ClearAllPoints();
		TracerData.ToonPanel["Window"]["Inventory"..i]["Texture1"]:SetAllPoints(TracerData.ToonPanel["Window"]["Inventory"..i]);			
		ParentAnchor = TracerData.ToonPanel["Window"]["Inventory"..i];
		xOffset = 0;
		yOffset = -10;
		AnchorFrame = "TOP";
		AnchorParent = "BOTTOM";							
	end	
	--Text
	for i=1, 18, 1 do
		TracerData.ToonPanel["Window"]["Inventory"..i]["Title"]:ClearAllPoints();
		TracerData.ToonPanel["Window"]["Inventory"..i]["Title"]:SetPoint("TOPLEFT", TracerData.ToonPanel["Window"]["Inventory"..i], "TOPRIGHT", 3, -2);
	end
	--Emplacement de chasse
	for i=1, 18, 1 do
		TracerData.ToonPanel["Window"]["InventorySocket"..i] = TracerData.Function:CreateFrameOne("ToonPanelInventorySocket"..i, TracerData.ToonPanel["Window"], TracerData.ToonPanel["Window"]["Inventory"..i], 10, 10, "BOTTOMLEFT", "BOTTOMRIGHT", 3, 2, 1, 0, 0, 0.8, "CENTER", "CENTER", 0, 0, nil);
		TracerData.ToonPanel["Window"]["InventorySocket"..i]:SetFrameStrata("FULLSCREEN");					
	end
	--Emplacement d'enchant
	for i=1, 18, 1 do
		TracerData.ToonPanel["Window"]["InventoryEnchant"..i] = TracerData.Function:CreateFrameOne("ToonPanelInventoryEnchant"..i, TracerData.ToonPanel["Window"], TracerData.ToonPanel["Window"]["InventorySocket"..i], 10, 10, "BOTTOMLEFT", "BOTTOMRIGHT", 3, 0, 1, 0, 0, 0.8, "CENTER", "CENTER", 0, 0, nil);
		TracerData.ToonPanel["Window"]["InventoryEnchant"..i]:SetFrameStrata("FULLSCREEN");	
		TracerData.ToonPanel["Window"]["InventoryEnchant"..i]:Hide();
	end	

	--Actualisation	
	TracerData.ToonPanel["Scan"]:RegisterEvent("PLAYER_EQUIPMENT_CHANGED");
	TracerData.ToonPanel["Scan"]:RegisterEvent("SOCKET_INFO_SUCCESS");
	TracerData.ToonPanel["Scan"]:RegisterEvent("TRAIT_NODE_CHANGED");
	TracerData.ToonPanel["Scan"]:RegisterEvent("TRAIT_CONFIG_UPDATED");	
	TracerData.ToonPanel["Scan"]:RegisterEvent("PLAYER_TALENT_UPDATE");
	TracerData.ToonPanel["Scan"]:SetScript("OnEvent", function(_, event, arg1)								
		if (event == "PLAYER_EQUIPMENT_CHANGED") or (event == "SOCKET_INFO_SUCCESS") or ((event == "UNIT_INVENTORY_CHANGED") and (arg1 == "player")) then
			TracerData.Function:InventoryUpdate();
		else
			TracerData.Function:NodesUpdate();		
		end
	end)
end

function TracerData.Function:ToonPanelCreate2()
	rheader, gheader, bheader, theader = 0.63, 0.63, 0.63, 1;	--Couleur header
	rwindow, gwindow, bwindow, twindow = 0, 0, 0, 1;			--Couleur fond catégories
	length = 900;	--largeur fenêtre
	
	local classId = TracerDB.Toons[TracerData.thisToon]["ClassId"];
	
	--Frame pour détecter les modifications
	TracerData.ToonPanel["Scan"] = CreateFrame("Frame", "TracerToonPanelScan", UIParent);
	
	--Création de la fenêtre
	--Header
	TracerData.ToonPanel["Header"] = TracerData.Function:CreateFrameOne("ToonPanelHeader", UIParent, UIParent, length, TracerDB.Options.heightline, "TOPLEFT", "BOTTOMLEFT", TracerDB.Options.anchorlefttoonpanel, TracerDB.Options.anchortoptoonpanel, rheader, gheader, bheader, theader, "CENTER", "CENTER", 0, 0, "Infos");
	TracerData.ToonPanel["Header"]:SetFrameStrata("FULLSCREEN");
	TracerData.ToonPanel["Header"]:Hide();	
	--Déplacement de la fenêtre
	TracerData.ToonPanel["Header"]:SetScript("OnMouseDown", function() 
		TracerData.ToonPanel["Header"]:SetMovable(true); --Autorisation de déplacer la fenêtre
		TracerData.ToonPanel["Header"]:StartMoving();
		end) --Autorisation
	TracerData.ToonPanel["Header"]:SetScript("OnMouseUp", function() 
		TracerDB.Options.anchorlefttoonpanel = TracerData.ToonPanel["Header"]:GetLeft();
		TracerDB.Options.anchortoptoonpanel = TracerData.ToonPanel["Header"]:GetTop();
		TracerData.ToonPanel["Header"]:StopMovingOrSizing();
		TracerData.ToonPanel["Header"]:ClearAllPoints();
		TracerData.ToonPanel["Header"]:SetPoint("TOPLEFT", UIParent, "BOTTOMLEFT", TracerDB.Options.anchorlefttoonpanel, TracerDB.Options.anchortoptoonpanel);
		end) --Blocage
	--Bouton Fermer
	TracerData.Buttons.CloseToonPanel = CreateFrame("Button", "TracerCloseToonPanelButton", TracerData.ToonPanel["Header"], "GameMenuButtonTemplate");
	TracerData.Buttons.CloseToonPanel:SetPoint("BOTTOMRIGHT", TracerData.ToonPanel["Header"], "TOPRIGHT", 0, 5);
	TracerData.Buttons.CloseToonPanel:SetSize(15, 15);
	TracerData.Buttons.CloseToonPanel:SetNormalTexture("Interface\\AddOns\\Tracer\\Fonts\\close_normal");	
	TracerData.Buttons.CloseToonPanel:SetScript("OnClick", function()
		TracerData.ToonPanel["Header"]:Hide()
		end);		
	--Fenêtre
	TracerData.ToonPanel["Window"] = TracerData.Function:CreateFrameOne("ToonPanelWindow", TracerData.ToonPanel["Header"], TracerData.ToonPanel["Header"], length, 500, "TOPLEFT", "BOTTOMLEFT", 0, 0, rwindow, gwindow, bwindow, twindow, "CENTER", "CENTER", 0, 0, nil);	
	TracerData.ToonPanel["Window"]:SetFrameStrata("FULLSCREEN");
	
	
	--Informations générales
	--Nom-Serveur
	TracerData.ToonPanel["Window"]["ToonName"] = TracerData.ToonPanel["Window"]:CreateFontString(nil, "OVERLAY");
	TracerData.ToonPanel["Window"]["ToonName"]:SetFont("Fonts\\FRIZQT__.TTF", 15);			
	TracerData.ToonPanel["Window"]["ToonName"]:SetPoint("LEFT", TracerData.ToonPanel["Window"], "TOPLEFT", 10, -12);	
	TracerData.ToonPanel["Window"]["ToonName"]:SetText("Grøkar - Elune");	
	--Race
	TracerData.ToonPanel["Window"]["ToonRace"] = TracerData.Function:CreateFrameOne("ToonPanelToonRace", TracerData.ToonPanel["Window"], TracerData.ToonPanel["Window"]["ToonName"], 20, 20, "TOPLEFT", "BOTTOMLEFT", 0, -10, 0, 1, 0, 0.5, "LEFT", "RIGHT", 5, 0, nil);
	TracerData.ToonPanel["Window"]["ToonRace"]:SetFrameStrata("FULLSCREEN");
	--Classe
	TracerData.ToonPanel["Window"]["ToonClass"] = TracerData.Function:CreateFrameOne("ToonPanelToonClass", TracerData.ToonPanel["Window"], TracerData.ToonPanel["Window"]["ToonRace"], 20, 20, "LEFT", "RIGHT", 5, 0, 0, 0, 0, 0, "LEFT", "RIGHT", 5, 0, nil);	
	TracerData.ToonPanel["Window"]["ToonClass"]:SetFrameStrata("FULLSCREEN");	
	
	--Spé (icône)
	local ParentAnchor = TracerData.ToonPanel["Window"]["ToonRace"];
	local xOffset, yOffset = 0, -15;
	local AnchorFrame, AnchorParent = "TOP", "BOTTOM";
	for i=1, 4, 1 do
		TracerData.ToonPanel["Window"]["ToonSpe"..i] = CreateFrame("Button", "ToonPanelToonSpe1"..i, TracerData.ToonPanel["Window"]);
		TracerData.ToonPanel["Window"]["ToonSpe"..i]:SetPoint(AnchorFrame, ParentAnchor, AnchorParent, xOffset, yOffset);
		TracerData.ToonPanel["Window"]["ToonSpe"..i]:SetSize(20, 20);
		TracerData.ToonPanel["Window"]["ToonSpe"..i]:Hide();	
		TracerData.ToonPanel["Window"]["ToonSpe"..i]:SetHighlightTexture("Interface\\AddOns\\Tracer\\Fonts\\TalentSelected");		
		TracerData.ToonPanel["Window"]["ToonSpe"..i]:SetScript("OnClick", function(self, button, down)
			local name = TracerData.ToonPanel["Window"]["ToonName"]:GetText();
			for key, value in pairs(TracerDB.Toons) do
				if name == key then
					--TracerData.Function:ToonTalentDisplay(value.Order, i);
					TracerData.Function:ToonInventoryDisplay(value.Order, i)
				end
			end
			end);
		ParentAnchor = TracerData.ToonPanel["Window"]["ToonSpe"..i];
		xOffset = 5;
		yOffset = 0;
		AnchorFrame = "LEFT";
		AnchorParent = "RIGHT";		
	end
	
	--Nom de la spécialisation
	TracerData.ToonPanel["Window"]["ToonSpeDisplay"] = TracerData.Function:CreateFrameOne("ToonSpeDisplay", TracerData.ToonPanel["Window"], TracerData.ToonPanel["Window"]["ToonSpe1"], 50, 20, "LEFT", "BOTTOMLEFT", 5, -25, 0, 0, 0, 0, "LEFT", "LEFT", 0, 0, "Name spé");
	TracerData.ToonPanel["Window"]["ToonSpeDisplay"]:SetFrameStrata("FULLSCREEN");	
	
	--Inventory
	--Texture
	ParentAnchor = TracerData.ToonPanel["Window"]["ToonSpeDisplay"];
	xOffset, yOffset = 20, -40;
	AnchorFrame = "TOPLEFT";
	AnchorParent = "TOPLEFT";
	for i=1, 9, 1 do
		TracerData.ToonPanel["Window"]["Inventory"..i] = TracerData.Function:CreateFrameOne("ToonPanelInventory"..i, TracerData.ToonPanel["Window"], ParentAnchor, 29, 29, AnchorFrame, AnchorParent, xOffset, yOffset, 0, 0, 0, 0, "CENTER", "CENTER", 0, 0, nil);
		TracerData.ToonPanel["Window"]["Inventory"..i]:SetFrameStrata("FULLSCREEN");
		TracerData.ToonPanel["Window"]["Inventory"..i]["Texture1"]:ClearAllPoints();
		TracerData.ToonPanel["Window"]["Inventory"..i]["Texture1"]:SetAllPoints(TracerData.ToonPanel["Window"]["Inventory"..i]);				
		ParentAnchor = TracerData.ToonPanel["Window"]["Inventory"..i];
		xOffset = 0;
		yOffset = -10;
		AnchorFrame = "TOP";
		AnchorParent = "BOTTOM";							
	end		
	ParentAnchor = TracerData.ToonPanel["Window"]["Inventory1"];
	xOffset, yOffset = 10, 0;
	AnchorFrame = "LEFT";
	AnchorParent = "RIGHT";
	for i=10, 18, 1 do
		TracerData.ToonPanel["Window"]["Inventory"..i] = TracerData.Function:CreateFrameOne("ToonPanelInventory"..i, TracerData.ToonPanel["Window"], ParentAnchor, 29, 29, AnchorFrame, AnchorParent, xOffset, yOffset, 0, 0, 0, 0, "CENTER", "CENTER", 0, 0, nil);
		TracerData.ToonPanel["Window"]["Inventory"..i]:SetFrameStrata("FULLSCREEN");
		TracerData.ToonPanel["Window"]["Inventory"..i]["Texture1"]:ClearAllPoints();
		TracerData.ToonPanel["Window"]["Inventory"..i]["Texture1"]:SetAllPoints(TracerData.ToonPanel["Window"]["Inventory"..i]);			
		ParentAnchor = TracerData.ToonPanel["Window"]["Inventory"..i];
		xOffset = 0;
		yOffset = -10;
		AnchorFrame = "TOP";
		AnchorParent = "BOTTOM";							
	end	
	--Text
	for i=1, 18, 1 do
		TracerData.ToonPanel["Window"]["Inventory"..i]["Title"]:ClearAllPoints();		
		if i <= 9 then
			TracerData.ToonPanel["Window"]["Inventory"..i]["Title"]:SetPoint("TOPRIGHT", TracerData.ToonPanel["Window"]["Inventory"..i], "TOPLEFT", -3, -2);	
		else
			TracerData.ToonPanel["Window"]["Inventory"..i]["Title"]:SetPoint("TOPLEFT", TracerData.ToonPanel["Window"]["Inventory"..i], "TOPRIGHT", 3, -2);		
		end
			
	end
	--Emplacement de chasse
	for i=1, 18, 1 do
		TracerData.ToonPanel["Window"]["InventorySocket"..i] = TracerData.Function:CreateFrameOne("ToonPanelInventorySocket"..i, TracerData.ToonPanel["Window"], TracerData.ToonPanel["Window"]["Inventory"..i], 10, 10, "BOTTOMLEFT", "BOTTOMRIGHT", 3, 2, 1, 0, 0, 0.8, "CENTER", "CENTER", 0, 0, nil);
		TracerData.ToonPanel["Window"]["InventorySocket"..i]:SetFrameStrata("FULLSCREEN");					
	end
	--Emplacement d'enchant
	for i=1, 18, 1 do
		TracerData.ToonPanel["Window"]["InventoryEnchant"..i] = TracerData.Function:CreateFrameOne("ToonPanelInventoryEnchant"..i, TracerData.ToonPanel["Window"], TracerData.ToonPanel["Window"]["InventorySocket"..i], 10, 10, "BOTTOMLEFT", "BOTTOMRIGHT", 3, 0, 1, 0, 0, 0.8, "CENTER", "CENTER", 0, 0, nil);
		TracerData.ToonPanel["Window"]["InventoryEnchant"..i]:SetFrameStrata("FULLSCREEN");	
		TracerData.ToonPanel["Window"]["InventoryEnchant"..i]:Hide();
	end	

	--Arbre de Talents
	TracerData.ToonPanel["Window"]["Node"] = {};

	--Actualisation	
	TracerData.ToonPanel["Scan"]:RegisterEvent("PLAYER_EQUIPMENT_CHANGED");
	TracerData.ToonPanel["Scan"]:RegisterEvent("SOCKET_INFO_SUCCESS");
	TracerData.ToonPanel["Scan"]:RegisterEvent("TRAIT_NODE_CHANGED");
	TracerData.ToonPanel["Scan"]:RegisterEvent("TRAIT_CONFIG_UPDATED");	
	TracerData.ToonPanel["Scan"]:RegisterEvent("PLAYER_TALENT_UPDATE");
	TracerData.ToonPanel["Scan"]:SetScript("OnEvent", function(_, event, arg1)								
		if (event == "PLAYER_EQUIPMENT_CHANGED") or (event == "SOCKET_INFO_SUCCESS") or ((event == "UNIT_INVENTORY_CHANGED") and (arg1 == "player")) then
			TracerData.Function:InventoryUpdate();
		else
			TracerData.Function:NodesUpdate();		
		end
	end)
end


function TracerData.Function:ToonPanelDisplay(toonnumber)
	--Recherche des infos du Toons dans la database
	local data = {};
	local nametoon = "";
	local nameraceicon = "";
	for key, value in pairs(TracerDB.Toons) do
		if value.Order == toonnumber then
			data = value;
			nametoon = key;
		end
	end
	
	--Update Text	
	TracerData.ToonPanel["Window"]["ToonName"]:SetTextColor(data.ClassColor.r, data.ClassColor.g, data.ClassColor.b);
	TracerData.ToonPanel["Window"]["ToonName"]:SetText(nametoon);
	
	--Update Texture
	--Race
	if data.Gender ~= 0 then
		if data.Gender == 2 then		--male
			nameraceicon = tostring(data.RaceId).."_male";
		else
			nameraceicon = tostring(data.RaceId).."_female";		
		end
		TracerData.ToonPanel["Window"]["ToonRace"]["Texture1"]:SetTexture("Interface\\AddOns\\Tracer\\Fonts\\race\\"..nameraceicon);	
	else
		TracerData.ToonPanel["Window"]["ToonRace"]["Texture1"]:SetTexture(nil);	
	end
	--Class
	TracerData.ToonPanel["Window"]["ToonClass"]["Texture1"]:SetTexture(TracerData.ClassIcon[data.ClassId]);	
	--Spé
	for i=1, 4, 1 do
		if Speid[data.ClassId][i] then
			if TracerDB.SpecializationIdInfos[Speid[data.ClassId][i]] then
				TracerData.ToonPanel["Window"]["ToonSpe"..i]:Enable();
				TracerData.ToonPanel["Window"]["ToonSpe"..i]:SetNormalTexture(TracerDB.SpecializationIdInfos[Speid[data.ClassId][i]]["icon"]);
				TracerData.ToonPanel["Window"]["ToonSpe"..i]:Show();
			else
				TracerData.ToonPanel["Window"]["ToonSpe"..i]:Disable();
				TracerData.ToonPanel["Window"]["ToonSpe"..i]:Hide();				
			end
		else
			TracerData.ToonPanel["Window"]["ToonSpe"..i]:Disable();
			TracerData.ToonPanel["Window"]["ToonSpe"..i]:Hide();				
		end		
	end
	
	--Affichage de l'inventaire
	TracerData.Function:ToonInventoryDisplay(toonnumber, 0);
	--Affichage de l'arbre de talents
	--TracerData.Function:ToonNodesDisplay(toonnumber, 0);
	
	--Génération des Tooltips
	--Race
	TracerData.ToonPanel["Window"]["ToonRace"]:SetScript("OnEnter", function()
		GameTooltip:Hide();	
		GameTooltip:SetOwner(UIParent, "ANCHOR_CURSOR");			
		GameTooltip:AddLine(data.Race);
		GameTooltip:Show();
		end);
	TracerData.ToonPanel["Window"]["ToonRace"]:SetScript("OnLeave", function()
		GameTooltip:Hide();
		end);
	--Class
	TracerData.ToonPanel["Window"]["ToonClass"]:SetScript("OnEnter", function()
		GameTooltip:Hide();	
		GameTooltip:SetOwner(UIParent, "ANCHOR_CURSOR");			
		GameTooltip:AddLine(data.Class);
		GameTooltip:Show();
		end);
	TracerData.ToonPanel["Window"]["ToonClass"]:SetScript("OnLeave", function()
		GameTooltip:Hide();
		end);
	--Spécialisation
	for i=1, 4, 1 do
		TracerData.ToonPanel["Window"]["ToonSpe"..i]:SetScript("OnEnter", function()
			GameTooltip:Hide();	
			GameTooltip:SetOwner(UIParent, "ANCHOR_CURSOR");			
			GameTooltip:AddLine(TracerDB.SpecializationIdInfos[Speid[data.ClassId][i]]["name"]);
			GameTooltip:Show();
			end);
		TracerData.ToonPanel["Window"]["ToonSpe"..i]:SetScript("OnLeave", function()
			GameTooltip:Hide();
			end);	
	end
	
	--Afficher la fenêtre
	TracerData.ToonPanel["Header"]:Show();
end


function TracerData.Function:InventoryUpdate()
	--print("Inventory Update");
	TracerData.ToonPanel["Scan"]:UnregisterEvent("UNIT_INVENTORY_CHANGED");

	local t = {};
	local gemid = 0;
	local link = "";
	local enchant, gem1, itemId = 0, 0, 0;
	local numspe = TracerDB.Toons[TracerData.thisToon]["Specialization"]["id"];
	if numspe then
		TracerDB.Toons[TracerData.thisToon]["Inventory"][numspe] = {};	
		for i=1, 19, 1 do
			link = GetInventoryItemLink("player", i);
			if link then
				_, _, _, _, itemId, enchant, gem1, _, _, _, _, _, _, _, _ = string.find(link, "|?c?f?f?(%x*)|?H?([^:]*):?(%d+):?(%d*):?(%d*):?(%d*):?(%d*):?(%d*):?(%-?%d*):?(%-?%d*):?(%d*):?(%d*)|?h?%[?([^%[%]]*)%]?|?h?|?r?")
				--General Data
				TracerDB.Toons[TracerData.thisToon]["Inventory"][numspe][i] = {
					link = link,
					itemId = itemId,
					texture = GetInventoryItemTexture("player", i),
					quality = GetInventoryItemQuality("player", i),
					ilvl = GetDetailedItemLevelInfo(link),				
					};
				--Gem	
				t = {};
				t = GetItemStats(link);
				if t and t["EMPTY_SOCKET_PRISMATIC"] then
					if gem1 ~= "" then
						TracerDB.Toons[TracerData.thisToon]["Inventory"][numspe][i]["emptysocket"] = {true, gem1};
					else
						TracerDB.Toons[TracerData.thisToon]["Inventory"][numspe][i]["emptysocket"] = {true, 0};
					end
				else			
					TracerDB.Toons[TracerData.thisToon]["Inventory"][numspe][i]["emptysocket"] = {false, 0};			
				end
				--Enchant (Cape/Torse/Brassard/MainGauche/Gants/Pieds/Anneau1/Anneau2/MainDroite)
				if (i == 15) or (i == 5) or (i == 9) or (i == 16) or (i == 10) or (i == 8) or (i == 11) or (i == 12) or (i == 17) then		--debug
					if enchant ~= "" then
						TracerDB.Toons[TracerData.thisToon]["Inventory"][numspe][i]["enchant"] = {true, enchant};
					else
						TracerDB.Toons[TracerData.thisToon]["Inventory"][numspe][i]["enchant"] = {true, 0};
					end
				else
					TracerDB.Toons[TracerData.thisToon]["Inventory"][numspe][i]["enchant"] = {false, 0};			
				end
			else
				TracerDB.Toons[TracerData.thisToon]["Inventory"][numspe][i] = {};
			end
			gemid = 0;
		end
	end
	C_Timer.After(2, function() TracerData.ToonPanel["Scan"]:RegisterEvent("UNIT_INVENTORY_CHANGED"); end)
end

function TracerData.Function:NodesUpdate()	
	--print("Nodes Update");	
	--Informations sur la spécialisation pour le Toon
	local id, name, description, icon, background, role, primaryStat = GetSpecializationInfo(GetSpecialization());
	if not id then return end
	
	TracerDB.Toons[TracerData.thisToon]["Specialization"] = {
		id = id,
		name = name,
		description = description,
		icon = icon,
		background = background,
		role = role,
		primaryStat = primaryStat,
		};
	--Informations sur la spé à sauvegarder dans la DataBase
	if not TracerDB["SpecializationIdInfos"][id] then
		TracerDB["SpecializationIdInfos"][id] = {
			id = id,
			name = name,
			description = description,
			icon = icon,
			background = background,
			primaryStat = primaryStat,		
		};		
	end
	--print("Spécialisation "..id.." "..name.." - "..GetSpecialization());

	--TracerDB.test = {};	
	TracerDB.Toons[TracerData.thisToon]["ConfigsInfos"][id] = {};
	
	local configIds = C_ClassTalents.GetConfigIDsBySpecID(id);
	local nodeIDs = {};
	local nodeInfo = {};
	--TracerDB.test = configIds;
	if not configIds then
		configIds = {C_ClassTalents.GetActiveConfigID()};
	end	
	if configIds then
		for index, value in ipairs(configIds) do
			nodeIDs = {};
			nodeInfo = {};
			TracerDB.Toons[TracerData.thisToon]["ConfigsInfos"][id][index] = C_Traits.GetConfigInfo(value);
			nodeIDs = C_Traits.GetTreeNodes(TracerDB.Toons[TracerData.thisToon]["ConfigsInfos"][id][index]["treeIDs"][1])
			for index1, value1 in ipairs(nodeIDs) do
				nodeInfo[index1] = C_Traits.GetNodeInfo(value, value1)
			end
			TracerDB.Toons[TracerData.thisToon]["ConfigsInfos"][id][index]["nodes"] = nodeInfo;
		end
	end
	--TracerDB.test = TracerDB.Toons[TracerData.thisToon]["ConfigsInfos"];	
end


function TracerData.Function:ToonInventoryDisplay(toonnumber, Speindex)
	--Recherche des infos du Toons dans la database
	local data = {};
	for key, value in pairs(TracerDB.Toons) do
		if value.Order == toonnumber then
			data = value;
		end
	end

	--On cherche le numéro de la spé (si utilisation des boutons de modif de spé)
	if Speindex ~= 0 then
		Speindex = Speid[data.ClassId][Speindex];
	else
		Speindex = data.Specialization.id;
	end
	--Affichage du nom de la spé (si utilisation des boutons de modif de spé)
	if TracerDB.SpecializationIdInfos[Speindex] then
		TracerData.ToonPanel["Window"]["ToonSpeDisplay"]["Title"]:SetText(TracerDB.SpecializationIdInfos[Speindex]["name"]);	
	end
	
	--Affichage des textures du stuff
	for i=1, 18, 1 do
		if data.Inventory[Speindex] then
			--Texture
			if data.Inventory[Speindex][SlotNum[i]]["texture"] then		
				TracerData.ToonPanel["Window"]["Inventory"..i]["Texture1"]:SetTexture(data.Inventory[Speindex][SlotNum[i]]["texture"]);
			else
				TracerData.ToonPanel["Window"]["Inventory"..i]["Texture1"]:SetTexture(SlotTexture[i]);
			end
			--Quality
			if data.Inventory[Speindex][SlotNum[i]]["quality"] then
				TracerData.ToonPanel["Window"]["Inventory"..i]["Texture2"]:ClearAllPoints();
				TracerData.ToonPanel["Window"]["Inventory"..i]["Texture2"]:SetAllPoints(TracerData.ToonPanel["Window"]["Inventory"..i]);
				TracerData.ToonPanel["Window"]["Inventory"..i]["Texture2"]:SetTexture("Interface\\AddOns\\Tracer\\Fonts\\ItemQuality\\"..data.Inventory[Speindex][SlotNum[i]]["quality"]);
			else
				TracerData.ToonPanel["Window"]["Inventory"..i]["Texture2"]:SetTexture(nil);			
			end				
			--Tooltip
			if data.Inventory[Speindex][SlotNum[i]]["link"] then			
				TracerData.ToonPanel["Window"]["Inventory"..i]:SetScript("OnEnter", function()
					GameTooltip:Hide();	
					GameTooltip:SetOwner(TracerData.ToonPanel["Window"]["Inventory"..i], "ANCHOR_NONE");
					GameTooltip:SetPoint("BOTTOMLEFT", TracerData.ToonPanel["Window"]["Inventory"..i], "TOPRIGHT");			
					GameTooltip:SetHyperlink(data.Inventory[Speindex][SlotNum[i]]["link"]);
					GameTooltip:Show();
					end);
				TracerData.ToonPanel["Window"]["Inventory"..i]:SetScript("OnLeave", function()
					GameTooltip:Hide();
					end);
			else
				TracerData.ToonPanel["Window"]["Inventory"..i]:SetScript("OnEnter", function() end);		
			end
			--Ilvl Text
			if data.Inventory[Speindex][SlotNum[i]]["ilvl"] then
				TracerData.ToonPanel["Window"]["Inventory"..i]["Title"]:SetTextColor(TracerData.QualityColor[data.Inventory[Speindex][SlotNum[i]]["quality"]][1], TracerData.QualityColor[data.Inventory[Speindex][SlotNum[i]]["quality"]][2], TracerData.QualityColor[data.Inventory[Speindex][SlotNum[i]]["quality"]][3], 1);
				TracerData.ToonPanel["Window"]["Inventory"..i]["Title"]:SetText(data.Inventory[Speindex][SlotNum[i]]["ilvl"]);
			else
				TracerData.ToonPanel["Window"]["Inventory"..i]["Title"]:SetText(nil);			
			end
			--Checking Gem
			if data.Inventory[Speindex][SlotNum[i]]["emptysocket"] then
				if data.Inventory[Speindex][SlotNum[i]]["emptysocket"][1] and (data.Inventory[Speindex][SlotNum[i]]["emptysocket"][2] == 0) then
					TracerData.ToonPanel["Window"]["InventorySocket"..i]:Show();
				else
					TracerData.ToonPanel["Window"]["InventorySocket"..i]:Hide();
				end
			else
				TracerData.ToonPanel["Window"]["InventorySocket"..i]:Hide();
			end
			--Checking Enchant
			if data.Inventory[Speindex][SlotNum[i]]["enchant"] then
				if (i == 18) and (data.Inventory[Speindex][SlotNum[i]]["link"]) then	--Traitement spécial main gauche				
					local inventoryType = C_Item.GetItemInventoryTypeByID(data.Inventory[Speindex][SlotNum[i]]["link"]); --(17 2h /13 1h)
					if (inventoryType == 17) or (inventoryType == 13) then
						TracerData.ToonPanel["Window"]["InventoryEnchant"..i]:Show();
					else
						TracerData.ToonPanel["Window"]["InventoryEnchant"..i]:Hide();
					end
				else
					if data.Inventory[Speindex][SlotNum[i]]["enchant"][1] and (data.Inventory[Speindex][SlotNum[i]]["enchant"][2] == 0) then
						TracerData.ToonPanel["Window"]["InventoryEnchant"..i]:Show();
					else
						TracerData.ToonPanel["Window"]["InventoryEnchant"..i]:Hide();
					end
				end
			else
				TracerData.ToonPanel["Window"]["InventoryEnchant"..i]:Hide();
			end
		else
			--Texture
			TracerData.ToonPanel["Window"]["Inventory"..i]["Texture1"]:SetTexture(SlotTexture[i]);			
			--Quality	
			TracerData.ToonPanel["Window"]["Inventory"..i]["Texture2"]:SetTexture(nil);	
			--Ilvl Text
			TracerData.ToonPanel["Window"]["Inventory"..i]["Title"]:SetText(nil);				
			--Tooltip
			TracerData.ToonPanel["Window"]["Inventory"..i]:SetScript("OnEnter", function() end);
			--Gem
			TracerData.ToonPanel["Window"]["InventorySocket"..i]:Hide();
			--Enchant
			TracerData.ToonPanel["Window"]["InventoryEnchant"..i]:Hide();
		end
	end
end

function TracerData.Function:ToonNodesDisplay(toonnumber, ButtonNumSpe)
	--Table pour les frames pour l'arbre de talent : réinitialisation
	for key, value in pairs(TracerData.ToonPanel["Window"]["Node"]) do
		TracerData.ToonPanel["Window"]["Node"][key]:Hide();
	end
	--Recherche des infos du Toons dans la database
	local data = {};
	for key, value in pairs(TracerDB.Toons) do
		if value.Order == toonnumber then
			data = value;
		end
	end
	
	--On cherche le numéro de l'arbre de talent (si utilisation des boutons de modif de spé)
	if ButtonNumSpe ~= 0 then
		ButtonNumSpe = Speid[ButtonNumSpe];
	else
		ButtonNumSpe = data.Specialization.id;
	end

	--Arbre de Talent
	local Xoffset, Yoffset = 0, 0;
	--Guerrier (1)
	if data.ClassId == 1 then
		for key, value in  pairs(data.ConfigsInfos[ButtonNumSpe][1]["nodes"])do
			--Kill des précédentes frames si jamais ???
			if TracerData.ToonPanel["Window"]["Node"][value.ID] then
				TracerData.ToonPanel["Window"]["Node"][value.ID] = nil;
			end
			--Réglage des positions
				--Coordonnées de base
				Xoffset = value.posX
				Yoffset = value.posY
				--Ajustement pour rapprocher les deux arbres
				if Xoffset > 7000 then
					Xoffset = Xoffset - 2500;
				end	
				--Placement final
				Xoffset = Xoffset/14;			
				Yoffset = -Yoffset/14+50;	
			--Création de la frame
			TracerData.ToonPanel["Window"]["Node"][value.ID] = TracerData.Function:CreateFrameOne("TonPanelNodes"..key, TracerData.ToonPanel["Window"], TracerData.ToonPanel["Window"], 25, 25, "TOPLEFT", "TOPLEFT", Xoffset, Yoffset, 1, 0, 0, 1, "CENTER", "CENTER", 0, 0, value.ID)
			TracerData.ToonPanel["Window"]["Node"][value.ID]:SetFrameStrata("FULLSCREEN");
			--Affichage
			if (value.posX == 0) and (value.posY == 0) then
				TracerData.ToonPanel["Window"]["Node"][value.ID]:Hide();
			else
				TracerData.ToonPanel["Window"]["Node"][value.ID]:Show();
			end
		end
	end
	--Paladin (2)
	if data.ClassId == 2 then
		for key, value in  pairs(data.ConfigsInfos[ButtonNumSpe][1]["nodes"])do
			--Kill des précédentes frames si jamais ???
			if TracerData.ToonPanel["Window"]["Node"][value.ID] then
				TracerData.ToonPanel["Window"]["Node"][value.ID] = nil;
			end
			--Réglage des positions
				--Coordonnées de base
				Xoffset = value.posX
				Yoffset = value.posY
				--Ajustement pour rapprocher les deux arbres
				if Xoffset > 7000 then
					Xoffset = Xoffset - 2500;
				end	
				--Placement final
				Xoffset = (Xoffset - 500)/14;			
				Yoffset = -Yoffset/14+50;	
			--Création de la frame
			TracerData.ToonPanel["Window"]["Node"][value.ID] = TracerData.Function:CreateFrameOne("TonPanelNodes"..key, TracerData.ToonPanel["Window"], TracerData.ToonPanel["Window"], 25, 25, "TOPLEFT", "TOPLEFT", Xoffset, Yoffset, 1, 0, 0, 1, "CENTER", "CENTER", 0, 0, value.ID)
			TracerData.ToonPanel["Window"]["Node"][value.ID]:SetFrameStrata("FULLSCREEN");
			--Affichage
			if (value.posX == 0) and (value.posY == 0) then
				TracerData.ToonPanel["Window"]["Node"][value.ID]:Hide();
			else
				TracerData.ToonPanel["Window"]["Node"][value.ID]:Show();
			end
		end
	end
	--Chasseur (3)
	if data.ClassId == 3 then
		for key, value in  pairs(data.ConfigsInfos[ButtonNumSpe][1]["nodes"])do
			--Kill des précédentes frames si jamais ???
			if TracerData.ToonPanel["Window"]["Node"][value.ID] then
				TracerData.ToonPanel["Window"]["Node"][value.ID] = nil;
			end
			--Réglage des positions
				--Coordonnées de base
				Xoffset = value.posX
				Yoffset = value.posY
				--Ajustement pour rapprocher les deux arbres
				if Xoffset > 7000 then
					Xoffset = Xoffset - 2500;
				end	
				--Placement final
				Xoffset = Xoffset/14;			
				Yoffset = -Yoffset/14+50;	
			--Création de la frame
			TracerData.ToonPanel["Window"]["Node"][value.ID] = TracerData.Function:CreateFrameOne("TonPanelNodes"..key, TracerData.ToonPanel["Window"], TracerData.ToonPanel["Window"], 25, 25, "TOPLEFT", "TOPLEFT", Xoffset, Yoffset, 1, 0, 0, 1, "CENTER", "CENTER", 0, 0, value.ID)
			TracerData.ToonPanel["Window"]["Node"][value.ID]:SetFrameStrata("FULLSCREEN");
			--Affichage
			if (value.posX == 0) and (value.posY == 0) then
				TracerData.ToonPanel["Window"]["Node"][value.ID]:Hide();
			else
				TracerData.ToonPanel["Window"]["Node"][value.ID]:Show();
			end
		end
	end
	--Voleur (4)
	if data.ClassId == 4 then
		for key, value in  pairs(data.ConfigsInfos[ButtonNumSpe][1]["nodes"])do
			--Kill des précédentes frames si jamais ???
			if TracerData.ToonPanel["Window"]["Node"][value.ID] then
				TracerData.ToonPanel["Window"]["Node"][value.ID] = nil;
			end
			--Réglage des positions
				--Coordonnées de base
				Xoffset = value.posX
				Yoffset = value.posY
				--Ajustement pour rapprocher les deux arbres
				if Xoffset > 7000 then
					Xoffset = Xoffset - 2500;
				end	
				--Placement final
				Xoffset = Xoffset/14;			
				Yoffset = -Yoffset/14+50;	
			--Création de la frame
			TracerData.ToonPanel["Window"]["Node"][value.ID] = TracerData.Function:CreateFrameOne("TonPanelNodes"..key, TracerData.ToonPanel["Window"], TracerData.ToonPanel["Window"], 25, 25, "TOPLEFT", "TOPLEFT", Xoffset, Yoffset, 1, 0, 0, 1, "CENTER", "CENTER", 0, 0, value.ID)
			TracerData.ToonPanel["Window"]["Node"][value.ID]:SetFrameStrata("FULLSCREEN");
			--Affichage
			if (value.posX == 0) and (value.posY == 0) then
				TracerData.ToonPanel["Window"]["Node"][value.ID]:Hide();
			else
				TracerData.ToonPanel["Window"]["Node"][value.ID]:Show();
			end
		end
	end
	--Prêtre (5)
	if data.ClassId == 5 then
		for key, value in  pairs(data.ConfigsInfos[ButtonNumSpe][1]["nodes"])do
			--Kill des précédentes frames si jamais ???
			if TracerData.ToonPanel["Window"]["Node"][value.ID] then
				TracerData.ToonPanel["Window"]["Node"][value.ID] = nil;
			end
			--Réglage des positions
				--Coordonnées de base
				Xoffset = value.posX
				Yoffset = value.posY
				--Ajustement pour rapprocher les deux arbres
				if Xoffset > 7000 then
					Xoffset = Xoffset - 2500;
				end	
				--Placement final
				Xoffset = Xoffset/14;			
				Yoffset = -Yoffset/14+50;	
			--Création de la frame
			TracerData.ToonPanel["Window"]["Node"][value.ID] = TracerData.Function:CreateFrameOne("TonPanelNodes"..key, TracerData.ToonPanel["Window"], TracerData.ToonPanel["Window"], 25, 25, "TOPLEFT", "TOPLEFT", Xoffset, Yoffset, 1, 0, 0, 1, "CENTER", "CENTER", 0, 0, value.ID)
			TracerData.ToonPanel["Window"]["Node"][value.ID]:SetFrameStrata("FULLSCREEN");
			--Affichage
			if (value.posX == 0) and (value.posY == 0) then
				TracerData.ToonPanel["Window"]["Node"][value.ID]:Hide();
			else
				TracerData.ToonPanel["Window"]["Node"][value.ID]:Show();
			end
		end
	end	
	--DK (6)
	if data.ClassId == 6 then
		for key, value in  pairs(data.ConfigsInfos[ButtonNumSpe][1]["nodes"])do
			--Kill des précédentes frames si jamais ???
			if TracerData.ToonPanel["Window"]["Node"][value.ID] then
				TracerData.ToonPanel["Window"]["Node"][value.ID] = nil;
			end
			--Réglage des positions
				--Coordonnées de base
				Xoffset = value.posX
				Yoffset = value.posY
				--Ajustement pour rapprocher les deux arbres
				if Xoffset > 7000 then
					Xoffset = Xoffset - 2500;
				end	
				--Placement final
				Xoffset = Xoffset/14;			
				Yoffset = -Yoffset/14+50;	
			--Création de la frame
			TracerData.ToonPanel["Window"]["Node"][value.ID] = TracerData.Function:CreateFrameOne("TonPanelNodes"..key, TracerData.ToonPanel["Window"], TracerData.ToonPanel["Window"], 25, 25, "TOPLEFT", "TOPLEFT", Xoffset, Yoffset, 1, 0, 0, 1, "CENTER", "CENTER", 0, 0, value.ID)
			TracerData.ToonPanel["Window"]["Node"][value.ID]:SetFrameStrata("FULLSCREEN");
			--Affichage
			if (value.posX == 0) and (value.posY == 0) then
				TracerData.ToonPanel["Window"]["Node"][value.ID]:Hide();
			else
				TracerData.ToonPanel["Window"]["Node"][value.ID]:Show();
			end
		end
	end	
	--Chaman (7)
	if data.ClassId == 7 then
		for key, value in  pairs(data.ConfigsInfos[ButtonNumSpe][1]["nodes"])do
			--Kill des précédentes frames si jamais ???
			if TracerData.ToonPanel["Window"]["Node"][value.ID] then
				TracerData.ToonPanel["Window"]["Node"][value.ID] = nil;
			end
			--Réglage des positions
				--Coordonnées de base
				Xoffset = value.posX
				Yoffset = value.posY
				--Ajustement pour rapprocher les deux arbres
				if Xoffset > 7000 then
					Xoffset = Xoffset - 2500;
				end	
				--Placement final
				Xoffset = Xoffset/14+50;			
				Yoffset = -Yoffset/14+50;	
			--Création de la frame
			TracerData.ToonPanel["Window"]["Node"][value.ID] = TracerData.Function:CreateFrameOne("TonPanelNodes"..key, TracerData.ToonPanel["Window"], TracerData.ToonPanel["Window"], 25, 25, "TOPLEFT", "TOPLEFT", Xoffset, Yoffset, 1, 0, 0, 1, "CENTER", "CENTER", 0, 0, value.ID)
			TracerData.ToonPanel["Window"]["Node"][value.ID]:SetFrameStrata("FULLSCREEN");
			--Affichage
			if (value.posX == 0) and (value.posY == 0) then
				TracerData.ToonPanel["Window"]["Node"][value.ID]:Hide();
			else
				TracerData.ToonPanel["Window"]["Node"][value.ID]:Show();
			end
		end
	end
	--Mage (8)
	if data.ClassId == 8 then
		for key, value in  pairs(data.ConfigsInfos[ButtonNumSpe][1]["nodes"])do
			--Kill des précédentes frames si jamais ???
			if TracerData.ToonPanel["Window"]["Node"][value.ID] then
				TracerData.ToonPanel["Window"]["Node"][value.ID] = nil;
			end
			--Réglage des positions
				--Coordonnées de base
				Xoffset = value.posX
				Yoffset = value.posY
				--Ajustement pour rapprocher les deux arbres
				if Xoffset > 7000 then
					Xoffset = Xoffset - 2500;
				end	
				--Placement final
				Xoffset = Xoffset/14;			
				Yoffset = -Yoffset/14+50;	
			--Création de la frame
			TracerData.ToonPanel["Window"]["Node"][value.ID] = TracerData.Function:CreateFrameOne("TonPanelNodes"..key, TracerData.ToonPanel["Window"], TracerData.ToonPanel["Window"], 25, 25, "TOPLEFT", "TOPLEFT", Xoffset, Yoffset, 1, 0, 0, 1, "CENTER", "CENTER", 0, 0, value.ID)
			TracerData.ToonPanel["Window"]["Node"][value.ID]:SetFrameStrata("FULLSCREEN");
			--Affichage
			if (value.posX == 0) and (value.posY == 0) then
				TracerData.ToonPanel["Window"]["Node"][value.ID]:Hide();
			else
				TracerData.ToonPanel["Window"]["Node"][value.ID]:Show();
			end
		end
	end	
	--Démoniste (9)
	if data.ClassId == 9 then
		for key, value in  pairs(data.ConfigsInfos[ButtonNumSpe][1]["nodes"])do
			--Kill des précédentes frames si jamais ???
			if TracerData.ToonPanel["Window"]["Node"][value.ID] then
				TracerData.ToonPanel["Window"]["Node"][value.ID] = nil;
			end
			--Réglage des positions
				--Coordonnées de base
				Xoffset = value.posX
				Yoffset = value.posY
				--Ajustement pour rapprocher les deux arbres
				if Xoffset > 7000 then
					Xoffset = Xoffset - 2500;
				end	
				--Placement final
				Xoffset = Xoffset/14;			
				Yoffset = -Yoffset/14+50;	
			--Création de la frame
			TracerData.ToonPanel["Window"]["Node"][value.ID] = TracerData.Function:CreateFrameOne("TonPanelNodes"..key, TracerData.ToonPanel["Window"], TracerData.ToonPanel["Window"], 25, 25, "TOPLEFT", "TOPLEFT", Xoffset, Yoffset, 1, 0, 0, 1, "CENTER", "CENTER", 0, 0, value.ID)
			TracerData.ToonPanel["Window"]["Node"][value.ID]:SetFrameStrata("FULLSCREEN");
			--Affichage
			if (value.posX == 0) and (value.posY == 0) then
				TracerData.ToonPanel["Window"]["Node"][value.ID]:Hide();
			else
				TracerData.ToonPanel["Window"]["Node"][value.ID]:Show();
			end
		end
	end	
	--Moine (10)
	if data.ClassId == 10 then
		for key, value in  pairs(data.ConfigsInfos[ButtonNumSpe][1]["nodes"])do
			--Kill des précédentes frames si jamais ???
			if TracerData.ToonPanel["Window"]["Node"][value.ID] then
				TracerData.ToonPanel["Window"]["Node"][value.ID] = nil;
			end
			--Réglage des positions
				--Coordonnées de base
				Xoffset = value.posX
				Yoffset = value.posY
				--Ajustement pour rapprocher les deux arbres
				if Xoffset > 7000 then
					Xoffset = Xoffset - 2500;
				end	
				--Placement final
				Xoffset = Xoffset/14;			
				Yoffset = -Yoffset/14+50;	
			--Création de la frame
			TracerData.ToonPanel["Window"]["Node"][value.ID] = TracerData.Function:CreateFrameOne("TonPanelNodes"..key, TracerData.ToonPanel["Window"], TracerData.ToonPanel["Window"], 25, 25, "TOPLEFT", "TOPLEFT", Xoffset, Yoffset, 1, 0, 0, 1, "CENTER", "CENTER", 0, 0, value.ID)
			TracerData.ToonPanel["Window"]["Node"][value.ID]:SetFrameStrata("FULLSCREEN");
			--Affichage
			if (value.posX == 0) and (value.posY == 0) then
				TracerData.ToonPanel["Window"]["Node"][value.ID]:Hide();
			else
				TracerData.ToonPanel["Window"]["Node"][value.ID]:Show();
			end
		end
	end	
	--Druide (11)
	if data.ClassId == 11 then
		for key, value in  pairs(data.ConfigsInfos[ButtonNumSpe][1]["nodes"])do
			--Kill des précédentes frames si jamais ???
			if TracerData.ToonPanel["Window"]["Node"][value.ID] then
				TracerData.ToonPanel["Window"]["Node"][value.ID] = nil;
			end
			--Réglage des positions
				--Coordonnées de base
				Xoffset = value.posX
				Yoffset = value.posY
				--Ajustement pour rapprocher les deux arbres
				if Xoffset > 7000 then
					Xoffset = Xoffset - 2500;
				end	
				--Placement final
				Xoffset = Xoffset/14+50;			
				Yoffset = -Yoffset/14+50;	
			--Création de la frame
			TracerData.ToonPanel["Window"]["Node"][value.ID] = TracerData.Function:CreateFrameOne("TonPanelNodes"..key, TracerData.ToonPanel["Window"], TracerData.ToonPanel["Window"], 25, 25, "TOPLEFT", "TOPLEFT", Xoffset, Yoffset, 1, 0, 0, 1, "CENTER", "CENTER", 0, 0, value.ID)
			TracerData.ToonPanel["Window"]["Node"][value.ID]:SetFrameStrata("FULLSCREEN");
			--Affichage
			if (value.posX == 0) and (value.posY == 0) then
				TracerData.ToonPanel["Window"]["Node"][value.ID]:Hide();
			else
				TracerData.ToonPanel["Window"]["Node"][value.ID]:Show();
			end
		end
	end	
	--DH (12)
	if data.ClassId == 12 then
		for key, value in  pairs(data.ConfigsInfos[ButtonNumSpe][1]["nodes"])do
			--Kill des précédentes frames si jamais ???
			if TracerData.ToonPanel["Window"]["Node"][value.ID] then
				TracerData.ToonPanel["Window"]["Node"][value.ID] = nil;
			end
			--Réglage des positions
				--Coordonnées de base
				Xoffset = value.posX
				Yoffset = value.posY
				--Ajustement pour rapprocher les deux arbres
				if Xoffset > 7000 then
					Xoffset = Xoffset - 2500;
				end	
				--Placement final
				Xoffset = Xoffset/14;			
				Yoffset = -Yoffset/14+50;	
			--Création de la frame
			TracerData.ToonPanel["Window"]["Node"][value.ID] = TracerData.Function:CreateFrameOne("TonPanelNodes"..key, TracerData.ToonPanel["Window"], TracerData.ToonPanel["Window"], 25, 25, "TOPLEFT", "TOPLEFT", Xoffset, Yoffset, 1, 0, 0, 1, "CENTER", "CENTER", 0, 0, value.ID)
			TracerData.ToonPanel["Window"]["Node"][value.ID]:SetFrameStrata("FULLSCREEN");
			--Affichage
			if (value.posX == 0) and (value.posY == 0) then
				TracerData.ToonPanel["Window"]["Node"][value.ID]:Hide();
			else
				TracerData.ToonPanel["Window"]["Node"][value.ID]:Show();
			end
		end
	end
	--Evoker (13)
	if data.ClassId == 13 then
		for key, value in  pairs(data.ConfigsInfos[ButtonNumSpe][1]["nodes"])do
			--Kill des précédentes frames si jamais ???
			if TracerData.ToonPanel["Window"]["Node"][value.ID] then
				TracerData.ToonPanel["Window"]["Node"][value.ID] = nil;
			end
			--Réglage des positions
				--Coordonnées de base
				Xoffset = value.posX
				Yoffset = value.posY
				--Ajustement pour rapprocher les deux arbres
				if Xoffset > 7000 then
					Xoffset = Xoffset - 2500;
				end	
				--Placement final
				Xoffset = Xoffset/14;			
				Yoffset = -Yoffset/14+50;	
			--Création de la frame
			TracerData.ToonPanel["Window"]["Node"][value.ID] = TracerData.Function:CreateFrameOne("TonPanelNodes"..key, TracerData.ToonPanel["Window"], TracerData.ToonPanel["Window"], 25, 25, "TOPLEFT", "TOPLEFT", Xoffset, Yoffset, 1, 0, 0, 1, "CENTER", "CENTER", 0, 0, value.ID)
			TracerData.ToonPanel["Window"]["Node"][value.ID]:SetFrameStrata("FULLSCREEN");
			--Affichage
			if (value.posX == 0) and (value.posY == 0) then
				TracerData.ToonPanel["Window"]["Node"][value.ID]:Hide();
			else
				TracerData.ToonPanel["Window"]["Node"][value.ID]:Show();
			end
		end
	end
end